/*  $Id: vplatfrm.hhh,v 1.17.1.1 1995/01/24 15:07:31 cway Stab $
 *
 *  C Preprocessor Definitions for use in #if statements,
 *  which are used in embedded non-portable code.
 *
 *  Copyright (c) 1993, 1994 by Viewlogic Systems, Inc.
 */

#ifndef vlPLATFORM_H
#define vlPLATFORM_H

/* Hardware definitions --------------------------------------------------- */

#define vlHW_ALPHA    0     /* Alpha axp                             */
#define vlHW_APOLLO   0     /* not used                              */
#define vlHW_ELXSI    0     /* not used                              */
#define vlHW_HP9000   0     /* hp9000                                */
#define vlHW_HP9K700  0     /* hp9k700                               */
#define vlHW_IBMRT    0     /* RT                                    */
#define vlHW_INTEL386 0     /* pcunix                                */
#define vlHW_NECPC    0     /* NEC PC                                */
#define vlHW_PC       0     /* all PC                                */
#define vlHW_PMAX     0     /* DECStation (pmax)                     */
#define vlHW_PS2      0     /* IBM PS/2                              */
#define vlHW_RIOS     0     /* IBM RS/6000 (rios)                    */
#define vlHW_SUN      1     /* sun3 sun4 sun386i                     */
#define vlHW_SUN3     0     /* sun3                                  */
#define vlHW_SUN386   0     /* sun386i                               */
#define vlHW_SUN4     1     /* sun4                                  */
#define vlHW_TOWER    0     /* not used                              */
#define vlHW_VAX      0     /* vax                                   */

/* Compiler definitions --------------------------------------------------- */

#ifndef vlCOMP_PROTO
#define vlCOMP_PROTO  1     /* Compiler allows function prototypes   */
#endif

#define vlCOMP_AC     0     /* Sun ANSI C (SC2.0.1) for SunOS 4 (acc only) */
#define vlCOMP_BC     0     /* Borland Turbo C                       */
#define vlCOMP_GC     1     /* Gnu C (gcc)                           */
#define vlCOMP_GCPLPL 0     /* g++, C++ */
#define vlCOMP_HC     0     /* High C                                */
#define vlCOMP_LC     0     /* Lattice C                             */
#define vlCOMP_MC     0     /* Microsoft C                           */
#define vlCOMP_UC     0     /* Unix C (vendor supplied cc)           */
#define vlCOMP_VC     0     /* VAX C                                 */
#define vlCOMP_WC     0     /* Watcom C                              */
#define vlCOMP_ZC     0     /* Zortech C                             */

/* Operating Systems ------------------------------------------------------ */

/* Generic Standard OS definitions
 *
 * Use these wherever possible, in place of naming a specific OS.
 * That is, use vlOS_SYSVR4 instead of vlOS_SOLARIS, if possible.
 */

#define vlOS_DOS      0     /* any DOS (PCDOS 286 386 WINDOWS BIGWIN !NT)   */
#define vlOS_UNIX     1     /* Unix-like, either BSD or SYSV                */
#define vlOS_SYSV     0     /* ATT SYSV compliant                           */
#define vlOS_SYSVR3   0     /* not used                                     */
#define vlOS_SYSVR4   0     /* ATT SYSVR4 compliant                         */

/* PC- and Windows-related OS definitions */

#define vlOS_PCDOS    0     /* DOS for 086                                  */
#define vlOS_286      0     /* DOS for the 286                              */
#define vlOS_386      0     /* DOS for the 386                              */
#define vlOS_BIGWIN   0     /* Rational's BigWin for Windows 3.x            */
#define vlOS_WINDOWS  0     /* Windows OS-related differences               */

#define vlOS_NT       0     /* MS Windows NT                                */
#define vlOS_OS2      0     /* IBM OS/2                                     */
#define vlOS_WIN32    0     /* any platform using win32 or win32s API's     */

#define vlOS_OSF      0     /* OSF                                          */
#define vlOS_PCUNIX   0     /* Unix for x86                                 */
#define vlOS_SUNOS3   0     /* SunOS 3.x                                    */
#define vlOS_SUNOS4   1     /* SunOS 4.x                                    */
#define vlOS_SOLARIS  0     /* SunOS 5.x -- use vlOS_SYSVR4 if possible     */
#define vlOS_LINUX    0     /* Linux                                        */
#define vlOS_VMS      0     /* DEC VMS                                      */

#define vlOS_AIX      0     /* IBM AIX                                      */
#define vlOS_AIX30    0     /* IBM AIX 3                                    */
#define vlOS_HPUX     0     /* HP-UX                                        */
#define vlOS_ULTRIX   0     /* DEC Ultrix                                   */
#define vlOS_AEGIS    0     /* not used                                     */
#define vlOS_XENIX    0     /* not used                                     */

/* Compilation environment ------------------------------------------------ */

#define vlENV_WV      0     /* workview and facilities               */
#define vlENV_SALONE  1     /* standalones                           */
#define vlENV_DVIEW   0     /* not used                              */
#define vlENV_GTEST   0     /* graphics test program (pre-5.0)       */
#ifndef vlENV_DEBUG
#define vlENV_DEBUG   0     /* compile in debugging code             */
#endif

/* Graphics environment --------------------------------------------------- */

#define vlGRAF_CURSES     0 /* Curses                                */
#define vlGRAF_METAWINDOW 0 /* Metawindow                            */
#define vlGRAF_MOTIF      0 /* Motif toolkit                         */
#define vlGRAF_MSWINDOWS  0 /* Microsoft windows                     */
#define vlGRAF_OLIT       0 /* Openlook toolkit (OLIT)               */
#define vlGRAF_SUNVIEW    0 /* Sunview                               */
#define vlGRAF_UIS        0 /* DEC UIS for VMS                       */
#define vlGRAF_WFD        0 /* Windows for data                      */
#define vlGRAF_X          1 /* X windows                             */
#define vlGRAF_XT         1 /* X toolkit intrinsics                  */
#define vlGRAF_XVIEW      0 /* XView toolkit                         */

#endif /* vlPLATFORM_H */
