/*
 * This viewscript load script works both from from the vload command
 * line and from a tef file with (property exec "VSCRIPT").  It checks
 * to make sure we're running with Core at 5.2 or greater.  If not, it
 * runs vload via a system command, to get the up-to-date core.
 */

if (isbound (`CompatibleVersion, vcWv)) {
    vcWv.RequireFac (wv, "vansetup");
    if (string_eq (vcWin.ProgramName, "vload"))
        vcWin.SetProgramName ("VHDL Library Manager");
    vcWin.Create (vcRegion.Create ("vsslib.ini", vansetup.fac, "vsslib.ini"));
} /* if */
else if (isbound (`vframe, nil)) {
    err_output := "";
    function exit_proc(mode, code) {
        if ((mode != vcSysMode.Exited) || (code != 0))
            error ("Unable to invoke vload to run vantage setup: \n" +
                   err_output,
                   nil);
    } /* function exit_proc */
    vcWin.System (nil, "vload rvansetp", nil, FALSE, nil,
                  func(s) err_output += s;, exit_proc, nil, nil);
} /* else if */
else
    error ("Cannot run vantage setup from version 5.1 -- must use 5.2", nil);
