/* This file contains the menu definitions for ViewFPGA */

pldonly  := vlPref.Val (prefs, "pldonly");


/* File menu */
if (pldonly)
   m_main_file := vcWv.MakeMenu ("m_main_file",
      list ("Specify schematic", c_file_sch),
      list ("Specify ABEL", c_file_abel),
      list ("Specify JEDEC", c_file_jed),
      list ("Edit selected file", c_file_edit));
else
   m_main_file := vcWv.MakeMenu ("m_main_file",
      list ("Specify schematic", c_file_sch),
      list ("Specify VHDL", c_file_vhdl),
      list ("Specify ABEL", c_file_abel),
      list ("Specify JEDEC", c_file_jed),
      list ("Edit selected file", c_file_edit));


/* Create menu */
if (pldonly)
   m_main_create := vcWv.MakeMenu  ("m_main_create",
      list ("Symbol...", c_cre_sym),
      list ("Functional model", c_cre_func),
      list ("PLD partitioning schematic", c_cre_part),
      list ("PLD JEDEC", c_cre_jedec),
      list ("PLD JEDEC and timing model", c_cre_timing));
else
   m_main_create := vcWv.MakeMenu  ("m_main_create",
      list ("Symbol...", c_cre_sym),
      list ("Functional model", c_cre_func),
      list ("FPGA WIR file", c_cre_fpga),
      list ("PLD partitioning schematic", c_cre_part),
      list ("PLD JEDEC", c_cre_jedec),
      list ("PLD JEDEC and timing model", c_cre_timing));


/* Option menu */
if (pldonly)
   m_main_options := vcWv.MakeMenu  ("m_main_options",
      list ("User Interface", c_opt_ui),
      list ("ABEL compiler", c_opt_ahdl2pla),
      list ("PLA optimizer", c_opt_plaopt),
      list ("PLD partitioner", c_opt_part),
      list ("Fitter (pin assignment)", c_opt_fit),
      list ("PLD device selector", c_opt_devsel),
      list ("JEDEC writer", c_opt_fuseasm),
      list ("PLD timing modeller", c_opt_j2vhdl));
else {
   m_opt_pld := vcWv.MakeMenu  ("m_opt_pld",
      list ("PLA optimizer", c_opt_plaopt),
      list ("PLD partitioner", c_opt_part),
      list ("Fitter (pin assignment)", c_opt_fit),
      list ("PLD device selector", c_opt_devsel),
      list ("JEDEC writer", c_opt_fuseasm),
      list ("PLD timing modeller", c_opt_j2vhdl));
   m_main_options := vcWv.MakeMenu  ("m_main_options",
      list ("User Interface", c_opt_ui),
      list ("ABEL compiler", c_opt_ahdl2pla),
      list ("VHDL analyzer", c_opt_vhdl),
      list ("FPGA synthesizer", c_opt_vdes),
      list ("PLD tools", m_opt_pld)); }


/* Utility menu */
if (pldonly)
   m_main_utility := vcWv.MakeMenu  ("m_main_utility",
      list ("Copy tutorial files", c_util_diotut),
      list ("Create logical schematic", c_util_diosch),
      list ("Show PLD pinouts", c_util_pldpins),
      list ("Programmer window", c_util_burndev),
      list ("Delete intermediate files", c_util_delint));
else {
   m_util_tutor := vcWv.MakeMenu ("m_util_tutor",
      list ("PLD", c_util_diotut),
      list ("Xilinx 3000", c_util_x3tut),
      list ("Actel Act-2", c_util_act2tut));
   m_main_utility := vcWv.MakeMenu  ("m_main_utility",
      list ("Copy tutorial files", m_util_tutor),
      list ("Create logical schematic", c_util_diosch),
      list ("Show PLD pinouts", c_util_pldpins),
      list ("Programmer window", c_util_burndev),
      list ("Delete intermediate files", c_util_delint)); }


/* Main menu */
vcFac.SetMenus (fac, vcWv.MakeMenu  ("m_main",
   vcWin.RedSquareEntry,
   list ("File", m_main_file),
   list ("Create", m_main_create),
   list ("Options", m_main_options),
   list ("Utilities", m_main_utility)));
