/* ------------------------------------------------------------------------ *\
 * $Id: viewpart.vs,v 1.4 93/10/28 18:18:31 pras Stab $
 * Primary partitioner viewscript file.
 *
 * Earliest versions derived from UI prototype's edition of this file,
 * with funky UI features removed and various organizational dodads
 * cleaned up (like removing all global variables). (bob d)
 *
 * Copyright (c) 1992 by Viewlogic Systems, Inc.
 * ---- change log ommitted ----
\* ------------------------------------------------------------------------ */

/****************************
  Define the strings that are being used for labels throughout the
  Viewscript code.
****************************/
DefStrComps := "Components: ";
DefStrRegs := "Registers: ";
DefStrPins := "Pins: ";
DefStrClkPins := "Clock Pins: ";
DefStrDesignName := "Design Name: ";
DefStrPackage := "Package: ";
DefStrTechnology := "Technology: ";
DefStrCapacity := "Capacity";
DefStrUtil := "Utilizations";
DefStrAvail := "Available";
DefStrTimes := "X ";
DefStrEqual := "= ";
DefStrNumParts := "No. Of Partitions";
DefStrOptParts := "Optimal Partitions: ";
DefStrCurrent := "Current: ";
DefStrUserGoal := "User Goal: ";
DefStrThresh := "Thresholds";
DefStrNetThresh := "System Net: ";
DefStrAutoGroup := "Auto Group: ";
DefStrUserTech := "User Tech. File: ";

/*
vcWv.interrupts(vcTxShell.fac,
                '\e', '\^C', '\_\^C',
                '\pgup', '\pgdn', '\home', '\end', '\up', '\down');
*/
vcWv.interrupts(fac, '\^C');

/* This is the name used to write the ini file from the Preference Editor.
 * Now this automatically tracks the facility name, as it should.
 */
IniFileName := vcFac.Name(fac) + ".ini";

/** 
  This function will clear the static Region passed to it and
  it will add the new text to the region.
**/
function UpdateStaticText(s_region, newText)
{

   vcStaticText.Clear(s_region);
   vcStaticText.Add(s_region, newText);

} /* End of UpdateStaticText */

/**
  Creates the Status table where the information about the design and
  selected device is displayed for the user.
**/
function CreateStatTable()
{
   LabelDesign := vcRegion.Create("LDesign", vcLabel.fac, DefStrDesignName);
   StaticDesign := vcRegion.Create("SDesign", vcStaticText.fac, "", 
                                   width <- 10);
   vcRegion.Font(StaticDesign, vgFont.smallb);


   LabelDevice := vcRegion.Create("LDev", vcLabel.fac, DefStrPackage);
   StaticDevice := vcRegion.Create("SDev", vcStaticText.fac, "",
                                   width <- 8);
   vcRegion.Font(StaticDevice, vgFont.smallb);

   LabelComp := vcRegion.Create("LComp", vcLabel.fac, DefStrComps);
   LabelReg := vcRegion.Create("LReg", vcLabel.fac, DefStrRegs);
   LabelPin := vcRegion.Create("LPin", vcLabel.fac, DefStrPins);

   LabelComp1 := vcRegion.Create("LComp1", vcLabel.fac, DefStrComps);
   LabelReg1 := vcRegion.Create("LReg1", vcLabel.fac, DefStrRegs);
   LabelPin1 := vcRegion.Create("LPins1", vcLabel.fac, DefStrPins);

   LabelUserTech := vcRegion.Create("LUserTech", vcLabel.fac, DefStrUserTech);

   /* Status of the Design */
   StaticCompDes := vcRegion.Create("SCompDes", vcStaticText.fac, "",
                                  width <- 6);
   vcRegion.Font(StaticCompDes, vgFont.smallb);

   StaticRegDes := vcRegion.Create("SRegDes", vcStaticText.fac, "",
                                 width <- 6);
   vcRegion.Font(StaticRegDes, vgFont.smallb);
   
   StaticPinsDes := vcRegion.Create("SPinsDes", vcStaticText.fac, "",
                                  width <- 6);
   vcRegion.Font(StaticPinsDes, vgFont.smallb);

   /* Status of the Device */
   LabelTot := vcRegion.Create("LTot", vcLabel.fac, DefStrCapacity);
   vcRegion.Font(LabelTot, vgFont.smalli);

   StaticCompDev := vcRegion.Create("SCompDev", vcStaticText.fac, "",
                                  width <- 6);
   vcRegion.Font(StaticCompDev, vgFont.smallb);

   StaticRegDev := vcRegion.Create("SRegDev", vcStaticText.fac, "",
                                 width <- 6);
   vcRegion.Font(StaticRegDev, vgFont.smallb);

   StaticPinsDev := vcRegion.Create("SPinsDev", vcStaticText.fac, "",
                                  width <- 6);
   vcRegion.Font(StaticPinsDev, vgFont.smallb);


   StaticUserTech := vcRegion.Create("SUserTech", vcStaticText.fac, "",
                                     width <- 6);
   vcRegion.Font(StaticUserTech, vgFont.smallb);
   

   /* Create the Utilization Column */
   LabelUtil := vcRegion.Create("LUtil", vcLabel.fac, DefStrUtil);
   vcRegion.Font(LabelUtil, vgFont.smalli);

   StaticCompUtil := vcRegion.Create("SCompUtil", vcStaticText.fac, "",
                                  width <- 6);
   vcRegion.Font(StaticCompUtil, vgFont.smallb);

   StaticRegUtil := vcRegion.Create("SRegUtil", vcStaticText.fac, "",
                                 width <- 6);
   vcRegion.Font(StaticRegUtil, vgFont.smallb);

   StaticPinsUtil := vcRegion.Create("SPinsUtil", vcStaticText.fac, "",
                                  width <- 6);
   vcRegion.Font(StaticPinsUtil, vgFont.smallb);


   /* Create the Available Chart */
   LabelAvail := vcRegion.Create("LAvail", vcLabel.fac, DefStrAvail);
   vcRegion.Font(LabelAvail, vgFont.smalli);

   StaticCompAvail := vcRegion.Create("SCompAvail", vcStaticText.fac, "",
                                  width <- 3);
   vcRegion.Font(StaticCompAvail, vgFont.smallb);

   StaticRegAvail := vcRegion.Create("SRegAvail", vcStaticText.fac, "",
                                 width <- 3);
   vcRegion.Font(StaticRegAvail, vgFont.smallb);

   StaticPinsAvail := vcRegion.Create("SPinsAvail", vcStaticText.fac, "",
                                  width <- 3);
   vcRegion.Font(StaticPinsAvail, vgFont.smallb);


   /** Create the Threshold status **/
   LabelThresh := vcRegion.Create("LThresh", vcLabel.fac, DefStrThresh);
   vcRegion.Font(LabelThresh, vgFont.smalli);

   LabelNet := vcRegion.Create("LNet", vcLabel.fac, DefStrNetThresh);
   StaticNet := vcRegion.Create("SNet", vcStaticText.fac, "",
                                  width <- 3);
   vcRegion.Font(StaticNet, vgFont.smallb);
   
   LabelGroup := vcRegion.Create("LGroup", vcLabel.fac, DefStrAutoGroup);
   StaticGroup := vcRegion.Create("SGroup", vcStaticText.fac, "",
                                 width <- 3);
   vcRegion.Font(StaticGroup, vgFont.smallb);

   /* Create the Technology Label */
   LabelTech := vcRegion.Create("LTech", vcLabel.fac, DefStrTechnology);
   StaticTech := vcRegion.Create("STech", vcStaticText.fac, "",
                                 width <- 3);
   vcRegion.Font(StaticTech, vgFont.smallb);

   /** Partition Information **/
   LabelPart := vcRegion.Create("Lpart", vcLabel.fac, DefStrNumParts);
   vcRegion.Font(LabelPart, vgFont.smalli);

   LabelUserPart := vcRegion.Create("LUpart", vcLabel.fac, 
                                    DefStrUserGoal);
   StaticUserPart := vcRegion.Create("SUpart", vcStaticText.fac, "",
                                     width <- 3);
   LabelOptPart := vcRegion.Create("LOpart", vcLabel.fac, 
                                   DefStrOptParts);
   StaticOptPart := vcRegion.Create("SOpart", vcStaticText.fac, "",
                                    width <- 3);
   LabelCurPart := vcRegion.Create("LCpart", vcLabel.fac, DefStrCurrent);
   StaticCurPart := vcRegion.Create("SCpart", vcStaticText.fac, "",
                                    width <- 3);

   /* Create the a status table */
   StatTable := vcTable.Create("StatusTable", 6, 8);

   row := 0;
   vcTable.Set(StatTable, row, 2, LabelDevice);
   vcTable.Set(StatTable, row, 3, StaticDevice);
   vcTable.Set(StatTable, row, 4, LabelTech);
   vcTable.Set(StatTable, row, 5, StaticTech);
   vcTable.Set(StatTable, row, 6, LabelPart);


   row = row + 1;  /* row = 1 */
   vcTable.Set(StatTable, row, 0, LabelDesign);
   vcTable.Set(StatTable, row, 1, StaticDesign);
   vcTable.Set(StatTable, row, 3, LabelTot);
   vcTable.Set(StatTable, row, 4, LabelUtil);
   vcTable.Set(StatTable, row, 5, LabelAvail);
   vcTable.Set(StatTable, row, 6, LabelCurPart);
   vcTable.Set(StatTable, row, 7, StaticCurPart);

   row = row + 1;  /* row = 2 */
   vcTable.Set(StatTable, row, 0, LabelComp);
   vcTable.Set(StatTable, row, 1, StaticCompDes);
   vcTable.Set(StatTable, row, 2, LabelComp1);
   vcTable.Set(StatTable, row, 3, StaticCompDev);
   vcTable.Set(StatTable, row, 4, StaticCompUtil);
   vcTable.Set(StatTable, row, 5, StaticCompAvail);
   vcTable.Set(StatTable, row, 6, LabelUserPart);
   vcTable.Set(StatTable, row, 7, StaticUserPart);

   row = row + 1;  /* row = 3 */
   vcTable.Set(StatTable, row, 0, LabelReg);
   vcTable.Set(StatTable, row, 1, StaticRegDes);
   vcTable.Set(StatTable, row, 2, LabelReg1);
   vcTable.Set(StatTable, row, 3, StaticRegDev);
   vcTable.Set(StatTable, row, 4, StaticRegUtil);
   vcTable.Set(StatTable, row, 5, StaticRegAvail);
   vcTable.Set(StatTable, row, 6, LabelThresh);

   row = row + 1;  /* row = 4 */
   vcTable.Set(StatTable, row, 0, LabelPin);
   vcTable.Set(StatTable, row, 1, StaticPinsDes);
   vcTable.Set(StatTable, row, 2, LabelPin1);
   vcTable.Set(StatTable, row, 3, StaticPinsDev);
   vcTable.Set(StatTable, row, 4, StaticPinsUtil);
   vcTable.Set(StatTable, row, 5, StaticPinsAvail);
   vcTable.Set(StatTable, row, 6, LabelNet);
   vcTable.Set(StatTable, row, 7, StaticNet);

   row = row + 1;  /* row = 5 */
   vcTable.Set(StatTable, row, 0, LabelOptPart);
   vcTable.Set(StatTable, row, 1, StaticOptPart);
   vcTable.Set(StatTable, row, 2, LabelUserTech);
   vcTable.Set(StatTable, row, 3, StaticUserTech);
   vcTable.Set(StatTable, row, 6, LabelGroup);
   vcTable.Set(StatTable, row, 7, StaticGroup);


   vcTable.Col(StatTable, -1, vcTable.Border.Invisible,
               1, 1, 1, vgAlign.MiddleLeft);
   
   vcTable.Col(StatTable, 6, vcTable.Border.Visible,
               4, 6, 8, vgAlign.MiddleLeft);

   vcTable.Col(StatTable, 2, vcTable.Border.Visible,
               4, 6, 8, vgAlign.MiddleLeft);

   vcTable.Row(StatTable, 7, vcTable.Border.Visible,
               1, 1, 1, vgAlign.LowerLeft);

   return(StatTable);

} /* End of Function CreateStatTable */


function _Create(designName, region)
{
   declare part;

   MainTable := vcTable.Create("MainTable", 2, 1);
   PartShell := vcRegion.Create(vcFac.Name(fac), vcTxShell.fac, "", 
                                prompt <- vcFac.Name(fac) + ">",
                                commands <- TRUE,
                                height <- 10);
   SavePartShell(PartShell);

   /* The Main WindowTable */
   StatTable := CreateStatTable();

   vcTable.Set(MainTable, 0, 0, StatTable);
   vcTable.Set(MainTable, 1, 0, PartShell);
   
   vcTable.Row(MainTable, 1, vcTable.Border.Adjustable, 1, 1, 1,
               vgAlign.MiddleCenter);
   vcRegion.AddChild(region, MainTable);

   part = ConstrPartitioner(region);
   return(part);

} /* End of function _Create */

/** Update the design status window **/
function UpdtDesMainStat(part)
{
    main_region := vcTable.Get(GetRegion(part), 0, 0);

    /* Update the design name */
    s_region := vcTable.Get(main_region, 1, 1);
    UpdateStaticText(s_region, getDesignName(part));

    s_region = vcTable.Get(main_region, 2, 1);
    UpdateStaticText(s_region, getDesignComps(part));

    s_region = vcTable.Get(main_region, 3, 1);
    UpdateStaticText(s_region, getDesignRegs(part));

    s_region = vcTable.Get(main_region, 4, 1);
    UpdateStaticText(s_region, getDesignPins(part));
    vcStaticText.Add(s_region, " (");
    vcStaticText.Add(s_region, getDesignClks(part));
    vcStaticText.Add(s_region, " Clock)");

} /* End of UpdtDesMainStat */

/** Clear the design Area **/
function ClearDesMainStat(part)
{
   main_region := vcTable.Get(GetRegion(part), 0, 0);

   /* Clear all the static text area underneath the design name */
   s_region := vcTable.Get(main_region, 1, 1);
   vcStaticText.Clear(s_region);
   
   s_region = vcTable.Get(main_region, 2, 1);
   vcStaticText.Clear(s_region);
   
   s_region = vcTable.Get(main_region, 3, 1);
   vcStaticText.Clear(s_region);
   
   s_region = vcTable.Get(main_region, 4, 1);
   vcStaticText.Clear(s_region);
   
   s_region = vcTable.Get(main_region, 5, 1);
   vcStaticText.Clear(s_region);
   
} /* End of ClearDesMainStat */

/** Update the status of Optimum partitions for the design **/
function UpdtOptPartMainStat(part, optPart)
{
   main_region := vcTable.Get(GetRegion(part), 0, 0);
   s_region := vcTable.Get(main_region, 5, 1);
   UpdateStaticText(s_region, optPart);
} /* End of UpdtOptPartMainStat */

/** Update the technology information **/
function UpdtTechMainStat(part, techname)
{
   main_region := vcTable.Get(GetRegion(part), 0, 0);
   s_region := vcTable.Get(main_region, 0, 5);
   UpdateStaticText(s_region, string_upper(techname));
   /** NYI - remember to clear out the other status information because
     it's no longer correct **/
   ClearDesMainStat(part);
   ClearPckgMainStat(part);

} /* End of UpdtTechMainStat */

/** Update the Main status Window with the Package that was selected **/
function UpdtPckgMainStat(part, pkg)
{

   main_region := vcTable.Get(GetRegion(part), 0, 0);

   /* Set the device name */
   s_region := vcTable.Get(main_region, 0, 3);
   UpdateStaticText(s_region, pkg);

   /* Set the Component Count */
   s_region = vcTable.Get(main_region, 2, 3);
   UpdateStaticText(s_region, PackageNComps(part));

   /* Set the Register Count */
   s_region = vcTable.Get(main_region, 3, 3);
   UpdateStaticText(s_region, PackageNRegs(part));

   /* Set the Pin Count */
   s_region = vcTable.Get(main_region, 4, 3);
   UpdateStaticText(s_region, PackageNPins(part));
   vcStaticText.Add(s_region, " (");
   vcStaticText.Add(s_region, PackageNClkPins(part));
   vcStaticText.Add(s_region, " Clock)");

   /* Update the available column also */
   s_region = vcTable.Get(main_region, 2, 5);
   UpdateStaticText(s_region, getCompAvailStr(part));
   
   s_region = vcTable.Get(main_region, 3, 5);
   UpdateStaticText(s_region, getRegAvailStr(part));
   
   s_region = vcTable.Get(main_region, 4, 5);
   UpdateStaticText(s_region, getPinAvailStr(part));

} /* End of UpdtPckgMainStat */

/** Clear the Package Area **/
function ClearPckgMainStat(part)
{

   main_region := vcTable.Get(GetRegion(part), 0, 0);

   /* Set the device name */
   s_region := vcTable.Get(main_region, 0, 3);
   vcStaticText.Clear(s_region);

   /* Set the Component Count */
   s_region = vcTable.Get(main_region, 2, 3);
   vcStaticText.Clear(s_region);

   /* Set the Register Count */
   s_region = vcTable.Get(main_region, 3, 3);
   vcStaticText.Clear(s_region);

   /* Set the Pin Count */
   s_region = vcTable.Get(main_region, 4, 3);
   vcStaticText.Clear(s_region);

   /* Clear out the available column also */
   s_region = vcTable.Get(main_region, 2, 5);
   vcStaticText.Clear(s_region);
   
   s_region = vcTable.Get(main_region, 3, 5);
   vcStaticText.Clear(s_region);
   
   s_region = vcTable.Get(main_region, 4, 5);
   vcStaticText.Clear(s_region);

} /* End of ClearPckgMainStat */   

/** 
  This function will update the Utilization column in the main status window
**/

function UpdtUtilMainStat(part)
{

   UpdtCompUtilMainStat(part);
   UpdtRegUtilMainStat(part);
   UpdtPinUtilMainStat(part);

} /* End of UpdtUtilMainStat */

function UpdtCompUtilMainStat(part)
{
   main_region := vcTable.Get(GetRegion(part), 0, 0);

   s_region := vcTable.Get(main_region, 2, 4);
   UpdateStaticText(s_region, getCompUtilStr(part));

   s_region = vcTable.Get(main_region, 2, 5);
   UpdateStaticText(s_region, getCompAvailStr(part));
 
} /* End of UpdtCompUtilMainStat */

function UpdtRegUtilMainStat(part)
{  
   main_region := vcTable.Get(GetRegion(part), 0, 0);

   s_region := vcTable.Get(main_region, 3, 4);
   UpdateStaticText(s_region, getRegUtilStr(part));

   s_region = vcTable.Get(main_region, 3, 5);
   UpdateStaticText(s_region, getRegAvailStr(part));
   
} /* End of UpdtRegUtilMainStat */

function UpdtPinUtilMainStat(part)
{
   main_region := vcTable.Get(GetRegion(part), 0, 0);

   s_region := vcTable.Get(main_region, 4, 4);
   UpdateStaticText(s_region, getPinUtilStr(part));

   s_region = vcTable.Get(main_region, 4, 5);
   UpdateStaticText(s_region, getPinAvailStr(part));

} /* End of UpdtUtilMainStat */

function UpdtCurrentPartMainStat(part)
{
   main_region := vcTable.Get(GetRegion(part), 0, 0);

   s_region := vcTable.Get(main_region, 1, 7);
   UpdateStaticText(s_region, cbGetNumOfParts(part));

} /* End of UpdtCurrentPartMainStat */


function UpdtUserGoalMainStat(part)
{
   main_region := vcTable.Get(GetRegion(part), 0, 0);

   s_region := vcTable.Get(main_region, 2, 7);
   UpdateStaticText(s_region, cbGetUserGoal(part));

} /* End of UpdtUserGoalMainStat */

function UpdtSystemNetMainStat(part)
{
   main_region := vcTable.Get(GetRegion(part), 0, 0);

   s_region := vcTable.Get(main_region, 4, 7);
   UpdateStaticText(s_region, cbGetSystemNet(part));

} /* End of UpdtSystemNetMainStat */

function UpdtAutoGroupMainStat(part)
{
   main_region := vcTable.Get(GetRegion(part), 0, 0);

   s_region := vcTable.Get(main_region, 5, 7);
   value := cbGetAutoGroup(part);
   if(value < 0)
      UpdateStaticText(s_region, "OFF");
   else
      UpdateStaticText(s_region, value);

} /* End of UpdtAutoGroupMainStat */

function UpdtUserTechMainStat(part, techfile)
{
   main_region := vcTable.Get(GetRegion(part), 0, 0);

   s_region := vcTable.Get(main_region, 5, 3);
   UpdateStaticText(s_region, techfile);

} /* End of UpdtUserTechMainStat */

function design_fcn(part, event, TheDesign, TheLevel)
{
    vcWin.Busy(vcEvent.Window(event), TRUE);
    
    status := LoadDesign(part, event, TheDesign,TheLevel);
    vcWin.Busy(vcEvent.Window(event), FALSE);
    if (status)
        enable_commands(part);
    /* Now that the design is loaded, 
       update the Status Table in the Main Window */

    UpdtDesMainStat(part);

} /* design_fcn */

vcBind.Set(bindings,'\^C', vcWv.Cmd(fac,func(sh,ev) { ; }));


function lockpushed(part, event, table, row)
{
/****
   vcCmd.Run(lock_partition_cmd, part, event, 
             list(getDesignName(part) + "_" + number2string(row+1), 0), TRUE);
****/

   vcTable.Set(table, row, 2, 
               vcWv.IconButtonCreate("Lock", "partunlk", nil, 
                                   vcWv.Cmd(fac, 
                                            func(d, e)
                                            {
                                               unlockpushed(d, e, table, row);
                                            },
                                            ""), nil));
} /* End of lockpushed */

function unlockpushed(part, event, table, row)
{
/****
   vcCmd.Run(lock_partition_cmd, part, event, 
             list(getDesignName(part) + "_" + number2string(row+1), 1), TRUE);
****/

   vcTable.Set(table, row, 2, 
               vcWv.IconButtonCreate("Lock", "partlock", nil, 
                                   vcWv.Cmd(fac, 
                                            func(d, e)
                                            {
                                               lockpushed(d, e, table, row);
                                            },
                                            ""), nil));
} /* End of unlockpushed */

load_design_cmd := vcWv.Cmd(fac, design_fcn, "LoadDesign", "Load Design",
                            vcWv.Param("design", vlStringVT,
                                       vcWv.Sticky, "",
                                       "Specify Design Name"),
                            vcWv.Param("level", vlStringVT,
                                       vcWv.Sticky, "",
                                       vcWv.Secondary,
                                       "Specify Levels"));

vcCmd.EchoShell(load_design_cmd, vlOnOff.On);

partition_cmd := vcWv.Cmd(fac,
                          func(part, event) {
                              vcWin.Busy(vcEvent.Window(event), TRUE);
                              status := Partition(part, event);
                              vcWin.Busy(vcEvent.Window(event), FALSE);
                              if (status)
                                  enable_commands(part);
                          }, "Partition");
vcCmd.EchoShell(partition_cmd, vlOnOff.On);

show_user_groups_cmd := vcWv.Cmd(fac, ShowUserGroups, "ShowUserGroups");
vcCmd.EchoShell(show_user_groups_cmd, vlOnOff.On);

show_auto_groups_cmd := vcWv.Cmd(fac, ShowAutoGroups,
                                 "ShowAutoGroups");
vcCmd.EchoShell(show_auto_groups_cmd, vlOnOff.On);

write_report_cmd := vcWv.Cmd(fac, Report, "Report");
vcCmd.EchoShell(write_report_cmd, vlOnOff.On);

show_status_cmd := vcWv.Cmd(fac, ShowStatus, "Status");
vcCmd.EchoShell(show_status_cmd, vlOnOff.On);

show_summary_cmd := vcWv.Cmd(fac, ShowSummary, "Summary");
vcCmd.EchoShell(show_summary_cmd, vlOnOff.On);

load_user_macro_cmd := vcWv.Cmd(fac, LoadUserTechFile,
                                "LoadUserTechFile", "LoadUserTechFile",
                                vcWv.Param("file_name", vlStringVT,
                                           vcWv.Sticky, ""));
/* vcCmd.EnableApply(load_user_macro_cmd, vlOnOff.Off); */
vcCmd.EchoShell(load_user_macro_cmd, vlOnOff.On);

add_system_wide_net_cmd := vcWv.Cmd(fac, SWAddNet, "SWAddNet", "SWAddNet",
                                    vcWv.Param("net name", vlStringVT,
                                               vcWv.Sticky, ""));
/* vcCmd.EnableApply(add_system_wide_net_cmd, vlOnOff.On); */
vcCmd.EchoShell(add_system_wide_net_cmd, vlOnOff.On);

delete_system_wide_net_cmd := vcWv.Cmd(fac, SWDeleteNet,
                                       "SWDeleteNet", "SWDeleteNet",
                                       vcWv.Param("remove_net", vlStringVT,
                                                  vcWv.Sticky, ""));
/* vcCmd.EnableApply(delete_system_wide_net_cmd, vlOnOff.On); */
vcCmd.EchoShell(delete_system_wide_net_cmd, vlOnOff.On);

show_SW_nets_cmd := vcWv.Cmd(fac, SWShowNets, "SWShowNets");
vcCmd.EchoShell(show_SW_nets_cmd, vlOnOff.On);

list_system_wide_nets_cmd := show_SW_nets_cmd;
vcCmd.EchoShell(list_system_wide_nets_cmd, vlOnOff.On);

setup_goal_cmd := vcWv.Cmd(fac, GoalNumber, "GoalNumber", "GoalNumber",
                           vcWv.Param("# of Partitions",
                                      vlPositiveIntVT, vcWv.Sticky, 2,
                                      "The goal for number of partitions."));
/* vcCmd.EnableApply(setup_goal_cmd, vlOnOff.On); */
vcCmd.EchoShell(setup_goal_cmd, vlOnOff.On);

function tech_package_fcn(part, event, tech)
{
   vcCmd.Run(technology_cmd, part, event, list(tech), TRUE);
   tech := TechnologySet(part);
   
   if (tech)
      vcCmd.Run(package_pick_cmd, part, event, nil, FALSE);

   enable_commands(part);
   ClearDesMainStat(part);
   ClearPckgMainStat(part);

} /* tech_package_fcn */

/* Command for the above function. */
tech_package_cmd := vcWv.Cmd(fac,  tech_package_fcn,
                             "techpkg", "techpkg",
                             vcWv.Param("Technology", vlStringVT,
                                        vcWv.Sticky, ""));
vcCmd.EnableMacro(tech_package_cmd, vlOnOff.Off);

function technology_fcn(part, event, technology)
{
   status := LoadTechnology(part, event, technology);
   
   /* set the technology library */
   if (!status)
      error("Couldn't read library \"" + technology + "\"", nil);
   
   enable_commands(part);
   UpdtTechMainStat(part, technology);
   
   /* Clear the status area */
   ClearDesMainStat(part);
   ClearPckgMainStat(part);

} /* technology_fcn */

technology_cmd := vcWv.Cmd(fac,  technology_fcn, "technology", "technology",
                           vcWv.Param("Technology", vlStringVT,
                                      vcWv.Sticky, ""));
vcCmd.EchoShell(technology_cmd, vlOnOff.On);

function package_fcn(part, event, pkg)
{
   status := SetPackage(part, pkg, TRUE);
   
   if (!status)
      error("Couldn't set package to \"" + pkg + "\"", nil);
   else 
   {
      cbSetAvailCap(part, event);
      CheckGroups(part, event);
      PrintOpt(part,event);
      UpdtPckgMainStat(part, pkg);
   } /* else */

   main_region := GetRegion(part);
/*   vcTable.Set(main_region, 1, 0, createPartTable(part, event)); */

   enable_commands(part);
} /* package_fcn */

package_cmd := vcWv.Cmd(fac,  package_fcn, "package", "package",
                        vcWv.Param("Package", vlStringVT, vcWv.Sticky, ""));
vcCmd.EchoShell(package_cmd, vlOnOff.On);

function package_pick(part, event)
{
   HowManyRows := HowManyPackages(part);
   TheList := PackageNames(part);
   declare str;
   function AcceptFcn(ev) 
   {
      /* Use the event which created this pick list -- which should contain
       * be the top window and it's region -- NOT the event associated
       * with hitting this button.
       */
      vcCmd.Run(package_cmd, part, event,
                str, TRUE);
   }

   /* Lets Create the region where the information about the devices
      will be displayed */
   LabelComp := vcRegion.Create("Lcomp", vcLabel.fac, DefStrComps);
   StaticComp := vcRegion.Create("Scomp", vcStaticText.fac, "10000");
   LabelReg := vcRegion.Create("Lreg", vcLabel.fac, DefStrRegs);
   StaticReg := vcRegion.Create("Sreg", vcStaticText.fac, "2455");
   LabelPin := vcRegion.Create("Lpin", vcLabel.fac, DefStrPins);
   StaticPin := vcRegion.Create("Spin", vcStaticText.fac, "123");
   LabelClk := vcRegion.Create("Lclk", vcLabel.fac, DefStrClkPins);
   StaticClk := vcRegion.Create("Sclk", vcStaticText.fac, "4");

   DevInfo := vcTable.Make("DeviceInfo", 4, 2, 
                           LabelComp, StaticComp,
                           LabelReg, StaticReg,
                           LabelPin, StaticPin,
                           LabelClk, StaticClk);

   vcTable.Col(DevInfo, 0, vcTable.Border.Invisible,
               30, 20, 35, vgAlign.MiddleCenter);

   vcTable.Col(DevInfo, 1, vcTable.Border.Invisible,
               8, 10, 12, vgAlign.MiddleCenter);
   
   SubTitle := vcRegion.Create("", vcLabel.fac,
                               "Packages for " + TechnologyName(part));
   
   Picklist := vcRegion.Create("Package Picklist", vcPicklist.fac,
                               TheList,
                               columns <- 1,
                               exclusive <- TRUE,
                               will_scroll <- TRUE);

   Ideal := HowManyRows;

   if (Ideal > 10)
   Ideal = 10;

   ThePick := vcPicklist.Scroll("Picks", Picklist,
                                5, Ideal, 20);

   vcPicklist.Notify(Picklist,
                     func(TheString, on_or_off) 
                     {
                        if (on_or_off)
                        {
                           str = TheString;
                        }
                        /* Set the PKGID in the Partitioner data struct. */
                        status := SetPackage(part, car(TheString), FALSE);
                        /* Get the Combs value and display it */
                        UpdateStaticText(StaticComp, PackageNComps(part));

                        /* Get the Regs value and display it */
                        UpdateStaticText(StaticReg, PackageNRegs(part));

                        /* Get the pins value and display it */
                        UpdateStaticText(StaticPin, PackageNPins(part));

                        /* Get the clock pins value and display it */
                        UpdateStaticText(StaticClk, PackageNClkPins(part));

                     });

   vcPicklist.SetPick(Picklist, 0);

   PackSel := vcTable.Create("packselector", 2, 2);
   vcTable.Set(PackSel, 0, 0, SubTitle);
   vcTable.Set(PackSel, 1, 0, ThePick);
   vcTable.Set(PackSel, 1, 1, DevInfo);

   /* get the simple button arrangement together */
   TheButtons := vcRegion.Create("buttons", vcButnRow.fac,
                                 list(list("Accept", "Accept",
                                           AcceptFcn,
                                           list(close_window <- TRUE)),
                                      list("Cancel", "Cancel",
                                           func() ;,
                                           list(close_window <- TRUE))));

   Selector := vcTable.Make("selector", 2, 1,
                            PackSel, TheButtons);

/*   vcTable.Col(Selector, -1, vcTable.Border.Invisible,
               30, 20, 35, vgAlign.MiddleCenter);
*/


   PopWin := vcWin.Popup(vcEvent.Window(event), Selector,
                         Selector, vcWin.NoBindings);
   vcWin.AddStatus(PopWin, "Select Desired Package");
   vcWin.SetTitle(PopWin, "Package Selector");
} /* package_pick */

package_pick_cmd := vcWv.Cmd(fac,  package_pick, "PickPackage");
vcCmd.EnableMacro(package_pick_cmd, vlOnOff.Off);

function GetPartitionName_fcn(part)
{
   part_name := getDesignName(part) + "_";
   return(part_name);
} /* End of GetPartitionName_fcn */

lock_partition_cmd := vcWv.Cmd(fac, Lock, "Lock", "Lock",
                               vcWv.Param("Partition", vlStringVT,
                                          vcWv.Dynamic, GetPartitionName_fcn),
                               vcWv.Param("On or Off", vlOnOffVT,
                                          vcWv.Sticky, vlOnOff.On,
														vcPickEnum.fac));

vcCmd.EchoShell(lock_partition_cmd, vlOnOff.On);

move_component_cmd := vcWv.Cmd(fac, MoveComponent,
                               "MoveComponent", "MoveComponent",
                               vcWv.Param("Component", vlStringVT,
                                          vcWv.Sticky, ""),
                               vcWv.Param("Partition Name", vlStringVT,
                                          vcWv.Dynamic, GetPartitionName_fcn));
vcCmd.EchoShell(move_component_cmd, vlOnOff.On);

scatter_all_cmd := 
   vcWv.CmdWithConfirm(fac, 
							  func(part, event) 
							  { 
								  vcWin.WithBusy(vcEvent.Window(event),
													  func() ScatterAll(part, event););
							  },
							  func(part, event)
							  {
								  "Do you really want to scatter all existing partitions?";
							  }, TRUE, "ScatterAll", "ScatterAll"	);

vcCmd.EchoShell(scatter_all_cmd, vlOnOff.On);

scatter_partition_cmd := vcWv.Cmd(fac, Scatter, "Scatter", "Scatter",
                                  vcWv.Param("Partition", vlStringVT,
                                             vcWv.Sticky, ""));
vcCmd.EchoShell(scatter_partition_cmd, vlOnOff.On);

auto_group_cmd := vcWv.Cmd(fac, SetAutoGroups,
                           "SetAutoGroups", "SetAutoGroups",
                           vcWv.Param("value", vlIntVT,
                                      vcWv.Sticky, 100));
vcCmd.EchoShell(auto_group_cmd, vlOnOff.On);

set_pin_count_threshold_cmd := vcWv.Cmd(fac, SWSetThreshold,
                                        "SWSetThreshold", "SWSetThreshold",
                                        vcWv.Param("value", vlPositiveIntVT,
                                                   vcWv.Sticky, 10));
vcCmd.EchoShell(set_pin_count_threshold_cmd, vlOnOff.On);

show_summary_cmd := vcWv.Cmd(fac, ShowSummary, "ShowSummary");
vcCmd.EchoShell(show_summary_cmd, vlOnOff.On);

utilization_cmd := 
   vcWv.Cmd(fac, 
            Utilization, "Utilization", "Utilization",
            vcWv.Param("Component", UtilValueVT,
                       vcWv.Sticky, 100.0, vcCmdline.fac,
                       "Enter Component utilization in percentage."),
            vcWv.Param("Register", UtilValueVT,
                       vcWv.Sticky, 100.0, vcCmdline.fac,
                       "Enter Register utilization in percentage."),
            vcWv.Param("Pin", UtilValueVT,
                       vcWv.Sticky, 100.0, vcCmdline.fac,
                       "Enter Pin utilization in percentage."));

vcCmd.EchoShell(utilization_cmd, vlOnOff.On);

computil_cmd := 
   vcWv.Cmd(fac,
            Computil, "Computil", "Computil",
            vcWv.Param("Component", UtilValueVT,
                       vcWv.Sticky, 100.0, vcCmdline.fac,
                       "Enter Component utilization in percentage."));

vcCmd.EchoShell(computil_cmd, vlOnOff.On);


regutil_cmd := 
   vcWv.Cmd(fac,
            Regutil, "Regutil", "Regutil",
            vcWv.Param("Register", UtilValueVT,
                       vcWv.Sticky, 100.0, vcCmdline.fac,
                       "Enter Register utilization in percentage."));

vcCmd.EchoShell(regutil_cmd, vlOnOff.On);

pinutil_cmd := 
   vcWv.Cmd(fac,
            Pinutil, "Pinutil", "Pinutil",
            vcWv.Param("Pin", UtilValueVT,
                       vcWv.Sticky, 100.0, vcCmdline.fac,
                       "Enter Pin utilization in percentage."));

vcCmd.EchoShell(pinutil_cmd, vlOnOff.On);

verbose_cmd := vcWv.Cmd(fac, Verbose, "Verbose", "Verbose",
                        vcWv.Param("On or Off", vlOnOffVT,
                                   vcWv.Sticky, vlOnOff.On,
											  vcPickEnum.fac));
vcCmd.EchoShell(verbose_cmd, vlOnOff.On);

aliasing_cmd := vcWv.Cmd(fac, Aliasing, "Aliasing", "Aliasing",
                         vcWv.Param("On or Off", vlOnOffVT,
                                    vcWv.Sticky, vlOnOff.On,
												vcPickEnum.fac));
vcCmd.EchoShell(aliasing_cmd, vlOnOff.On);

soft_macros_cmd := vcWv.Cmd(fac, SoftMacros, "SoftMacros", "SoftMacros",
                            vcWv.Param("On or Off", vlOnOffVT,
                                       vcWv.Sticky, vlOnOff.On,
													vcPickEnum.fac));
vcCmd.EchoShell(soft_macros_cmd, vlOnOff.On);

write_wirelists_cmd := 
   vcWv.CmdWithConfirm(fac, 
							  func(part, event) 
							  {
								  vcWin.WithBusy(vcEvent.Window(event),
													  func()
													  Write(part,event););
							  },
							  func(part, event)
							  {
								  status := File_Exists(part, event, "");
								  if(status == 1)
								  "Do you really want to overwrite these files?";
								  else
								  FALSE;
							  },
							  TRUE, "Write", "Write");														 
vcCmd.EchoShell(write_wirelists_cmd, vlOnOff.On);

write_to_cmd := 
   vcWv.CmdWithConfirm(fac, 
							  func(part, event, name)
							  {
								  vcWin.WithBusy(vcEvent.Window(event),
													  func()
													  WriteTo(part, event, name););
							  },
							  func(part,event, name)
							  {
								  status := File_Exists(part, event, name);
								  if(status == 1)
								     "Do you really want to overwrite these files?";
								  else
								     FALSE;
							  }, TRUE, "WriteTo", "WriteTo",
							  vcWv.Param("Wirelist Name", vlStringVT,
											 vcWv.Sticky, ""));

vcCmd.EchoShell(write_to_cmd, vlOnOff.On);

setup_list_cmd := show_status_cmd;

find_component_cmd := vcWv.Cmd(fac, FindComponent,
                               "FindComponent", "FindComponent",
                               vcWv.Param("Name", vlStringVT,
                                          vcWv.Sticky, ""));
vcCmd.EchoShell(find_component_cmd, vlOnOff.On);

show_total_cmd := vcWv.Cmd(fac, Total, "Total");
vcCmd.EchoShell(show_total_cmd, vlOnOff.On);

about_SW_nets_cmd := vcWv.Cmd(fac, func(part, event)
                              vcAlert.SpawnHelp(vcEvent.Window(event),
                                                "viewpart",
                                                "SystemWideNets");,
                              "AboutSystemWideNets");
vcCmd.EchoShell(about_SW_nets_cmd, vlOnOff.On);

about_change_cmd := vcWv.Cmd(fac, func(part, event)
                             vcAlert.SpawnHelp(vcEvent.Window(event),
                                               "viewpart", "ChangeMenu");,
                             "AboutChange");
vcCmd.EchoShell(about_change_cmd, vlOnOff.On);

net_connections_cmd := vcWv.Cmd(fac, NetConnections,
                                "NetConnections", "NetConnections",
                                vcWv.Param("Net Name", vlStringVT,
                                           vcWv.Sticky, ""));
vcCmd.EchoShell(net_connections_cmd, vlOnOff.On);

function _Enter(part, event)
{
    if (!MenusUpdated(part)) {
        enable_commands(part);

        vcWin.AddStatus(vcEvent.Window(event),
                        status_message(part));
    } /* if */
} /* _Enter */

/* This makes a command out of a command line string.
 */
function cmd(cmdname, abbrev, title, params) {
    function send_strings (args...) {
        declare str, part, e, a;

        part = car (args); args = cdr (args);
        e    = car (args); args = cdr (args);
        for (str = abbrev; !null(args); args = cdr (args)) {
            a = car (args);
            str = str + " " +
                (istype (a, string) ? a : number2string (a));
        } /* for */
        vcShell.TypeIn (part, str, TRUE);
    } /* function send_strings */
    vcCmd.Create (fac, send_strings, cmdname, title, params);
} /* cmd */

function status_message(part)
{
    declare message;

    /* has the user specified technology */
    tech_switch := convert(vlOnOffVT, TechnologySet(part) ? TRUE : FALSE);

    /* has the user specified technology and package */
    pkg_switch := convert(vlOnOffVT, PackageSet(part) ? TRUE : FALSE);

    /* design is OK if pkg spec'd and design loaded (slightly redundant). */
    design_switch := convert(vlOnOffVT, DesignLoaded(part) ? TRUE : FALSE);

    /* part means "have partitioned this design at least once" */
    part_switch := convert(vlOnOffVT, Partitioned(part) ? TRUE : FALSE);

    if (!tech_switch)
        message = "Use \"Setup->Device->Technology\" ";
    else if (!pkg_switch)
        message = "Use \"Setup->Device->Package\" ";
    else if (!design_switch)
        message = "Use \"File->Load Design\" ";
    else if (!part_switch)
        message = "Use \"Partition\" ";
    else
        message = "";

    return(message);
} /* status_message */

/* Centralized function to twiddle the greying/disabling of commands
 * based on the state of the program; that is, if user has selected
 * a technology and package, loaded a design, and partioned at least once.
 * (When these actions take place, this function should be called).
 */
function enable_commands(part)
{
    declare message;
    function enable_list (switch, cmd_list)
        {
            for (cmd := cmd_list; !null(cmd); cmd = cdr(cmd)) {
                vcCmd.SetDisabledMsg(car(cmd), message);
                vcCmd.Enable(car(cmd), switch);
            } /* for */
        } /* enable_list */

    /* has the user specified technology */
    tech_switch := convert(vlOnOffVT, TechnologySet(part) ? TRUE : FALSE);

    /* has the user specified technology and package */
    pkg_switch := convert(vlOnOffVT, PackageSet(part) ? TRUE : FALSE);

    /* design is OK if pkg spec'd and design loaded (slightly redundant). */
    design_switch := convert(vlOnOffVT, DesignLoaded(part) ? TRUE : FALSE);

    /* part means "have partitioned this design at least once" */
    part_switch := convert(vlOnOffVT, Partitioned(part) ? TRUE : FALSE);

    if (!tech_switch)
        message = "Use \"Setup->Device->Technology\" first";
    else if (!pkg_switch)
        message = "Use \"Setup->Device->Package\" first";
    else if (!design_switch)
        message = "Use \"File->Load Design\" first";
    else if (!part_switch)
        message = "Use \"Partition\" first";

    enable_list(tech_switch,
                list(package_cmd, package_pick_cmd, load_user_macro_cmd));

    enable_list(pkg_switch,
                list(load_design_cmd));

    enable_list(design_switch,
                list(add_system_wide_net_cmd,
                     delete_system_wide_net_cmd,
                     list_system_wide_nets_cmd,
                     partition_cmd,
                     show_user_groups_cmd,
                     show_auto_groups_cmd,
                     net_connections_cmd));

    enable_list(part_switch,
                list(find_component_cmd,
                     lock_partition_cmd,
                     move_component_cmd,
                     scatter_all_cmd,
                     scatter_partition_cmd,
                     show_summary_cmd,
                     show_total_cmd,
                     write_report_cmd,
                     write_to_cmd,
                     write_wirelists_cmd));

    if (vcRegion.Window(GetRegion(part)) != nil) {
        vcWin.UpdateMenus(vcRegion.Window(GetRegion(part)));
        SetMenusUpdated(part, TRUE);
    } /* if */

} /* enable_commands */

load("partmn.vs");
load("partht.vs");
