/*
 * $Revision: 1.5 $
 *
 * Because plot expansion affects scale, the new values take effect 
 * immediately as opposed to waiting until the user hits the apply.
 * In the event the user hits a cancel, reset_value is called.
 */
package vspexp (create_explist, reset_value) {

declare old_exp;

vspBF := "BESTFIT";
vspALGN := "ALIGN";

function set_expansion (val, on_off) {

        if (on_off == vlOnOff.Off)
                return (nil);

        set_graphics_modified ();
        
        fac_pack.sp_sapopt (string_append("ORIENT ", val));
        fac_pack.vspUpdateScale ();
        vspscale.set_scale_cmdline_val (fac_pack.get_def_scale(vspFIRSTVAL));
}

expansions := list(0, `vertical, "PLOT EXPANSION",
                list(cons(vspBF, vspBF), cons(vspALGN, vspALGN)),
                set_expansion);

function get_exp_index (str) {
        declare tlst;

        exp_lst := cadddr (expansions);
        for (i := 0, tlst = exp_lst; tlst != nil; ++i, tlst = cdr(tlst)) {
                if (string_eqi (str, caar (tlst)))
                        return (i);
        }
        return (nil);
}

function reset_value () {
        fac_pack.sp_sapopt (string_append("ORIENT ", old_exp));
}

function create_explist () {
        old_exp = fac_pack.get_def_exp ();
        return (create_pklst (func () return (get_exp_index (old_exp));,
                cadr(expansions), caddr(expansions),
                cadddr(expansions), cadr(cdddr(expansions)), FALSE));
        }
}

