/*
 *  $Revision: 1.25.4.1 $
 *
 *  Viewscript UI definitions for the Core vcButton facility.
 *
 *  Copyright (c) 1992 by Viewlogic Systems, Inc.
 */

armed_bindings := vcBind.Create ();

arm_cmd := vcWv.Cmd (fac,
                     func (button, ev)
                     {
                         if (arm (button, ev))
                         {
                             r := vcEvent.Region (ev);
                             vcRegion.SetGrab (r, r);
                             vcRegion.SetBindings (r, armed_bindings);
                         }
                     }, "arm");

fire_cmd := vcWv.Cmd (fac,
                      func (button, ev)
                      {
                          r := vcEvent.Region (ev);
                          vcRegion.SetGrab (r, nil);
                          vcRegion.SetBindings (r, bindings);
                          if (inside (button, vcEvent.X (ev), vcEvent.Y (ev)))
                              fire (button, ev);
                          else
                              disarm (button, ev);
                      }, "fire");

move_cmd := vcWv.Cmd (fac,
                      func (button, ev)
                      {
                          if (inside (button, vcEvent.X (ev), vcEvent.Y (ev)))
                              arm (button, ev);
                          else
                              maybe_disarm (button, ev);
                      });

vcBind.Set (bindings, '\leftdown',  arm_cmd);
vcBind.Set (bindings, '\rightdown', arm_cmd);

vcBind.Set (armed_bindings, '\leftup',  fire_cmd);
vcBind.Set (armed_bindings, '\rightup', fire_cmd);
vcBind.Set (armed_bindings, '\move',    move_cmd);

vcWv.Interrupts (fac, '\leftup', '\rightup');

activate_cmd := vcWv.Cmd (fac, _Activate);
vcBind.set (bindings, ' ', activate_cmd);       /* KSelect, virtually */
