/*
 *  $Revision: 1.9.7.1 $
 *
 *  Viewscript UI definitions for the Core vcTxShell facility.
 *
 *  Copyright (c) 1992 by Viewlogic Systems, Inc.
 */

vcBind.Set (bindings, '\tab',
            vcWv.Cmd (fac, func(shell, e)
                          _insert_char (shell,
                                        vcEvent.Create (vcEvent.X (e),
                                                        vcEvent.Y (e),
                                                        '\t',
                                                        nil,
                                                        vcEvent.Window (e),
                                                        vcEvent.Region (e),
                                                        nil));,
                      "tab"));

process_cmd := vcWv.Cmd (fac, process, "enter");
vcBind.Set (bindings, '\enter', process_cmd);
vcBind.Set (bindings, '\^M', process_cmd);
vcBind.Set (bindings, '\^J', process_cmd);

next_cmd := vcWv.Cmd (fac, next_line, "next");
prev_cmd := vcWv.Cmd (fac, prev_line, "prev");
goto_prompt_cmd := vcWv.Cmd (fac, func(sh, e) goto_prompt (sh);,
                             "goto_prompt");
del_cmd := vcWv.Cmd (fac, del, "del");
del_next_char_cmd := vcWv.Cmd (fac, del_next_char, "del_next_char");
del_to_eol_cmd := vcWv.Cmd (fac, del_to_eol, "del_to_eol");
del_next_word_cmd := vcWv.Cmd (fac, del_next_word, "del_next_word");
del_to_prompt_cmd := vcWv.Cmd (fac, del_to_prompt, "del_to_prompt");
del_prev_word_cmd := vcWv.Cmd (fac, del_prev_word, "del_prev_word");
del_line_cmd := vcWv.Cmd (fac, func(s, e) {
    del_to_prompt (s, e);
    del_to_eol (s, e);
}, "del_line");
paste_cmd := vcWv.Cmd (fac, func(sh,e) {
    check_in_range (sh, TRUE);
    TypeIn (vcEvent.Region (e), vcWv.FetchCutBuffer (wv),
            FALSE, e);
}, "paste");

vcBind.Set (bindings, '\^P', prev_cmd);
vcBind.Set (bindings, '\^N', next_cmd);
vcBind.Set (bindings, '\up', prev_cmd);
vcBind.Set (bindings, '\down', next_cmd);
vcBind.Set (bindings, '\^A', goto_prompt_cmd);
vcBind.Set (bindings, '\^D', del_next_char_cmd);
vcBind.Set (bindings, '\F5', del_to_eol_cmd);
vcBind.Set (bindings, '\^K', del_to_eol_cmd);
vcBind.Set (bindings, '\F7', del_prev_word_cmd);
vcBind.Set (bindings, '\_\177', del_prev_word_cmd);
vcBind.Set (bindings, '\F8', del_prev_word_cmd);
vcBind.Set (bindings, '\_d', del_next_word_cmd);
vcBind.Set (bindings, '\_D', del_next_word_cmd);
vcBind.Set (bindings, '\^U', del_to_prompt_cmd);
vcBind.Set (bindings, '\177', del_cmd);
vcBind.Set (bindings, '\F6', del_line_cmd);
vcBind.Set (bindings, '\F18', paste_cmd);
vcBind.Set (bindings, '\middledown', paste_cmd);

/*
 * Keys which insert themselves
 */
tmpCmd := vcWv.Cmd (fac, _insert_char, "insert");
foreach (i; vcWv.Printable ())
    vcBind.Set (bindings, i, tmpCmd);
tmpCmd = nil;
