;;;;
;;;; $Revision: 1.34.1.2 $  $Date    : 93/12/18 16:44:43 $
;;;;
;;;; Master Class Definition file for Viewlogic tools.
;;;;
;;;; Copyright (c) 1994 by Viewlogic Systems, Inc.
;;;;



(vdm|ClassFileSetVersion class_file 1.0)



;;;
;;; Load the default object editors.
;;;
(load "vdmEdit" nil)



;;;
;;; ViewDraw schematic sheet.
;;;
(vdm|ClassCreate "Schematic" class_file
     `(AttrList         . ("BLOCK" "SHEET"))
     `(AttrFilter       . ("[0-9a-zA-Z_]+" "[0-9]+"))
     `(Editor           . ,vdmEditViewDraw)
     `(NameTemplate     . "$BLOCK.$SHEET");
     `(PhysicalTemplate . "sch/$BLOCK.$SHEET")
     `(Type             . ,vdmClassType|File))



;;;
;;; ViewDraw symbol.
;;;
(vdm|ClassCreate "Symbol" class_file
     `(AttrList         . ("BLOCK" "SHEET"))
     `(AttrFilter       . ("[0-9a-zA-Z_]+" "[0-9]+"))
     `(Editor           . ,vdmEditViewDraw)
     `(NameTemplate     . "$BLOCK.$SHEET");
     `(PhysicalTemplate . "sym/$BLOCK.$SHEET")
     `(Type             . ,vdmClassType|File))



;;;
;;; ViewDraw Occurence Attribute file.
;;;
(vdm|ClassCreate "OATs" class_file
     `(AttrList         . ("BLOCK"))
     `(AttrFilter       . ("[0-9a-zA-Z_]+"))
     `(Editor           . ,vdmEditViewDraw)
     `(NameTemplate     . "$BLOCK");
     `(PhysicalTemplate . "sch/$BLOCK.oat")
     `(Type             . ,vdmClassType|File))



;;;
;;; ViewDraw wir file.
;;;
(vdm|ClassCreate "Wir" class_file
     `(AttrList         . ("BLOCK" "SHEET"))
     `(AttrFilter       . ("[0-9a-zA-Z_]+" "[0-9]+"))
     `(Editor           . ,vdmEditViewDraw)
     `(NameTemplate     . "$BLOCK.$SHEET");
     `(PhysicalTemplate . "wir/$BLOCK.$SHEET")
     `(Type             . ,vdmClassType|File))


;;;
;;; ViewDraw symbol PIN file.
;;;
(vdm|ClassCreate "Pin" class_file
     `(AttrList         . ("BLOCK"))
     `(AttrFilter       . ("[0-9a-zA-Z_]+" "[0-9]+"))
     `(Editor           . ,vdmEditViewDraw)
     `(NameTemplate     . "$BLOCK");
     `(PhysicalTemplate . "sym/$BLOCK.pin")
     `(Type             . ,vdmClassType|File))


;;;
;;; ViewDraw Generic Library (PKT) file.
;;;
(vdm|ClassCreate "Pkt" class_file
     `(AttrList         . ("BLOCK"))
     `(AttrFilter       . ("[0-9a-zA-Z_]+" "[0-9]+"))
     `(Editor           . ,vdmEditViewDraw)
     `(NameTemplate     . "$BLOCK");
     `(PhysicalTemplate . "pkt/$BLOCK.1")
     `(Type             . ,vdmClassType|File))


;;;
;;; Meta-data object.  It's used internally by the VDM to store data
;;; about the data objects.
;;;
(vdm|ClassCreate "vdmMetaData" class_file
     `(AttrList         . ("NAME"))
     `(AttrFilter       . (".*"))
     `(PhysicalTemplate . "$NAME"))


;;;
;;; Widlcard  class.
;;;
(vdm|ClassCreate "vdmWildcard" class_file
     `(AttrList         . ("NAME"))
     `(AttrFilter       . (".*"))
     `(PhysicalTemplate . "$NAME")
     `(Type             . ,vdmClassType|Abstract))


;;;
;;; Configuration object. Used internally by the VDM to create configurations.
;;;
(vdm|ClassCreate "vdmCollection" class_file
     `(AttrList          . ("NAME"))
     `(AttrFilter        . (".*"))
     `(CollectionMembers . ("vdmWildcard"))
     `(NameTemplate      . "$NAME")
     `(PhysicalTemplate  . "vdmfcoll/$NAME.vcl")
     `(Type              . ,vdmClassType|Composite))



;;;
;;; Generic file class.
;;;
(vdm|ClassCreate "AnyFileOrDir" class_file
     `(AttrList         . ("NAME"))
     `(AttrFilter       . (".*"))
     `(Editor           . ,vdmEditDefault)
     `(PhysicalTemplate . "$NAME")
     `(Type             . ,vdmClassType|File))
