/*
 *  $Revision: 2.1.1.8 $  $Date    : 94/06/24 23:36:15 $
 *
 *  Menu definitions for the vdata facility.
 *
 *  Copyright (c) 1994,1995 by Viewlogic Systems, Inc.
 */


DisplayMenu :=
    vcWv.MakeMenu ("Display",
                   vcWv.Pin (),
                   list ("&New View",                   NewViewCmd),
                   list ("&Locations and Objects",      ShowLocObjCmd),
                   list ("&Classes",                    ShowClassesCmd),
                   list ("List of &selected items",     ShowSelectedCmd));

SelectMenu :=
    vcWv.MakeMenu ("Select",
                   vcWv.Pin (),
                   list ("&Children",                   SelectChildrenCmd),
                   list ("&Relatives",                  SelectRelativesCmd),
                   list ("&Objects by name",            FindObjectCmd),
                   list ("&Location by name",           SelectLocationCmd));

CheckpointMenu :=
    vcWv.MakeMenu ("Checkpoint",
                   vcWv.Pin (),
                   list ("Create",                      CreateCheckpointCmd),
                   list ("Restore",                     RestoreCheckpointCmd));

ObjectExtrasMenu :=
    vcWv.MakeMenu ("Extras",
                   vcWv.Pin (),
                   vcWv.CheckedOption ("Dry run",       DryRunCmd, FALSE),
                   list ("&Tag",                        SetTagCmd),
                   list ("&Update",                     ObjectUpdateCmd),
                   list ("&Loop Area",                  WorkOrStorageCmd));

ObjectMenu :=
    vcWv.MakeMenu ("Object",
                   vcWv.Pin (),
                   list ("Check &Out",                  CheckoutCmd),
                   list ("Check Out &No Lock",          CheckoutNoLockCmd),
                   list ("&Checkpoint",                 CheckpointMenu),
                   list ("Check &In",                   CheckinCmd),
                   list ("&Lock",                       LockCmd),
                   list ("&Unlock",                     UnlockCmd),
                   vcWv.Separator (),
                   list ("&Edit",                       EditObjCmd),
                   list ("&New Object",                 NewObjectCmd),
                   vcWv.Separator (),
                   list ("&Delete",                     DeleteCmd),
                   list ("In&fo",                       InfoCmd),
                   list ("E&xtras",                     ObjectExtrasMenu));

AttrMenu :=
    vcWv.MakeMenu ("Attribute",
                   vcWv.Pin (),
                   list ("&Add",                        AddAttributeCmd),
                   list ("&Edit",                       EditAttributesCmd));

CollectionMenu :=
    vcWv.MakeMenu ("Collection",
                   list ("&Create Collection",          CreateCollectionCmd),
                   list ("&Add Objects to Collection",  AddToCollectionCmd),
                   list ("&Remove Objects from Collection",
                         RemoveFromCollectionCmd),
                   list ("C&ompose Collection",         ComposeCollectionCmd));

RelationshipMenu :=
    vcWv.MakeMenu ("Relationship",
                   list ("&Create Relationship",        AddRelationshipCmd),
                   list ("&Remove Relationship",        RemoveRelationshipCmd),
                   list ("&Add Objects to Relationship",AddToRelationshipCmd),
                   list ("Remove &Objects from Relationship",
                         RemoveFromRelationshipCmd));


LocationMenu :=
    vcWv.MakeMenu ("Location",
                   vcWv.Pin (),
                   list ("&Create",                     LocationCreateCmd),
                   list ("&Remove",                     LocationRemoveCmd),
                   list ("&Edit",                       LocationEditCmd),
                   list ("Move &Top",                   LocationMoveTopCmd),
                   list ("Move &Up",                    LocationMoveUpCmd),
                   list ("Move &Down",                  LocationMoveDownCmd),
                   list ("&Write Locations",            LocationWriteCmd),
                   vcWv.Separator (),
                   list ("&Update",                     LocationUpdateCmd));

ClassMenu :=
    vcWv.MakeMenu ("Classes",
                   list ("&Create Drawer",              CreateDrawerCmd),
                   list ("&Remove Drawer",              RemoveDrawerCmd),
                   list ("&Edit Drawer",                EditDrawerCmd),
                   list ("&Add Class File",             AddClassFileCmd),
                   list ("&View Class Definition",      ViewClassDefCmd),
                   list ("&Write Class/Drawer Info",    WriteClassInfoCmd),
                   vcWv.Separator (),
                   list ("&Update",                     LClassUpdateCmd));

MainMenu :=
    vcWv.MakeMenu ("Main",
                   vcWin.RedSquareEntry,
                   list ("&Display",                    DisplayMenu),
                   list ("&Select",                     SelectMenu),
                   list ("&Object",                     ObjectMenu),
                   list ("&Attribute",                  AttrMenu),
                   list ("&Collection",                 CollectionMenu),
                   list ("&Relationship",               RelationshipMenu),
                   list ("&Location",                   LocationMenu),
                   list ("Class&es",                    ClassMenu));

vcFac.SetMenus (fac, MainMenu);
