/*
 * $Revision: 1.15.1.2 $
 *
 * Viewflow menus.
 */

view_menu := vcWv.MakeMenu ("View Menu",
                             vcWv.Pin (),
                             list ("&Refresh", vcVPCanvas.RefreshCmd),
                             list ("&Pan", PanCmd),
                             list ("&In", vcVPCanvas.InCmd),
                             list ("&Out", vcVPCanvas.OutCmd),
                             list ("&Zoom", StartZoomCmd),
                             list ("&Full", vcVPCanvas.FullCmd),
                             vcWv.Separator (), 
                             list ("O&verview", OverviewCmd)
                           );

/* this is a duplicate of the vge menu except for one thing:
 * it uses the named, not the unnamed, commands.
 * This way, I can enable/disable these entries without
 * effecting other vges, such as the IconEditor 
 */
function set_mode (cmd) {
    helpstr := "Add a " + vcCmd.Name (cmd) + " object.";
    function startit(vf, ev) {
        /* I'm your greatest static scoping nightmare */
        function run_command(ev)
            vcCmd.Run (cmd, vflCanvas.Display (vf.canvas), ev, nil, TRUE);
        vflCanvas.EnterMode (vf.canvas, run_command, helpstr);
    }
    cc := vcWv.Cmd (fac, startit, "add_" + vcCmd.Name (cmd));
    vcCmd.SetHelp (cc, helpstr);
    VgeCommandList = cons (cc, VgeCommandList);
    VgeCommandList = cons (cmd, VgeCommandList);
    cc;
}
graphics_menu := vcWv.MakeMenu ("Add Graphics",
                          vcWv.Pin (),
                          list ("&Arc",      set_mode (vge.ArcCmd)),
                          list ("Bit&map",   set_mode (vge.BitCmd)),
                          list ("Bo&rder",   set_mode (vge.BorderCmd)),
                          list ("&Box",      set_mode (vge.BoxCmd)),
                          list ("&Circle",   set_mode (vge.CircleCmd)),
                          list ("&Ellipse",  set_mode (vge.EllipseCmd)),
                          list ("&Line",     set_mode (vge.LineCmd)),
                          list ("&Kanji",    set_mode (vge.KanjiCmd)),
                          list ("&Instance", set_mode (vge.InstCmd)),
                          list ("&Pline",    set_mode (vge.PlineCmd)),
                          list ("&Raster",   set_mode (vge.RasterCmd)),
                          list ("&Spline",   set_mode (vge.SplineCmd)),
                          list ("&Text",     set_mode (vge.TextCmd)),
                          list ("TE&XT",     set_mode (vge.TEXTCmd)),
                          list ("TextRin&g", set_mode (vge.TextRingCmd)),
                          list ("&Vector",   set_mode (vge.VectorCmd)),
                          list ("PVector",   set_mode (vge.PVectCmd)));

add_obj_menu := vcWv.MakeMenu ("Add Object Menu",
                             list ("&Task", AddTaskCmd),
                             list ("&Data", AddDataCmd),
                             list ("&Graphics", graphics_menu)
                          );

object_menu := vcWv.MakeMenu ("Object Menu",
                               vcWv.Pin (),
                               list ("&Add", add_obj_menu),
                               list ("M&ove", MoveCmd),
                               list ("&Copy", CopySlctCmd),
                               list ("&Delete", DeleteSlctCmd),
                               list ("&Modify", ModifySlctCmd),
                               vcWv.Separator (),
                               list ("&Run", RunSlctCmd),
                               list ("&Update", UpdateSlctCmd),
                               list ("&Edit", EditSlctCmd),
                               list ("Mana&ge", ManageSlctCmd),
                               list ("Rese&t", ResetSlctCmd)
                             );
depend_add_menu := vcWv.MakeMenu ("Add Depend Menu",
                             list ("&Draw", AddLineCmd),
                             list ("&From",    AttachFromCmd),
                             list ("&To",      AttachToCmd),
                             vcWv.Separator (),
                             dep_mode_entry
                           );
depend_menu := vcWv.MakeMenu ("Dependency Menu",
                             list ("&Add", depend_add_menu),
                             list ("&Modify", ModifySlctCmd),
                             list ("&Stretch", StretchCmd),
                             list ("&Delete", DeleteSlctCmd),
                             vcWv.Separator (),
                             vcWv.CheckedOption 
                                    ("Curved", CurvedDependCmd, FALSE)
                           );

customize_menu := vcWv.MakeMenu ("Customize Menu",
                                list ("&Viewflow", CustomizeVflowCmd),
                                list ("vfl &Library", CustomizeVflCmd),
                                list ("Text &Colors", 
                                                CustomizeTextColorsCmd),
                                list ("&Icon Editor", IconEditorCmd)
                               );

flow_menu := vcWv.MakeMenu ("Flow Menu",
                              vcWv.Pin (),
                              list ("&Make", MakeCmd),
                              list ("&Update All", UpdateAllCmd),
                              list ("&Reset All", ResetAllCmd),
                              list ("&Cancel Make", CancelMakeCmd),
                              list ("Chec&k", CheckCmd),
                              vcWv.Separator (),
                              list ("&Global Symbols", GlobalSymbolCmd),
                              list ("&Log Window", LogWindowCmd),
                              list ("&ViewData", ViewdataCmd),
                              vcWv.Separator (),
                              list ("Customi&ze", customize_menu)
                            );

file_menu := vcWv.MakeMenu ("File Menu",
                               list ("&New", NewCmd),
                               list ("&Open", OpenCmd),
                               list ("&Write", WriteCmd),
                               list ("Write &To", WriteToCmd),
                               vcWv.Separator (),
                               list ("&Flow List", FlowListCmd)
                            );
                           
main_menu := vcWv.MakeMenu ("main menu",
                             vcWin.RedSquareEntry,
                             list ("&File", file_menu),
                             list ("&View", view_menu),
                             list ("&Object", object_menu),
                             list ("&Dependency", depend_menu),
                             list ("Flo&w", flow_menu)
                          );
vcFac.SetMenus (fac, main_menu);

/* now the popup menus */

TaskMenu := vcWv.MakeMenu ("Task Menu",
                               list ("M&ove", vge.MoveCmd),
                               list ("&Copy", CopySlctCmd),
                               list ("&Delete", DeleteSlctCmd),
                               list ("&Modify", ModifySlctCmd),
                               vcWv.Separator (),
                               list ("&Run", RunSlctCmd),
                               list ("&Update", UpdateSlctCmd),
                               list ("Rese&t", ResetSlctCmd));

                             
DataMenu := vcWv.MakeMenu ("Data Menu",
                               list ("M&ove", vge.MoveCmd),
                               list ("&Copy", CopySlctCmd),
                               list ("&Delete", DeleteSlctCmd),
                               list ("&Modify", ModifySlctCmd),
                               vcWv.Separator (),
                               list ("&Edit", EditSlctCmd),
                               list ("Mana&ge", ManageSlctCmd),
                               list ("Rese&t", ResetSlctCmd));

StartStopMenu := vcWv.MakeMenu ("Startstop Menu",
                               list ("M&ove", vge.MoveCmd),
                               list ("&Write", WriteCmd),
                               vcWv.Separator (),
                               list ("&Make", MakeCmd),
                               list ("&Update All", UpdateAllCmd),
                               list ("&Reset All", ResetAllCmd));

DependMenu := vcWv.MakeMenu ("Depend Menu",
                             list ("&Modify", ModifySlctCmd),
                             list ("&Stretch", StretchCmd),
                             list ("&Delete", DeleteSlctCmd));
