/* This func will be called from vdm.CollCompose(coll_obj) by vdm */

function PostPackColComposeFunc(cntx, obj) {
    vdraw_class := vdm.CntxFindClass(cntx, "ViewDraw Design");
    design := vdm.ObjGetName(obj);
    location := vdm.ObjGetLocation(obj);

    /* Create handle for viewdraw collection and find it */
    vdraw_obj := vdm.ObjCreate(design, vdm.VersLatest, vdraw_class, 
                     nil, cntx, nil );
    if (!vdm.ObjFind(vdraw_obj, nil, location))
    vlEx.Throw(vlEx.FAILURE, "Allegro Collection:PostPackColComposeFunc",
               vlErrSev.Error, 
               sprintf("Could not find Schematic Collection %s in location %s",
                       design, location));

    /* Create handle for pcb dictionary collection and find it */
    dict_obj := vdm.ObjCreate(design, vdm.VersLatest, vdraw_class, 
                     nil, cntx, list(cons(`NAME, design)));

    if (!vdm.ObjFind(dict_obj, nil, location))
    vlEx.Throw(vlEx.FAILURE, "Allegro Collection:PostPackColComposeFunc",
               vlErrSev.Error, 
               sprintf("Could not find Pcb Dictionary Collection in location %s",
                       location));

    return_list := list(vdraw_obj, dict_obj);
    wir_class := vdm.CntxFindClass(cntx, "Wir");
    declare class, block, sheet, location, wir_obj;
    foreach(member; vdm.CollLoopMember(vdraw_obj)) {
        class = vdm.ObjGetClass(member);
        class_name := vdm.ClassGetName(class);
        if (equal(class_name, "Schematic")) {
            block = vdm.ObjGetAttr(member, "BLOCK");
            sheet = vdm.ObjGetAttr(member, "SHEET");
            location = vdm.ObjGetLocation(member);
            wir_obj = vdm.ObjCreate(block + "." + sheet, 
                                    vdm.VersLatest, wir_class, 
                                    location, cntx, list(cons(`BLOCK, block),
                                                         cons(`SHEET, sheet)));
            
            return_list = cons(wir_obj, return_list);
        }
    }
    return return_list;
}
