/***********************************************************************
.INDEX  Define the Harris EDA Viewdraw Utils Cprobe menu.

.DESCRIPTION
.D      Define the Cprobe menu for sending messages to the Harris EDA
.D      physical design packages: FINESSE MCM and SCICARDS.
.D
.D      Currently the menu contains the following entries:
.D
.D              HighlightNet
.D              HighlightComp
.D              SelectNet
.D              SelectComp
.D              PlaceComp
.D              RouteNet
.D              DispNetProp
.D              GetNetProp
.D

.HISTORY	
.H	Programmer:	James Dolce	05/21/93
.H	   Project:	ITC002
.H
.H	Programmer:	Tony Casciano	11/15/93
.H	   Project:	ITC002
.H	   Description: Changed Menu indexes from 1,2,3, and 4 to
.H			0,1,2,3 when replacing entries in probe_menu

.COPYRIGHT 	1993 by Harris EDA Division
***********************************************************************/
vipcMsgVL_HIGHLIGHT := 98;

SrcIpcCntx := vipc.Init(vipc.TidVDRAW);

function cpr_sel_comp(DrawData, Event)
{
    vipc.Send(vipcMsgVL_HIGHLIGHT, SrcIpcCntx, vipc.CntxFid, "Comp 0",
              vipc.FlgMULTI);
}

function cpr_sel_net(DrawData, Event)
{
    vipc.Send(vipcMsgVL_HIGHLIGHT, SrcIpcCntx, vipc.CntxFid, "Net 1",
              vipc.FlgMULTI);
}

function cpr_disp_comp(DrawData, Event)
{
    vipc.Send(vipcMsgVL_HIGHLIGHT, SrcIpcCntx, vipc.CntxFid, "Comp 2",
              vipc.FlgMULTI);
}

function cpr_disp_net(DrawData, Event)
{
    vipc.Send(vipcMsgVL_HIGHLIGHT, SrcIpcCntx, vipc.CntxFid, "Net 3",
              vipc.FlgMULTI);
}

function cpr_move_comp(DrawData, Event)
{
    vipc.Send(vipcMsgVL_HIGHLIGHT, SrcIpcCntx, vipc.CntxFid, "Comp 4",
              vipc.FlgMULTI);
}

function cpr_rte_net(DrawData, Event)
{
    vipc.Send(vipcMsgVL_HIGHLIGHT, SrcIpcCntx, vipc.CntxFid, "Net 5",
              vipc.FlgMULTI);
}

function cpr_disp_net_prop(DrawData, Event)
{
    vipc.Send(vipcMsgVL_HIGHLIGHT, SrcIpcCntx, vipc.CntxFid, "Net 6",
              vipc.FlgMULTI);
}

function cpr_get_net_prop(DrawData, Event)
{
    vipc.Send(vipcMsgVL_HIGHLIGHT, SrcIpcCntx, vipc.CntxFid, "Net 7",
              vipc.FlgMULTI);
}

CprSelCompCmd := vcWv.Cmd (fac, cpr_sel_comp, "selectcomp");
CprSelNetCmd := vcWv.Cmd (fac, cpr_sel_net, "selectnet");
CprDispCompCmd := vcWv.Cmd (fac, cpr_disp_comp, "displaycomp");
CprDispNetCmd := vcWv.Cmd (fac, cpr_disp_net, "displaynet");
CprMoveCompCmd := vcWv.Cmd (fac, cpr_move_comp, "movecomp");
CprRteNetCmd := vcWv.Cmd (fac, cpr_rte_net, "rtenet");
CprDispNetPropCmd := vcWv.Cmd (fac, cpr_disp_net_prop, "dispnetprop");
CprGetNetPropCmd := vcWv.Cmd (fac, cpr_get_net_prop, "getnetprop");
/*
   Replace the existing cprobe entries and add the remaining new entries
*/
vcMenu.ReplaceEntry(probe_menu, 1, "SelectComp", CprSelCompCmd);
vcMenu.ReplaceEntry(probe_menu, 2, "SelectNet", CprSelNetCmd);
vcMenu.ReplaceEntry(probe_menu, 3, "HighlightComp", CprDispCompCmd); 
vcMenu.ReplaceEntry(probe_menu, 4, "HighlightNet", CprDispNetCmd);
vcMenu.AppendEntry(probe_menu, "PlaceComp", CprMoveCompCmd); 
vcMenu.AppendEntry(probe_menu, "RouteNet", CprRteNetCmd); 
vcMenu.AppendEntry(probe_menu, "DispNetProp", CprDispNetPropCmd);
vcMenu.AppendEntry(probe_menu, "GetNetProp", CprGetNetPropCmd);
/*
   Load the vdr_nav.vs file for handling attribute addition.
*/
load ("vdr_nav.vs");


