/*
 * $Id: ic.vs,v 1.3 1994/12/27 17:51:55 sandy Stab $
 * Name: IC.VS
 *
 * Facility: divafwd
 * 
 * Functional Description: 
 *    Viewscript file for encapsulating ic integration tools in viewdraw
 *    Also, create itc context for lvsnav to be able to send skill commands
 *    through lvsnav to Opus
 *
 * Environment:
 *    UNIX.
 *     
 * Author:  
 *   Sandy Lucas - July, 1994
 *
 * Modified by: 
 * Who            Version   When      What
 * SAL            1.0       07/22/94  Initial creation
 * 
 * 
 * Copyright (c) 1994 by Viewlogic Systems, Inc.
 */
set_stdout(TRUE);

vcWv.MakeEnum("vfOnOffVT", list("Off", "On"));
vcWv.MakeEnum("vfToolsVT", list("HLDS", "Dracula", "DIVA"));

function rundiva(data, event, design, levels, v, w, p, n, e, f, netlist, xref,
                 log)
{
  set_stdout(TRUE);

  function_call := "divafwd ";
  if (!string_eq(levels, ""))
     function_call = function_call + "-l " + levels;
  if (v == vfOnOff.On)
     function_call = function_call + "+v ";
  else function_call = function_call + "-v ";
  if (w == vfOnOff.On)
     function_call = function_call + "+w ";
  else function_call = function_call + "-w ";
  if (p == vfOnOff.On)
     function_call = function_call + "+p ";
  else function_call = function_call + "-p ";
  if (e == vfOnOff.On)
     function_call = function_call + "+e ";
  else function_call = function_call + "-e ";
  if (f == vfOnOff.On)
     function_call = function_call + "+f ";
  else function_call = function_call + "-f ";
  if (n == vfOnOff.On)
     function_call = function_call + "+n ";
  else function_call = function_call + "-n ";
  if (!string_eq(netlist, ""))
     function_call = function_call + "-out " + netlist;
  if (!string_eq(xref, ""))
     function_call = function_call + "-xref " + xref;
  if (!string_eq(log, ""))
     function_call = function_call + "-log " + log;
  if (!string_eq(design, "")) {
     function_call = function_call + design;
     vcWin.System(nil, function_call, nil, FALSE, vcSysOutput.Viewtext, nil, 
                  nil, nil, nil);
  }
  else error("You must enter a design name",1);
}

divacmd := vcWv.Cmd(vcWin.fac, rundiva, "divafwd", "DIVA Forward",
          vcWv.Param("Design Name", vlStringVT, vcWv.Sticky, ""),
          vcWv.Param("Levels", vlStringVT, vcWv.Sticky, "",vcWv.Secondary),
          vcWv.Param("Verbose Status Reports", vfOnOffVT, vcWv.Sticky, 
                     vfOnOff.On),
          vcWv.Param("Display Warnings/Errors", vfOnOffVT, vcWv.Sticky, 
                     vfOnOff.On),
          vcWv.Param("Unconnected Pin Warnings", vfOnOffVT, vcWv.Sticky, 
                     vfOnOff.On),
          vcWv.Param("Generate Net Statements", vfOnOffVT, vcWv.Sticky, 
                     vfOnOff.On),
          vcWv.Param("Expression Evaluation", vfOnOffVT, vcWv.Sticky, 
                     vfOnOff.On),
          vcWv.Param("Device Fixing", vfOnOffVT, vcWv.Sticky, 
                     vfOnOff.Off),
          vcWv.Param("Netlist File name", vlStringVT, vcWv.Sticky, "",
                     vcWv.Secondary),
          vcWv.Param("Cross Reference File Name", vlStringVT, vcWv.Sticky, "",
                     vcWv.Secondary),
          vcWv.Param("Log File Name", vlStringVT, vcWv.Sticky, "",
                     vcWv.Secondary));

function runlvs(data, event, design, lib, f, l, x, t, o)
{
  set_stdout(TRUE);

  function_call := "runlvs ";
  if (f == vfOnOff.On)
     function_call = function_call + "+f ";
  else function_call = function_call + "-f ";
  if (l == vfOnOff.On)
     function_call = function_call + "+l ";
  else function_call = function_call + "-l ";
  if (x == vfOnOff.On)
     function_call = function_call + "+x ";
  else function_call = function_call + "-x ";
  if (t == vfOnOff.On)
     function_call = function_call + "+t ";
  else function_call = function_call + "-t ";
  if (o == vfOnOff.On)
     function_call = function_call + "+o ";
  else function_call = function_call + "-o ";
  
  if (!string_eq(design, "")) {
     function_call = function_call + design + " ";
  }
  else error("You must enter a design name","");

  if (!string_eq(lib, "")) {
     function_call = function_call + lib;
     vcWin.System(nil, function_call, nil, FALSE, vcSysOutput.Viewtext, nil, 
                  nil, nil, nil);
  }
  else error("You must enter a Cadence library name","");

}

runlvscmd := vcWv.Cmd(vcWin.fac, runlvs, "runlvs", "Run LVS",
          vcWv.Param("Design Name/Cell Name", vlStringVT, vcWv.Sticky, ""),
          vcWv.Param("Cadence Library Name", vlStringVT, vcWv.Sticky, ""),
          vcWv.Param("Device Fixing", vfOnOffVT, vcWv.Sticky, 
                     vfOnOff.On),
          vcWv.Param("Netlist Layout", vfOnOffVT, vcWv.Sticky, 
                     vfOnOff.On),
          vcWv.Param("Create Xref", vfOnOffVT, vcWv.Sticky, 
                     vfOnOff.On),
          vcWv.Param("Terminal Correspondence", vfOnOffVT, vcWv.Sticky, 
                     vfOnOff.On),
          vcWv.Param("Overwrite si.env file", vfOnOffVT, vcWv.Sticky, 
                     vfOnOff.On));

function runhldfwd(data, event, design, levels, lc, p, v, w, xin, netlist, 
                   xref, log, cfg)
{
  set_stdout(TRUE);

  function_call := "hldfwd ";
  if (!string_eq(levels, ""))
     function_call = function_call + "-l " + levels;
  if (lc == vfOnOff.On)
     function_call = function_call + "+lc ";
  else function_call = function_call + "-lc ";
  if (p == vfOnOff.On)
     function_call = function_call + "+p ";
  else function_call = function_call + "-p ";
  if (v == vfOnOff.On)
     function_call = function_call + "+v ";
  else function_call = function_call + "-v ";
  if (w == vfOnOff.On)
     function_call = function_call + "+w ";
  else function_call = function_call + "-w ";
  if (xin == vfOnOff.On)
     function_call = function_call + "+xin ";
  else function_call = function_call + "-xin ";
  if (!string_eq(netlist, ""))
     function_call = function_call + "-out " + netlist;
  if (!string_eq(xref, ""))
     function_call = function_call + "-xref " + xref;
  if (!string_eq(log, ""))
     function_call = function_call + "-log " + log;
  if (!string_eq(cfg, ""))
     function_call = function_call + "-cfg " + cfg;
  if (!string_eq(design, "")) {
     function_call = function_call + design;
     vcWin.System(nil, function_call, nil, FALSE, vcSysOutput.Viewtext, nil, 
                  nil, nil, nil);
  }
  else error("You must enter a design name",1);
}

hldcmd := vcWv.Cmd(vcWin.fac, runhldfwd, "hldfwd", "HLD Forward",
          vcWv.Param("Design Name", vlStringVT, vcWv.Sticky, ""),
          vcWv.Param("Levels", vlStringVT, vcWv.Sticky, "",vcWv.Secondary),
          vcWv.Param("Symbol/pin lowercase", vfOnOffVT, vcWv.Sticky, 
                     vfOnOff.Off),
          vcWv.Param("Unconnected Pin Warnings", vfOnOffVT, vcWv.Sticky, 
                     vfOnOff.On),
          vcWv.Param("Verbose Status Reports", vfOnOffVT, vcWv.Sticky, 
                     vfOnOff.On),
          vcWv.Param("Display Warnings/Errors", vfOnOffVT, vcWv.Sticky, 
                     vfOnOff.On),
          vcWv.Param("Read existing xref file", vfOnOffVT, vcWv.Sticky, 
                     vfOnOff.Off),
          vcWv.Param("Netlist File name", vlStringVT, vcWv.Sticky, "",
                     vcWv.Secondary),
          vcWv.Param("Cross Reference File Name", vlStringVT, vcWv.Sticky, "",
                     vcWv.Secondary),
          vcWv.Param("Log File Name", vlStringVT, vcWv.Sticky, "",
                     vcWv.Secondary),
          vcWv.Param("Configuration File", vlStringVT, vcWv.Sticky, "",
                     vcWv.Secondary));
          
function runparaview(data, event, tool, design, c, v, w, pdata, oat, xref, cfg,
    log)
{
  set_stdout(TRUE);

  function_call := "paraview ";

  if (c == vfOnOff.On)
     function_call = function_call + "+c ";
  else
     function_call = function_call + "-c ";
  if (v == vfOnOff.On)
     function_call = function_call + "+v ";
  else
     function_call = function_call + "-v ";
  if (w == vfOnOff.On)
     function_call = function_call + "+w ";
  else
     function_call = function_call + "-w ";

  if (tool == vfTools.HLDS) {
    if (!string_eq(pdata, ""))
      function_call = function_call + "-hldsdata " + pdata + " ";
    if (!string_eq(oat, ""))
      function_call = function_call + "-hldsoat " + oat + " ";
    if (!string_eq(xref, ""))
      function_call = function_call + "-hldsxref " + xref + " ";
    if (!string_eq(cfg, ""))
      function_call = function_call + "-hldscfg " + cfg + " ";
  }
  else if (tool == vfTools.Dracula) {
    if (!string_eq(pdata, ""))
      function_call = function_call + "-dracdata " + pdata + " ";
    if (!string_eq(oat, ""))
      function_call = function_call + "-dracoat " + oat + " ";
    if (!string_eq(xref, ""))
      function_call = function_call + "-dracxref " + xref + " ";
    if (!string_eq(cfg, ""))
      function_call = function_call + "-draccfg " + cfg + " ";
  }
  else if (tool == vfTools.DIVA) {
    if (!string_eq(pdata, ""))
      function_call = function_call + "-divadata " + pdata + " ";
    if (!string_eq(oat, ""))
      function_call = function_call + "-divaoat " + oat + " ";
    if (!string_eq(xref, ""))
      function_call = function_call + "-divaxref " + xref + " ";
    if (!string_eq(cfg, ""))
      function_call = function_call + "-divacfg " + cfg + " ";
  }

  if (!string_eq(log, ""))
    function_call = function_call + "-log " + log + " ";

  if (!string_eq(design, ""))
    function_call = function_call + design + " ";

  if (tool == vfTools.HLDS) 
    function_call = function_call + "hlds";
  else if (tool == vfTools.Dracula) 
    function_call = function_call + "drac";
  else if (tool == vfTools.DIVA) 
    function_call = function_call + "diva";

  if (!string_eq(design, "")) {
    vcWin.System(nil, function_call, nil, FALSE, vcSysOutput.Viewtext, nil, 
                 nil, nil, nil);
  }
  else
    error("You must enter a design name",1);
}

function getwdesign(data)
{
  cur_design := vscript.getenv("WDESIGN");
}

paracmd := vcWv.Cmd(vcWin.fac, runparaview, "paraview", "Paraview",
          vcWv.Param("Parasitic Source Tool", vfToolsVT, vcWv.Sticky, 
                     vfTools.HLDS,
                     "Choose source tool which created the parasitic data file"),
          vcWv.Param("Design Name", vlStringVT, vcWv.Dynamic,
                     getwdesign, vcCmdline.fac,
                     "Top-level name of the design"),
          vcWv.Param("Overwrite 'CAP' OAT", vfOnOffVT, vcWv.Sticky, 
                     vfOnOff.On,
                     "Overwrite the 'CAP' OAT with the parasitic value being read in"),
          vcWv.Param("Verbose Status Reports", vfOnOffVT, vcWv.Sticky, 
                     vfOnOff.On,
                     "Display all design statistics to the screen"),
          vcWv.Param("Display Warnings/Errors", vfOnOffVT, vcWv.Sticky, 
                     vfOnOff.On,
                     "Display warning and errors to the screen"),
          vcWv.Param("Parasitic Data File", vlStringVT, vcWv.Sticky, "",
                     vcWv.Secondary,
                     "[Optional] Output file produced by parasitic extraction tool"),
          vcWv.Param("OATs File", vlStringVT, vcWv.Sticky, "", vcWv.Secondary,
                     "[Optional] OATs file to place parasitic values into"),
          vcWv.Param("Cross Reference File", vlStringVT, vcWv.Sticky, "",
                     vcWv.Secondary,
                     "[Optional] Xref file created while netlisting to parasitic extraction tool"),
          vcWv.Param("Configuration File Name", vlStringVT, vcWv.Sticky, "",
                     vcWv.Secondary,
                     "[Optional] Name of the configuration file to use"),
          vcWv.Param("Log File Name", vlStringVT, vcWv.Sticky, "",
                     vcWv.Secondary,
                     "[Optional] Name of log file to record this session"));
          
ic_menu := vcWv.MakeMenu ("IC Integration",
                          list ("DIVA forward", divacmd),
                          list ("Run LVS", runlvscmd),
                          list ("HLD forward", hldcmd),
                          list ("Paraview", paracmd));

vcMenu.AppendEntry(util_menu, "IC Integration", ic_menu);

/**************************************************************************/
/* ipc functions for communicating with lvsnav                            */
/**************************************************************************/

/* create viewdraw source context */
vdrawSrcCntx := vitc.SrcCntxCreate("Viewdraw", nil);

lvsnavDestCntx := nil;


/* function which sends an itc message to lvsnav where the message is the
   skill command to be passed along to Opus */
function sendSkill( data, event, skillcmd) {
   printf("in sendSkill function\n");
   if (lvsnavDestCntx == nil) {
      /* create lvsnav destination context */
      lvsnavDestCntx := vitc.CntxCreate(vipc.GidANY, vipc.UidANY, vipc.FidANY,
         "LVSNav", nil, vipc.HnmANY, vipc.PidANY, vipc.CidANY);
   }
   if ((lvsnavDestCntx != nil) && (vdrawSrcCntx != nil) && (skillcmd != nil)) {
      ret := vitc.Send("Skill Command", vdrawSrcCntx, lvsnavDestCntx, 
                skillcmd, vipc.FlgDIRECT);
      if (ret == vitc.Failure) {
         itcerr := vitc.ErrGet();
         vlErr.Out(nil, itcerr);
      }
   }
   else printf("No lvsnav itc context\n");
}

sendSkillCmd := vcWv.Cmd(vcWin.fac, sendSkill, "sendSkill", "Send Skill Cmd",
   vcWv.Param("Skill Command", vlStringVT, vcWv.Sticky, ""));

