/* autofill at col 60 */

adk_help_DEVICE := "";
adk_help_LEVEL := "";
adk_help_PARTS := "";
adk_help_PINNUMBER := "";
adk_help_PINSWAP := "";
adk_help_PINTYPE := "";
adk_help_PKG_TYPE := "";
adk_help_REFDES := "";

adk_help_ALT_SYMBOLS :=
"ALT_SYMBOLS:

Attach to a device (through a device file). List of
alternate package symbol names that can be substituted for
the primary package symbol during interactive placemnt.

";

adk_help_AUTO_RENAME :=
"AUTO_RENAME:

Attach to a reference designator (component). Indicates the
component is to be included in the next automatic renaming
process.

Value is TRUE or FALSE.

";


adk_help_BOARD_THICKNESS :=
"BOARD_THICKNESS:

Generated automatically by Allegro and attached to a board
(design).  Specifies board (or layout) thickness. Allegro
computes the thickness by adding all layer thicknesses in
the cross section.  Cadence recommends that you do not
assign the BOARD_THICKNESS property.

";


adk_help_BUS_NAME :=
"BUS_NAME:

Attach to a net. Name of a net to be treated as a bus by
interactive and automatic routing.

Value is a string.

";

adk_help_COMPONENT_WEIGHT :=
"COMPONENT_WEIGHT:

Attach to a reference designator (component). Used by
automatic placement to determine the relative importance of
components.  Value is an integer from 0 to 100. All
components have a default weight of 50.

";

adk_help_CURRENT :=
"CURRENT:

Attach to a component. Defines the current consumed by the
component in amperes.

Used by DF/Thermax and DF/Viable.
";

adk_help_C_TEMPERATURE :=
"C_TEMPERATURE:

Generated by DF/Thermax and attached to a reference
designator (component).  Defines the case temperature for
the component in degrees Centrigrade.

";

adk_help_DELAY_RULE :=
"DELAY_RULE:

Attach to a net. The delay or connection length restrictions
between any two pins in a net or an entire net (from the
first pin to the last pin in the net).

Used by automatic routing.

The format of the DELAY_RULE string is

DELAY_RULE {[refdes1.pin1]:[refdes2.pin2]:[min dealy]:[max
delay]} ...; netname

\n";

adk_help_DENSE_COMPONENT :=
"DENSE_COMPONENT:

Attach to a reference designator. Indicates the component is
heavily connected to other components.  Rats nesting
attempts to put the pin on these components at an end of
their net schedule.  Also, the automatic router routes
connections to a dense component, first.

Value is TRUE/FALSE.

";

adk_help_DEPTH_STOP :=
"DEPTH_STOP:

Attach to a device (through a device file).  Describes the
depth (an integer in database units) to which the component
is to be inserted on the design.

Used by the Allegro CIMLink Interface.
Refer to Cadence documentation for more details.
";

adk_help_DEVICE_LABEL :=
"DEVICE_LABEL:

Attach to a device (through the device file). Identifies the
device using the GenRad Circuit Description Lanugage (CDL)
and reflects the device (component) name in the ATE library.
Used by the Allegro GenRad Interface

The syntax for the DEVICE_LABEL property in the device file is

  PACKAGEPROP DEVICE_LABEL <property value>

Permissable values are: NC, RV, QN, QP, BOARD, ICnn, ICAnn,
DICnn, UKnn, GD, or the device name for ICs (where nn equals
the number of pins on the device).

";



adk_help_DIFFERENTIAL_PAIR :=
"DIFFERENTIAL_PAIR:

Attach to a net. The name of the differential pair. To
create a dirrential pair, assign two nets with a
DIFFERENTIAL_PAIR attribute that have the same name. 

Used by automatic routing and constraint checking.
";

adk_help_DIFFP_2ND_LENGTH := 
"DIFFP_2ND_LENGTH:

Attach to a net. The secondary differential pair maximum
line-to-line length. This is the maximum length a pair of
nets can run at a distance apart specified by the Secondary
Differential Pair Maximum line-to-line separation.

Used by automatic routing and DRC checking. 
";

adk_help_DIFFP_LENGTH_TOL  :=
"DIFFP_LENGTH_TOL:

Attach to a net. The allowable difference between the total
lengths of two differential pair nets. The value is either 
an absolute distance or a percentage of total net length. 

Used by automatic routing and DRC checking. 
";


adk_help_DRIVER_TERM_VAL :=
"DRIVER_TERM_VAL:

Attach to a net. The value of a terminator component to be
added to the driver end of the net.  Used by the automatic
terminator assignment program.

";



adk_help_ECL  :=
"ECL:

Attach to a net. Identifies a high speed net. Value is
either TRUE or FALSE. If the ECL property is attached to a
net, Allegro assumes a stub length of zero and a ratsnest
schedule of SOURCE_LOAD_DAISY_CHAIN. 

You can override this property by assigning the STUB_LENGTH
property or the RATSNEST_SCHEDULE property. 

Used by automatic routing and ratsnest scheduling. 

";

adk_help_ECL_TEMP  :=
"ECL_TEMP:

Attached to nets to be processed by the terminator
assignment program in incremental mode. 

Used by automatic routing and set by Allegro.

";


adk_help_ELECTRICAL_CONSTRAINT_SET :=
"ELECTRICAL_CONSTRAINT_SET:

Attach to a net. The name of the Electrical Constraint Set
to apply to the net. Any net that does not have a
ELECTRICAL_CONSTRAINT_SET property has the DEFAULT
Electrical Contraint Set.

";

adk_help_EXTERNAL_NOISE :=
"EXTERNAL_NOISE:

Attach to a net.  The value, typically in millivots (mV)
that represents noise not predicted by DF/SigNoise.
DF/SigNoide subtracts the external noise vlaue, along with
other sources (such as undershoot, crosstalk, thermal shift,
and simultaneous switching noise) from the noise immunity to
determine the noise margin.

";


adk_help_FAILURE_RATE :=
"FAILURE_RATE:

Generated by DF/Viable and attached to areference designator
(componnent).  The component's rate in failures in units
that correspond to the calcualtion method (usually failures
per million hours). 

Used by DF/Viable.

";

adk_help_FILLET :=
"FILLET:

Attach to connect lines. Indicates the connect lines are for
filleting around a pad or join line. Prevents DRC from
identifying dangling connect lines. 

Value is either TRUE or FALSE.

This property is assigned by the pad fillet glossing
function.

";


adk_help_FIXED  :=
"FIXED:

Attach to a net. Indicates the automatic router is not to
rip up connections in the net and that glossing is not to be
performed on the net.

Value is either TRUE or FALSE.
";


adk_help_FIX_ALL :=
"FIX_ALL:

Attach to a reference designator (component). Indicates that
no swapping can be performed on this component, its
functions, or its pins.

";

adk_help_GROUP :=
"GROUP:

Attach to a function designator (gate).  The name of the
group to which component belongs.  Allegro assigns functions
that have the same GROUP property value to the same
component.  The grouping of components lets you control the
assignment of functions to components.

";

adk_help_HARD_LOCATION :=
"HARD_LOCATION:

Attach to a reference designator (component) or function
designator (gate).  Prevents the reference designator of a
component from being automaticaly or interactively
renamed. 

Value is either TRUE or FALSE.

";

adk_help_HEAT_SINK_FACTOR :=

"HEAT_SINK_FACTOR:

Attach to a component. A number used as a multiplier to
represent increased surface area. 

Used by DF/Thermax.

";


adk_help_HEIGHT :=
"HEIGHT:

Attach to a device (through a device file).  The maximum
height of a component in design units.  Used by DRC to
determine spacing violations when components are mounted
under each other.

The syntax for the HEIGHT property in a device file is:
   PACKAGEPROP HEIGHT <height value>

";

adk_help_INSERTION_CODE :=
"INSERTION_CODE:

Attach to a device (through a device file). Specifies the
Universal Component Insertion Machine to be used. Used by
the Allegro CIMLink and SDRC interfaces.

The syntax of the INSERTION_CODE property in the device file
is

   PACKAGEPROP INSETRTION_CODE <property value>

Permissable values are: VCD, RADILA, DIP, MULTIMOD, SIP,
ZIP, AXIAL, and SMD.

";

adk_help_J_TEMPERATURE :=
"J_TEMPERATURE:

Generated by DF/Thermax and attached to a component. Defines
the junction temperature for the component in degrees
centigrade. 

";


adk_help_LOAD_TERM_VAL :=
"LOAD_TERM_VAL:

Attach to a net.  The value of a terminator component to be
added to the load end of the net.  Used by the terminator
assignment program.

";

adk_help_LOGICAL_PATH :=
"LOGICAL_PATH:

Automaticaly generated and attached to a function designator
(gate) by the fet2a process. It is used to back annotate
schematics.  You should not change this attribute
interactively.

";


adk_help_MATCHED_DELAY :=
"MATCHED_DELAY:

Attached to a net. Specifies connections that are part of a
matched dealy group. You can specify a matched:
    - total net delay
    - connection delays between nets
    - connection delays within a net
    - connection dealys within and between nets

Allegro applies the delay to sets of driver-receiver pairs
for the matched nets.  The MATCHED_DELAY attribute overrides
any Matched Delay constraint defined in the net's electrical
constraint set.

Refer the Allegro Properties Manual for a complete
description of the actual formats.

";

adk_help_MAX_BOND_LENGTH :=
"MAX_BOND_LENGTH:

Attach to a net or connect line. The maximum length of
bonding wire for a net.  A bonding wire is any connect line
on an Etch subcalss fo type bonding wire.

";

adk_help_MAX_BVIA_STAGGER :=
"MAX_BVIA_STAGGER:

Attach to a net.  The maximum distance between the connect
point of one pin or via (the pin or via's x,y location) and
the connect point of the other, where the two pins or vias
are on the same net and have single connect line joining
them.

";

adk_help_MAX_EXT_NOISE :=
"MAX_EXT_NOISE:

Attach to a net.  The maximum external noise tolerated by
this net.  Allegro checks this value against values
established for the EXTERNAL_NOISE attribute.  The default
value is 20 mV.

";


adk_help_MAX_FINAL_SETTLE :=
"MAX_FINAL_SETTLE:

Attach to a net.  The maximum transmission line wire delay,
plus the receiver distortions in the rise-or-fall time, and
the receiver settling time.  The default value is 4 nS.

";

adk_help_MAX_FIRST_SWITCH :=
"MAX_FIRST_SWITCH:

Attach to a net.  The maximum transmission line wire delay
plus distortions differing from the nominal driver
rise-or-fall time in the reciever rise-or-fall.  The default
value is 1 nS.

";


adk_help_MAX_OHM_LOSS :=
"MAX_OHM_LOSS:

Attach to a net.  The maximum ohmic loss tolerated by the
net.  Ohmic loss is a voltage drop across a resistor as
current passed through it.  Printed circuit board etch has a
measurable resistance, and due to the signal current, some
voltage is lost on the way to the receiver pin.  The default
value is 20 mV.

";


adk_help_MAX_OVERSHOOT :=
"MAX_OVERSHOOT:

Attach to a net.  The maximum voltage overshoot tolerated by
the net.  The default value is 600 mV.

";



adk_help_MAX_PARALLEL :=
"MAX_PARALLEL:

Attach to a net or connect line.  The value is a character
string of up to four differnt lengths and distances.
Seperate each length-distance value by a colon (:).
Seperate each length-distance pair by semi-colon (;). 
For example: 2:4;3:5;10:10;200:20

";

adk_help_MAX_PEAK_BXTALK :=
"MAX_PEAK_BXTALK:

Attach to a net.  The maximum backward crosstalk from any
other single neighbor net, tolerated by this net.
Crosstalk is the transmission of a signal from one etch
trace to another by electromagnetic field effects.  On a
printed circuit board, parallel etch can exhibit significant
crosstalk.  Backward crosstalk is considered to be an active
line that causes noise in a parallel trace propagating in
the opposite direction as the active trace signal.  The
default value is 2250 mV.

";


adk_help_MAX_PEAK_FXTALK :=
"MAX_PEAK_FXTALK:

Attach to a net.  The maximum forward crosstalk tolerated by
this net from any other single neighbor net.  The default
value is 250 mV.

";


adk_help_MAX_POWER_DISS  :=
"MAX_POWER_DISS:

Attach to a device (through a device file), or a component.
The maximum power dissipation in watts for the component. If
a value is not set on the component, then 'netin' attaches the
PACKAGEPROP MAX_POWER_DISS from the device file, if one
exists. If this property is attached directly to the
component, this property overrides one taken from the device
file. 

Used by DF/Thermax. 

The syntax for the MAX_POWER_DISS property in the device
file is

PACKAGEPROP MAX_POWER_DISS <watts>

";


adk_help_MAX_PROP_DELAY :=
"MAX_PROP_DELAY:

Attach to a net.  The maximum transmission line wire delay.
The default value is 2 nS.

";

adk_help_MAX_SUM_BXTALK :=
"MAX_SUM_BXTALK:

Attach to a net.  The maximum backward crosstalk summed
across all neighbor nets, tolerated by this net.  The
default value is 250 mV.

";

adk_help_MAX_SUM_FXTALK :=
"MAX_SUM_FXTALK:

Attach to a net.  The maximum forward crosstalk summed
across all neighbor nets, tolerated by this net.  The
default value is 250 mV.

";

adk_help_MAX_THERM_SHIFT :=
"MAX_THERM_SHIFT:

Attach to a net.  The maximum thermal shift tolerated by
this net.  Thermal shift is a termperature-induced change in
operating voltage caused by thermal drift.  A silicon
junction at room temperature operates at about 0.6 volts.
This value increases about 2 mV for every degree C of
junction temperature rise.  The junction temperature
differences between driver and receiver is responsible for
thermal shift in logic devices.  The default value is 100mV.

";


adk_help_MAX_UNDERSHOOT :=
"MAX_UNDERSHOOT:

Attach to a net or connect line.  The maximum undershoot
tolerated by this net.  Undershoot is a voltage swing back
into the mid-range after the nominal steady state high or
low level has been crossed.  The default value is 250 mV.

";


adk_help_MAX_VIA_COUNT :=
"MAX_VIA_COUNT:

Attach to a net.  The maximum via count for anet.

";

adk_help_MIN_BOND_LENGTH :=
"MIN_BOND_LENGTH:

Attach to a net or connect line.  The maximum length of
bonding wire for a net.  A bonding wire is any connect line
on an Etch subclass of type bonding wire.

";

adk_help_MIN_BVIA_GAP :=
"MIN_BVIA_GAP:

Attach to a net.  The minumum spacing between the connect
points of two buried vias that do not share a common layer.

";



adk_help_MIN_BVIA_STAGGER :=
"MIN_BVIA_STAGGER:

Attach to a net.  The minimum distance between the connect
pont of one pin or via (the x,y location of the pin or via)
and the connect point of the other, where the two pins or
vias are on the same net and have a single connect line
joining them.

";


adk_help_MIN_LINE_WIDTH :=
"MIN_LINE_WIDTH:

Attach to a net. The minimum width of a net or line.

";


adk_help_MIN_NECK_WIDTH :=
"MIN_NECK_WIDTH:

Attach to a net.  The minimum neck width of a net or line.

";


adk_help_MIN_NOISE_MARGIN :=
"MIN_NOISE_MARGIN:

Attach to a net.  The minimum noise margin tolerated by this
net.  The default value is 0 mV.

";


adk_help_MIN_PROP_DELAY :=
"MIN_PROP_DELAY:

Attach to a net.  The minimum transmission line wire delay.
The default value is 0 nS.

";


adk_help_NET_PHYSICAL_TYPE :=
"NET_PHYSICAL_TYPE:

Attach to a net or a constraint area.  This is the type of
physcial constraint to be applied.

";

adk_help_NET_SPACING_TYPE :=
"NET_SPACING_TYPE:

Attach to a net or constraint area.  The type of the Spacing
Constraint Set to be applied.

";


adk_help_NO_GLOSS :=
"NO_GLOSS:

Attach to a net.  Indicates this net should be automatically
glossed.  

Value is TRUE/FALSE.

";


adk_help_NO_LIN2SHAPE_FAT :=
"NO_LIN2SHAPE_FAT:

Attach to a connect line.  Excludes the line from being
fattened by the fatten command.

Value is TRUE/FALSE.

";


adk_help_NO_MOVE :=
"NO_MOVE:

Attach to a reference designator (component).  Indicates the
component cannot be moved during automatic or interactive
placement, or interactive component swapping.

Value is TRUE or FALSE.

";

adk_help_NO_PIN_ESCAPE :=
"NO_PIN_ESCAPE:

Attach to a symbol, net, or pin. Indicates the Pin Escape
Router is not to place pin escapes on this component, net,
or pin during routing.

Value is TRUE or FALSE.

";

adk_help_NO_RAT :=
"NO_RAT:

Attach to a net.  Indicates nets with this property will not
display ratsnets for unconnected pins. 

Value is TRUE or FALSE.

";

adk_help_NO_RIPUP :=
"NO_RIPUP:

Attach to a net.  Indicates the etch on this net is not to
be ripped up (removed) by the automatic router.  Any
connections on a net added after you assign this property
can be ripped up.

Value is TRUE or FALSE.

";


adk_help_NO_ROUTE :=
"NO_ROUTE:

Attach to net or component.  Inidcates any missing connections on 
this net should not be routed.

Value is TRUE or FALSE.

";

adk_help_NO_SHAPE_CONNECT :=
"NO_SHAPE_CONNECT:

Attach to a pin or via.  When this property is attached to a pin,
Allegro does not create a connection between the pin (that passes
through a shape with the same net) and a shape.  When this property
is attached to avia, Allegro does not create a connection between
the via (that passes though a shpae that is on the same net) and
a shape.

Value is TRUE or FALSE.

";


adk_help_NO_SWAP_GATE :=
"NO_SWAP_GATE:

Attach to a symbol. Indicates the functions within the
component cannot be swapped.  The function stays fixed in
its current slot in the component.

Value is TRUE or FALSE.

";

adk_help_NO_SWAP_GATE_EXT :=
"NO_SWAP_GATE_EXT:

Attach to a function designator.  Thsi function cannot be
swapped with one from another component.  However, it can be
swapped among slots within its current component.

Value is TRUE or FALSE.

";


adk_help_NO_SWAP_PIN :=
"NO_SWAP_PIN:

Attach to a component, gate, or pin.  Indicates that pins on this
component or gate cannot be swapped, either interactvely or
automatically.

Value is TRUE or FALSE.

";

adk_help_NO_TEST :=
"NO_TEST:

Attach to a net.  Indicates that test points are not to be
adde during test point generation.

Value is TRUE or FALSE.

";


adk_help_PACKAGE_THICKNESS :=
"PACKAGE_THICKNESS:

Attach to a symbol or component. The thickness of the
package, which is equivalent to the Z-axis definiton used in
DF/Thermax for package dimensions.

Used by DF/Thermax. 

";


adk_help_PINUSE :=
"PINUSE:

Attach to a pin to indicate its pin type.  This value
overrides any pinuse value specified in the device
file. 

Pinuse code values are: IN, OUT, BI, TRI, OCA, OCI, POWER,
GROUND, NC, and UNSPEC.

";


adk_help_PIN_ESCAPE :=
"PIN_ESCAPE:

Attach to a component. Indicates Allegro is to place a pin
escape on every pin of this component when the Pin Escape
Router is run.  

Value is TRUE or FALSE.

";

adk_help_PLACE_TAG :=
"PLACE_TAG:

Attach to a component. Indicates the component is to be
placed during the next automatic placement session,

Value is TRUE or FALSE.

You must remember to delete this before attempting to place
another group of components.

";

adk_help_PROBE_NUMBER :=
"PROBE_NUMBER:

Attach to a net. A positive integer that represents the test
probe to be used for testing the net.

";

adk_help_RATED_CURRENT :=
"RATED_CURRENT:

Attach to a device (through a device file). The rated
current limit, in amperes.

Used DF/Viable. 

";


adk_help_RATSNEST_SCHEDULE :=
"RATSNEST_SCHEDULE:

Attach to anet. The type of ratsnest calculation to be done
by Allegro for this net.  

The possible values are: MIN_TREE, MIN_DAISY_CHAIN,
SOURCE_LOAD_DAISY_CHAIN.

Refer to the Allegro Properties Manual for more details.

";

adk_help_ROOM :=
"ROOM:

Attach to a component or gate.  Indicates that the gate or
component is to be assigned to a component containing other
gates in the same room.

";

adk_help_ROUTE_PRIORITY :=
"ROUTE_PRIORITY:

Attach to a net.  A positive integer that represents the
routing priority for the net.  Allegro routes the net
according to the priority order.  Nets with the lowest value
number have the higher priority.

";

adk_help_ROUTE_TO_SHAPE :=
"ROUTE_TO_SHAPE:

Attach to a net. Directs Allegro to route pins on a net to
any other point on the net; the router can connect to a
shape or bus that is part of the net. It is used primarily
with power and ground nets.

Value is TRUE or FALSE.

";

adk_help_SAME_NET :=
"SAME_NET:

Attach to a net. Specifies whether elements in the smae net
are to be checked for spacing violations.

Value is TRUE or FALSE.

";

adk_help_SIGNAL_MODEL :=
"SIGNAL_MODEL:

Attach to a component. Name of the packaged device model,
which defines the electrical, I/O models and package
parasitics used by DF/SigNoise to characterize devices for
simulations.

";


adk_help_SLOTNAME :=
"SLOTNAME:

Attached automaticaly to a function by Allegro when loading
a preassigned netlist with netin. During gate assignment,
this slot name is the first choice when choosing the slot in
a component. This slot name is reserved even after gate
assignment and/or swapping, and can then be compared to the
slot that contains the function.

";

adk_help_STUB_LENGTH :=
"STUB_LENGTH:

Attach to ECL nets.  The maximum length allowed for stub, in
database units.  The STUB_LENGTH attribute overrides the ECL
attribute, which indicates the net does not allow stubs. A
value of zero for the STUB_LENGTH attribute means no stubs.

";



adk_help_TH_CB_RES  :=
"TH_CB_RES:

Attach to a device (through a device file), or a component.
The case to board resistance, in degrees Centigrade/watt. 

Used by DF/Thermax and DF/Viable. 

";


adk_help_TH_GLUERES  :=
"TH_GLUERES:

Attach to a device (through a device file), or a component.
The total thermal resistance, in degrees Centigrade/watt, of
the thermal enhancement material between the bottom of the
package and the board. If you do not assign a value, the
default value is infinity. 

Used by DF/Thermax. 

";


adk_help_TH_JC_RES  :=
"TH_JC_RES:

Attach to a device (through a device file). the junction to
case resistance. 

Used by DF/Viable. 

";


adk_help_TH_QUALITY :=
"TH_QUALITY

Attach to a device (through a device file) or a reference
designator. Value is a string that represents quality.

Used by DF/Viable for reliablilty calculations. 

";


adk_help_TMX_HEATSINK :=
"TMX_HEATSINK:

Attach to a component.  Name of the corresponding entry in
the Thermax Heat Sink Library.

";


adk_help_TS_ALLOWED :=
"TS_ALLOWED:

Attach to a net. Specifies whether T connections can be made
and the location of the T connections. Permissible values
are:
   - PINS ONLY
   - PINS & VIAS ONLY
   - ANYWHERE
   - NO Ts ALLOWED

";


adk_help_VIA_LIST :=
"VIA_LIST:

Attach to a net. A list of the via names (wildcards allowed)
that can be used for connections in this net.

";


adk_help_VOLTAGE :=
"VOLTAGE:

Attach to a component.  The voltage for this component.

Used by DF/SigNoise during analysis processing.

";


adk_help_VOLT_TEMP_MODEL :=
"VOLT_TEMP_MODEL:

Attach to a pin.  The voltage temperature model for the pin.

";

adk_help_WEIGHT := 
"WEIGHT:

Attach to a net. A number from 0 to 100. Allegro uses the
weight value during placement and automatic gate swapping. A
high weight tells Allegro to make those nets as short as
possible. 

";

adk_help_XTALK_ACTIVE_TIME :=
"XTALK_ACTIVE_TIME:

Attach to a net.  The time when this net is active (changing
voltage).  

";

adk_help_XTALK_IGNORE_NETS :=
"XTALK_IGNORE_NETS:

Attach to a net.  A list of names (wildcards allowed) to be
ignored by DG/SigNoised when performing crosstalk analysis.

";


adk_help_XTALK_SENSITIVE_TIME :=
"XTALK_SENSITIVE_TIME:

Attach to a net.  A list of times when this net is noise
sensitive to voltage changes of another net.

";

