/*
 * Name: VDRAWMN.VS
 *
 * Facility: VDRAW
 * 
 * Functional Description: 
 *    Viewscript file for Viewdraw
 *
 * Environment:
 *     SunOS 4.1 & CORE 5.0
 *     
 * Author:  
 *   Ron Maxwell, February 12, 1991  (vplace.vs)
 *
 * Modified by: 
 * Who            Version   When      What
 *
 * Murali K	  ?	    07/28/92  Added fub_cmd in the Vdraw menu
 *
 * PJS
 * 
 * (c) Copyright 1991, 1992 by Viewlogic Systems, Inc.
 */

/* MENUS
 */

prop_menu :=
    vcWv.MakeMenu ("properties",
                    /* vcWv.Pin (), */
                    list ("Modes",    cmodes_cmd),
                    list ("Values",   cvalues_cmd));

/* #if (ENH_OAT) */
sarray_menu :=
    vcWv.MakeMenu ("array",
                    /* vcWv.Pin (), */
                    list ("Index",     sarray_cmd),
                    list ("Next",     snarray_cmd),
                    list ("Prev",    sparray_cmd));
/* #endif */

select_menu :=
    vcWv.MakeMenu ("select",
                    /* vcWv.Pin (), */
                    list ("Attr",     sattr_cmd),
/* #if (ENH_OAT) */
                    list ("Array",    sarray_menu),
/* #endif */
                    list ("Comp",     scomp_cmd),
                    list ("Label",    slabel_cmd),
                    list ("Name",     sname_cmd),
                    list ("Owner",    sowner_cmd),
                    list ("Pin",      spinname_cmd),
                    list ("Text",     stext_cmd),
                    list ("Value",    svalue_cmd),
                    vcWv.Separator(),
                    list ("Group",    sgroup_cmd));

view_menu :=
    vcWv.MakeMenu ("view",
                    /* vcWv.Pin (), */
                    list ("Full",     full_cmd),
                    list ("Zoom",     zoom_cmd),
                    list ("In",       in_menu_cmd),
                    list ("Out",      out_menu_cmd),
                    list ("Pan",      pan_cmd),
                    list ("Scroll",   scroll_cmd),
                    list ("Select",   zselect_menu_cmd),
                    list ("Context",  con_cmd),
                    list ("Refresh",  refresh_cmd));

style_menu := 
    vcWv.MakeMenu ("style",
                    list ("Color", color_cmd),  
                    list ("Fill",  fstyle_cmd),
                    list ("Line",  lstyle_cmd));

if (vcWv.OS (wv) == vcOs.Unix) {
    text_menu :=
        vcWv.MakeMenu ("text",
                       list ("Font",    font_cmd),
                       list ("Origin",  origin_cmd),
                       list ("Size",    size_cmd),
                       list ("String",  chgtextstring_cmd)  ,
                       list ("Japanese",  chgkanjistring_cmd) );
} 
else { /* no Japanese for PC */
    text_menu :=
        vcWv.MakeMenu ("text",
                       list ("Font",    font_cmd),
                       list ("Origin",  origin_cmd),
                       list ("Size",    size_cmd),
                       list ("String",  chgtextstring_cmd));
}

xform_menu :=
    vcWv.MakeMenu ("xform",
                    list ("Reflect", reflect_cmd),
                    list ("Rotate",  rotate_cmd),
                    list ("Scale",   scale_cmd));

label_menu :=
    vcWv.MakeMenu ("label",
                    list ("Visibility", labelvis_cmd),
                    list ("Scope",      lscope_cmd),
                    list ("Sense",      lsense_cmd),
                    list ("String",     chglabstring_cmd));

cattr_menu :=
    vcWv.MakeMenu ("cattr",
                    list ("All",   cattr_all_cmd),
                    list ("PCB",   cattr_pcb_cmd),
                    list ("SPICE", cattr_spice_cmd));

attr_menu :=
    vcWv.MakeMenu ("attribute",
                    list ("Visibility", attrvis_cmd),
                    list ("Name",       name_cmd),
                    list ("Value",      value_cmd),
                    list ("Dialog",     cattr_menu),
                    list ("String",     chgattrstring_cmd));

bsize_menu :=
    vcWv.MakeMenu ("bsize",
                    list ("A-8.5x11", asize_cmd),
                    list ("B-17x11",  bsize_cmd),
                    list ("C-17x22",  csize_cmd),
                    list ("D-34x22",  dsize_cmd),
                    list ("E-34x44",  esize_cmd),
                    list ("A4",       a4_size_cmd),
                    list ("A3",       a3_size_cmd),
                    list ("A2",       a2_size_cmd),
                    list ("A1",       a1_size_cmd),
                    list ("A0",       a0_size_cmd),
                    list ("Z-WxH",    zsize_cmd));

block_menu :=
    vcWv.MakeMenu ("block",
                    list ("Type",  btype_cmd),
                    list ("Size",  bsize_menu));

pinnum_menu :=
    vcWv.MakeMenu ("pinnum",
                    list ("All",   cinst_cmd),
                    list ("One",   pinnum_cmd),
                    list ("Swap",  pinnumswap_cmd));

pin_menu :=
    vcWv.MakeMenu ("pin",
                    list ("Number", pinnum_menu),
                    list ("Sense",  psense_cmd));

change_menu :=
    vcWv.MakeMenu ("change",
                    vcWv.Pin (),
                    list ("Attr",   attr_menu),
                    list ("Block",  block_menu),
                    list ("Comp",   ccomp_menu_cmd),
                    list ("Label",  label_menu),
                    list ("Pin",    pin_menu),
                    list ("Refdes", refdes_cmd),
                    list ("Slot",   slot_cmd),
                    list ("Text",   text_menu));

buffer_menu :=
    vcWv.MakeMenu ("buffer",
                    list ("Clear",  bclear_cmd),
                    list ("Cut",    bcut_cmd),
                    list ("Copy",   bcopy_cmd),
                    list ("Paste",  bpaste_cmd),
                    list ("Append", bappend_cmd));

edit_menu :=
    vcWv.MakeMenu ("edit",
                    vcWv.Pin (),
                    list ("Array",   array_cmd),
                    list ("Buffer",  buffer_menu),
                    list ("Copy",    copy_cmd),
                    list ("Delete",  delete_cmd),
                    list ("Move",    move_cmd),
                    list ("Redo",    redo_cmd),
                    list ("Stretch", stretch_cmd),
                    list ("Style",   style_menu),
                    list ("Undo",    undo_cmd),
                    list ("Xform",   xform_menu));

if (vcWv.OS (wv) == vcOs.Unix) {
    graphics_menu :=
        vcWv.MakeMenu ("graphics",
                       vcWv.Pin (),
                       list ("Arc",      arc_cmd),
                       list ("Box",      box_cmd),
                       list ("Circle",   circle_cmd),
                       list ("Japanese", ktext_cmd),
                       list ("Line",     line_cmd),
                       list ("Text",     text_cmd));
}
else { /* no Japanese on PC */
    graphics_menu :=
        vcWv.MakeMenu ("graphics",
                       vcWv.Pin (),
                       list ("Arc",      arc_cmd),
                       list ("Box",      box_cmd),
                       list ("Circle",   circle_cmd),
                       list ("Line",     line_cmd),
                       list ("Text",     text_cmd));
}

/* RSM - 11/27/91 New analog menu */
analog_menu :=
    vcWv.make_menu("analog",
                   /* vcWv.Pin (),*/
                   list ("Transistors",  "analog transistors"),
                   list ("Diodes",       "analog diodes"),
                   list ("R,L,C",        "analog r,l,c"),
                   list ("Macro Models", "analog macros"),
                   list ("Instruments",  "analog instruments"),
                   list ("Sources",      "analog sources"),
                   list ("Other...",     open_sym_dbox));

add_menu :=
    vcWv.MakeMenu ("add",
                    vcWv.Pin (),
                    list ("Attr",     attr_cmd),
                    list ("Bus",      bus_cmd),
                    list ("Comp",     do_comp_cmd),
                    list ("Fub",      fub_cmd),
                    list ("Label",    label_cmd),
                    list ("Net",      net_cmd),
                    list ("Oat",      oattr_cmd),
                    list ("Pin",      pin_cmd),
                    list ("Graphics", graphics_menu),
                    list ("Analog",   analog_menu));

info_menu :=
    vcWv.MakeMenu ("info",
                    list ("Schematics", "dirsch *"),
                    list ("Symbols",    "dirsym *"),
                    list ("DirMem",     "dir *"),
                    list ("Objects",    "odetail "),
                    list ("Count",      "ocount "),
                    list ("Attributes", "alist *"),
                    list ("Labels",     "llist *"),
                    list ("Status",     "status "));

open_menu :=
    vcWv.MakeMenu ("open",
                    list ("Schematic", schematic_cmd),
                    list ("Symbol",    symbol_cmd));

makefont_menu :=
    vcWv.MakeMenu ("makefont",
                    list ("To Schematic",   edit_font_cmd),
                    list ("From Schematic", compile_font_cmd));

if (vcWv.OS (wv) == vcOs.Unix) {
    util_menu :=
        vcWv.MakeMenu ("util",
                       /* vcWv.Pin (), */
                       list ("Check",    check_cmd),
                       list ("CrossProbe", probe_menu),
                       list ("OatCheck", "mex oatcheck"),
                       list ("MakeFont", makefont_menu),
                       list ("SavePin",  savepin_cmd));
}
else {
    util_menu :=
        vcWv.MakeMenu ("util",
                       /* vcWv.Pin (), */
                       list ("Check",    check_cmd),
                       list ("OatCheck", "mex oatcheck"),
                       list ("MakeFont", makefont_menu),
                       list ("SavePin",  savepin_cmd));
}

level_menu :=
    vcWv.MakeMenu ("level",
                    list ("Push",  levelpush_cmd),
                    list ("Pop",   "pop"));

file_menu :=
    vcWv.MakeMenu ("file",
                    /* vcWv.Pin (), */
                    list ("Open",    fileopen_menu_cmd),
                    /* list ("Close",   close_cmd), */
                    list ("Level",   level_menu),
                    list ("Read",    read_cmd),
                    list ("Write",   write_cmd),
                    list ("WriteTo", writeto_cmd),
                    list ("Restore", restore_cmd));

main_menu :=
    vcWv.MakeMenu ("vdraw",
                    vcWin.RedSquareEntry,
                    list ("File",   file_menu),
                    list ("View",   view_menu),
                    list ("Edit",   edit_menu),
                    list ("Change", change_menu),
                    list ("Add",    add_menu),
                    list ("Select", select_menu),
                    list ("Info",   info_menu),
                    list ("Props",  prop_menu),
                    list ("Utils",  util_menu));

VO_file_menu :=
    vcWv.MakeMenu ("file",
                    /* vcWv.Pin (), */
                    list ("Open",    fileopen_menu_cmd),
                    list ("Level",   level_menu));

VO_view_menu :=
    vcWv.MakeMenu ("view",
                    /* vcWv.Pin (), */
                    list ("Full",     full_cmd),
                    list ("Zoom",     zoom_cmd),
                    list ("In",       in_menu_cmd),
                    list ("Out",      out_menu_cmd),
                    list ("Pan",      pan_cmd),
                    list ("Scroll",   scroll_cmd),
                    list ("Select",   zselect_menu_cmd),
                    list ("Context",  con_cmd),
                    list ("Refresh",  refresh_cmd),
                    list ("Attr",     cattr_menu));

VO_main_menu :=
    vcWv.MakeMenu ("vdraw",
                    vcWin.RedSquareEntry,
                    list ("File",   VO_file_menu),
                    list ("View",   VO_view_menu),
                    list ("Select", select_menu),
                    list ("Info",   info_menu),
                    list ("Modes",  VO_cmodes_cmd));

/*vcFac.SetMenus (fac, main_menu);*/
/*vcFac.SetMenus (fac, VO_main_menu);*/

vcFac.SetMenus (fac,
                (  read_only() == vlTrueFalse.True
                 ? VO_main_menu
                 : main_menu));

/*-*/
/* Main pop-up menus */
pushpop_menu :=
    vcWv.MakeMenu ("PushPop",
                    vcWv.Pin (),
                    list ("Push",           levelpush_cmd),
                    list ("Pop",            "pop"));

shft_sym_popup :=
    vcWv.MakeMenu ("shft_symbol",
                    list ("Push",           levelpush_cmd),
                    list ("Pop",            "pop"));

shft_sch_popup :=
    vcWv.MakeMenu ("shft_schematic",
                    list ("Push",           levelpush_cmd),
                    list ("Pop",            "pop"));

sch_add_popup_menu :=
    vcWv.MakeMenu ("add",
                    vcWv.Pin (),
                    list ("Attribute", attr_cmd),
                    list ("Bus",       bus_cmd),
                    list ("Comp",      do_comp_cmd),
		    list ("Fub",       fub_cmd),
                    list ("Label",     label_cmd),
                    list ("Net",       net_cmd),
                    vcWv.Separator (),
                    list ("Arc",       arc_cmd),
                    list ("Box",       box_cmd),
                    list ("Circle",    circle_cmd),
                    list ("Line",      line_cmd),
                    list ("Text",      text_cmd));

schematic_popup_menu :=
    vcWv.MakeMenu ("schematic",
                    vcWv.Pin (),
                    list ("Fast",      fast_draw_cmd),
                    list ("Add",       sch_add_popup_menu),
                    list ("Copy",      copy_cmd),
                    list ("Delete",    delete_cmd),
                    list ("Move",      move_cmd),
                    list ("Undo",      undo_cmd),
                    list ("Redo",      redo_cmd),
                    vcWv.Separator (),
                    list ("Zoom",      zoom_cmd),
                    list ("Push",      levelpush_cmd),
                    list ("Pop",       "pop"));

sym_add_popup_menu :=
    vcWv.MakeMenu ("add",
                    vcWv.Pin (),
                    list ("Attribute", attr_cmd),
                    list ("Label",     label_cmd),
                    list ("Pin",       pin_cmd),
                    vcWv.Separator (),
                    list ("Arc",       arc_cmd),
                    list ("Box",       box_cmd),
                    list ("Circle",    circle_cmd),
                    list ("Line",      line_cmd),
                    list ("Text",      text_cmd));

symbol_popup_menu :=
    vcWv.MakeMenu ("symbol",
                    vcWv.Pin (),
                    list ("Fast",      fast_draw_cmd),
                    list ("Add",       sym_add_popup_menu),
                    list ("Copy",      copy_cmd),
                    list ("Delete",    delete_cmd),
                    list ("Move",      move_cmd),
                    list ("Undo",      undo_cmd),
                    list ("Redo",      redo_cmd),
                    vcWv.Separator (),
                    list ("Zoom",      zoom_cmd),
                    list ("Push",      levelpush_cmd),
                    list ("Pop",       "pop"));

instance_popup_menu :=
    vcWv.MakeMenu ("instance",
                    list ("Attr",        attr_cmd),
                    list ("Push",        levelpush_cmd));

/* these commands bring up the appropriate pop-up menu */

sch_popup_cmd :=
    vcWv.Cmd (fac, func(d, e)
              {
                  vcMenuPop.create (schematic_popup_menu, e);
              }, "menu-schematic");

VO_popup_cmd :=
    vcWv.Cmd (fac, func(d, e)
              {
                  vcMenuPop.create (VO_popup_menu, e);
              }, "menu-VO-schematic");

sym_popup_cmd :=
    vcWv.Cmd (fac, func(d, e)
              {
                  vcMenuPop.create (symbol_popup_menu, e);
              }, "menu-symbol");

inst_popup_cmd :=
    vcWv.Cmd (fac, func(d, e)
              {
                  vcMenuPop.create (instance_popup_menu, e);
              }, "menu-instance");

shft_sch_popup_cmd :=
    vcWv.Cmd (fac, func(d, e)
              {
                  vcMenuPop.create (shft_sch_popup, e);
              }, "#menu-schematic");

shft_sym_popup_cmd :=
    vcWv.Cmd (fac, func(d, e)
              {
                  vcMenuPop.create (shft_sym_popup, e);
              }, "#menu-symbol");


vcCmd.EnableMacro (sch_popup_cmd,      "off");
vcCmd.EnableMacro (sym_popup_cmd,      "off");
vcCmd.EnableMacro (inst_popup_cmd,     "off");
vcCmd.EnableMacro (shft_sch_popup_cmd, "off");
vcCmd.EnableMacro (shft_sym_popup_cmd, "off");


/*
 * POPUP menus same as menus across top.  Popup at cursor.
 * (Typically bound to ALT + first character in menu name.)
 */

file_popup_cmd :=
    vcWv.Cmd (fac, func(d, e)
              {
                  vcMenuPop.create (file_menu, e);
              }, "file-menu");

view_popup_cmd :=
    vcWv.Cmd (fac, func(d, e)
              {
                  vcMenuPop.create (view_menu, e);
              }, "view-menu");

edit_popup_cmd :=
    vcWv.Cmd (fac, func(d, e)
              {
                  vcMenuPop.create (edit_menu, e);
              }, "edit-menu");

change_popup_cmd :=
    vcWv.Cmd (fac, func(d, e)
              {
                  vcMenuPop.create (change_menu, e);
              }, "change-menu");

add_popup_cmd :=
    vcWv.Cmd (fac, func(d, e)
              {
                  vcMenuPop.create (add_menu, e);
              }, "add-menu");

select_popup_cmd :=
    vcWv.Cmd (fac, func(d, e)
              {
                  vcMenuPop.create (select_menu, e);
              }, "select-menu");

info_popup_cmd :=
    vcWv.Cmd (fac, func(d, e)
              {
                  vcMenuPop.create (info_menu, e);
              }, "info-menu");


props_popup_cmd :=
    vcWv.Cmd (fac, func(d, e)
              {
                  vcMenuPop.create (prop_menu, e);
              }, "props-menu");


utils_popup_cmd :=
    vcWv.Cmd (fac, func(d, e)
              {
                  vcMenuPop.create (util_menu, e);
              }, "utils-menu");

/*
 * Other pop-up menus.
 */

level_popup_cmd :=
    vcWv.Cmd (fac, func(d, e)
              {
                  vcMenuPop.create (pushpop_menu, e);
              }, "level-menu");

text_popup_cmd :=
    vcWv.Cmd (fac, func(d, e)
              {
                  vcMenuPop.create (text_menu, e);
              }, "text-menu");

xform_popup_cmd :=
    vcWv.Cmd (fac, func(d, e)
              {
                  vcMenuPop.create (xform_menu, e);
              }, "xform-menu");

vcCmd.EnableMacro (file_popup_cmd,    "off");
vcCmd.EnableMacro (view_popup_cmd,    "off");
vcCmd.EnableMacro (edit_popup_cmd,    "off");
vcCmd.EnableMacro (change_popup_cmd,  "off");
vcCmd.EnableMacro (add_popup_cmd,     "off");
vcCmd.EnableMacro (select_popup_cmd,  "off");
vcCmd.EnableMacro (info_popup_cmd,    "off");
vcCmd.EnableMacro (props_popup_cmd,   "off");
vcCmd.EnableMacro (utils_popup_cmd,   "off");
vcCmd.EnableMacro (level_popup_cmd,   "off");
vcCmd.EnableMacro (text_popup_cmd,    "off");
vcCmd.EnableMacro (xform_popup_cmd,   "off");

VO_popup_menu :=
    vcWv.MakeMenu ("schematic",
                    vcWv.Pin (),
                    list ("Zoom",          zoom_cmd),
                    list ("Push",      levelpush_cmd),
                    list ("Pop",       "pop"),
                    vcWv.Separator (),
                    list ("ViewAttrAll",   cattr_all_cmd),
                    list ("ViewAttrPCB",   "cattr pcb.flt"),
                    list ("ViewAttrSpice", "cattr spice.flt")
                   );

load ("vdrawht.vs");   /* Help text */
