/* This file contains vs functions defining tasks in the 
 * Allegro flow.
 */

//function SetDesign(t, fl, in, out, complete) {
//    function finish (code) {
//        
//        complete (vcSysMode.Exited, code);
//        vcWin.Destroy (w);
//    }
//    function accept (ev) 
//        finish (0);
//    function cancel (ev)
//        finish ("Cancelled");
//  
//    r1 := vc
//    b1 := vcWv.LabelButtonCreate ("", "Accept", nil, accept, nil);
//    b2 := vcWv.LabelButtonCreate ("", "Cancel", nil, cancel, nil);
//    w := vcWin.Create (vcTable.Make ("Setup", 2, 2, r1, r2, b1, b2), 
//                       vcWin.NoBindings +vcWin.NoStatus);   
//}

/* Creates Checkpoint of sch, wir .tel, .ndc, .fdc, etc. after
 * pcbfwd.
*/

function mycheckout(obj, action_type)
    vdm.ObjCheckoutLock (obj);

/* 
 * This fuction creates a PostPack collection object and checkpoints it.
 * The PostPack collection object contains schematics packaged in a ViewDraw
 * Collection, wir files corresponding to the schematics, dictionary files,
 * etc.
 */


function  CreatePostPackCheckpoint(t, fl, in, out, complete) {

    /* Get the vfl schematic data object so that we can get its location */
    declare vdm_obj, location;
    vdm_obj := vflData.GetVdmObject(vflFlow.GetFromName(fl, 
                                                        "PrePackSchematic"), 
                                    fl);
    location := vdm.ObjGetLocation(vdm_obj);
    cntx := vdm.ObjGetCntx(vdm_obj);
    class := vdm.CntxFindClass(cntx, "PostPack");
    design := vscript.getenv("WDESIGN");
    if (null(design))
        design = vflFlow.GetGsymValue(fl, "DESIGN");
    printf("location = %s\n", location);
    coll_obj := vdm.ObjCreate(design, vdm.VersLatest, class, 
                         location, cntx, nil);

    vdraw_class := vdm.CntxFindClass(cntx, "ViewDraw Design");
    vdraw_obj := vdm.ObjCreate(design, vdm.VersLatest, vdraw_class, 
                               location, cntx, nil /* other attributes */);
    dict_class := vdm.CntxFindClass(cntx, "PcbDictionaries");
    dict_obj := vdm.ObjCreate(design, vdm.VersLatest, dict_class, 
                               location, cntx, nil /* other attributes */);
    vdm.CollCompose(vdraw_obj);
    vdm.CollCompose(dict_obj);
    vdm.CollCompose(coll_obj);

    vdm.ObjCheckpoint(coll_obj, TRUE, // update
                        TRUE, // lock_on_modify
                        FALSE, // dry_run
                        "Checkpoint after Check and Pack", // log_message
                        nil, // before_proc
                        mycheckout, //after_proc,
                        current_package());
    complete(vcSysMode.Exited, 0);
}


