
/*---------------------------------------------------------------------------*/
/*                                                                           */
/*   vsyn2.vs          viewsynthesis 5.0           25 January 1995           */
/*                     Copyrite January 1995, Viewlogic Systems, Inc.        */
/*   version 1.45      Phil Labee                                            */
/*                                                                           */
/*   This module contains these function:                                    */


declare amgdebug;
amgdebug=0;

semaphore   := vlOnOff.On;
current_tech := " ";
current_lib := " ";
current_design := " ";
current_module := "none";
current_outnet := " ";
current_report := " ";
current_outdir := ":";
declare sys;
declare outwin;
declare current_entity, current_vertex;
current_entity = "";
declare optfor, maxdelay, area_speed;
declare status_list;
declare preopt_list;
declare premap_list;
declare preopt_win;
declare premap_win;
    

input_cons_type := "rsfa"; 
output_cons_type := "rsfa"; 

declare arrive_time;
declare require_time;
declare in_name_reg ;
declare in_cmdline_reg ;
declare in_bar_reg ;
declare in_bar_value;
declare in_load_reg ;
declare in_load;
declare out_load;
declare in_drive_rise_reg ;
declare in_drive_rise;
declare in_drive_fall;
declare in_drive_fall_reg ;
declare label_drive_reg ;
declare label_load_reg ;
declare label_arrive_reg ;
declare out_name_reg ;
declare out_cmdline_reg ;
declare out_bar_reg ;
declare out_load_reg ;
declare out_require_reg ;
declare labelout_load_reg ;
declare labelout_require_reg ;


function getsrcfile(d) 
   {
   entity := get_current_entity( d ); 
   srclist := copy_list( vhdsrc_list );
   
   while (!null(srclist ) && (! string_eq( car( car( srclist )), entity) ))
      srclist = cdr( srclist );

   return( cdr( car( srclist ))); 
   }                                              /* end function GETSRCFILE */




VHDLDES := "vhdldes";
RETARGETER := "retargeter";

  /* variables needed for creating constraint table */

    in_no := 0;
    out_no := 0;
    max_inout := 2048;    /* plabee 1/19/95: 18549, 10397 */
    max_time := "none";

    con_value := max_time;
    in := make_vector(max_inout);
    out := make_vector(max_inout);
    in_arrive_rise := make_vector(max_inout,"0");
    in_arrive_fall := make_vector(max_inout,"0");
    out_require_rise := make_vector(max_inout,max_time);
    out_require_fall := make_vector(max_inout,max_time);
    in_load = make_vector(max_inout,max_time);
    out_load = make_vector(max_inout,max_time);
    in_drive_rise = make_vector(max_inout,max_time);
    in_drive_fall = make_vector(max_inout,max_time);
    in_bar_value= make_vector(max_inout,max_time);
    out_bar_value := make_vector(max_inout,max_time);
    arrive_time = make_vector(max_inout,max_time);
    require_time = make_vector(max_inout,max_time);

/* variables for settting package */

declare new_voltage;
declare new_temperature;
declare current_temperature;
declare current_voltage;
declare current_process_type;
declare current_area_speed;
declare current_maxdelay;
declare current_package;
declare new_process_type;
declare new_package;
empty_package :="";

vcWv.MakeEnum ("optVT",  list ("off", "area", "speed" ));
vcWv.MakeEnum ("cpuVT",  list ("low", "medium", "high" ));
vcWv.MakeEnum ("flatVT", list ("off", "low", "medium", "high" ));
vcWv.MakeEnum ("redunVT",list ("off", "on" ));
current_optfor := opt.area;
current_cpu    := cpu.low;
current_redux  := redun.off;
current_flat   := flat.off;
current_maxdelay = 0;
current_area_speed = 1;

/* Utility functions */



/* jrs 11/4/92 */
function append1(list1, item) {
   return (reverse(cons(item,reverse(list1)))); }
/* end jrs */

 
iterator from_to(first, last)
        for (i := first; i < last; ++i)
            iterate (i);

function fprintf(args...)
    fputline (car (args), apply (sprintf, cdr (args)));


/*---------------------------------------------------------------------------*/
/*                                                                           */
/*   LOGARITHMIC_SCALEBAR function is ...................................... */
/*                                                                           */
/*                                                                           */
/*                                                                           */

function logarithmic_scalebar(name, val, min, max, call_on_change)
   {
   ok_to_update := TRUE;

   function to_scale(x)                           /* nested functin TO_SCALE */
      {
      temp_value := 0.0;
      time_value := 0.0;
      time_value = x;  

      if (time_value <= 250)
         temp_value = time_value/25;

      else if (time_value <= 500)
         temp_value = (time_value - 180.77)/6.38;

      else if (time_value <= 750)
         temp_value = (time_value - 415.83)/1.67;

      else if (time_value <= 1000)
         temp_value = (time_value - 688.288)/0.312;
    
      if( temp_value > 999.0) return(max_time);  
      if( temp_value < 0.05 ) temp_value = 0.0;
      return( convert(string, temp_value));
      }                                      /* end nested function TO_SCALE */


   function from_scale(val)                    /* nested function FROM_SCALE */
      {
      declare value;

      /* fix to allow typing in "." */
    
      if( string_eq( val, max_time )) return(1000.0);
      x  := string2number( val ); 

      if ( x < 0.0 ) value = 0.0;

      if ( x <=10.00 )
         value = x * 25;

      else if ( x <= 50 )
         value = x * 6.38 + 180.77;

      else if ( x <= 200 )
         value = x * 1.67 + 415.83;

      else if ( x <= 1000 )
         value = x * 0.312 + 688.288;

      return( value );
      }                                    /* end nested function FROM_SCALE */


   /*  LOGARITHMIC_SCALEBAR function entry point */

   cmdline := vcRegion.Create (name + "_cmdline", vcCmdline.fac, val,
                               max_width <- 10, width <- 7);

   scalebar := vcRegion.Create (name + "_scalebar", vcScalebar.fac,
                                from_scale (val),
                                min <- min,
                                max <- max,
                                increment <- 0.01 ,
                                range <- FALSE,
                                value <- FALSE,
                                ticks <- 0);

   vcScale.NotifyOnChange (scalebar,
                  func(v) {  if( ok_to_update ) 
                               {
                               ok_to_update = FALSE;
                               vcCmdline.Set (cmdline, to_scale(v));
                               ok_to_update = TRUE; 
                               } 
                          }                           );

   vcCmdline.CallOnChange (cmdline,
                func(str) {
                          ok_to_update = FALSE;
                          len := string_length (str);
                          if ((len> 0) && (string_ref(str, len-1) != '.' ))
                             {
                             errstr := vcWv.ErrorCheck (func()
                                {
                                vcScalebar.Set (scalebar, from_scale (str));
                                call_on_change ( str ); 
                                }                                         );
                             if (errstr != nil)
                                {
                                w := vcRegion.Window (cmdline);
                                vcWin.ClearStatus (w);
                                vcWin.AddStatus (w, errstr);
                                } 
                             }
                          ok_to_update = TRUE;
                          }                                               );

   tt :=vcTable.Make (name, 1, 1, cmdline );
   return(tt);
   }                                    /* end function LOGARITHMIC_SCALEBAR */



function logscale_set(logscale, val) 
   {
   cmdline := vcTable.Get (logscale, 0, 0);
   vcCmdline.Set (cmdline, val);
   }

function stringregion_set(table, val)
   {
   cmdline := vcTable.Get (table, 0, 1);
   vcCmdline.Set (cmdline, val);
   }


/* A region with  a label and value which is not changeable */

function informregion (strlist)
   {
   declare oneitem, title, initval;
   table := vcTable.Create ("stringregion", 1, 2);
   for (; !null (strlist); strlist = cdr (strlist))
      {
      oneitem  = car (strlist);
      title    = car (oneitem); oneitem = cdr (oneitem);
      initval  = car (oneitem);
      vcTable.Add(table, vcRegion.Create1 (title, vcLabel.fac, title, nil));

      t_typein := vcRegion.Create1 (title + ".string", vcCmdline.fac, initval,
                                       list (width <- 5, macro_on <- TRUE));

      vcTable.Add (table, t_typein);
      vcCmdline.CallOnChange (t_typein,
                  func(s) { vcCmdline.Set(t_typein, initval); }  );
      }

   vcTable.Col (table, 0, vcTable.Border.Invisible, 1,1,1, vgAlign.MiddleRight);
   return (table); 
   }                                           /* end function INFORMREGION */



/* A region with some number of string entry widgets in a vertical row */

function stringregion (strlist)
   {
   declare oneitem, callback, title, initval;
   table := vcTable.Create ("stringregion", 1, 2);

   for (; !null (strlist); strlist = cdr (strlist))
      {
      oneitem  = car (strlist);
      callback = car (oneitem); oneitem = cdr (oneitem);
      title    = car (oneitem); oneitem = cdr (oneitem);
      initval  = car (oneitem);

      vcTable.Add (table, vcRegion.Create1 (title, vcLabel.fac, title, nil));
      t_typein := vcRegion.Create1 (title + ".string", vcCmdline.fac, initval,
                                      list (width <- 6, macro_on <- TRUE));
      vcTable.Add (table, t_typein);
      vcCmdline.CallOnChange (t_typein, callback);
      }
   vcTable.Col (table, 0, vcTable.Border.Invisible, 1,1,1, vgAlign.MiddleRight);
   return (table); 
   }                                            /* end function STRINGREGION */


/* A region with a input string and a title button */

function stringbutton (strlist)
   {
   declare oneitem, callback, accept, title, initval;
   table := vcTable.Create ("stringregion", 1, 2);

   for (; !null (strlist); strlist = cdr (strlist))
      {
      oneitem  = car (strlist);
      callback = car (oneitem); oneitem = cdr (oneitem);
      accept = car (oneitem); oneitem = cdr (oneitem);
      title    = car (oneitem); oneitem = cdr (oneitem);
      initval  = car (oneitem);

      b_accept := vcWv.LabelButtonCreate (title + ".a", title, nil, accept,
                                        list (macro_on <- TRUE));
      vcTable.Add (table, b_accept);
      t_typein := vcRegion.Create1 (title + ".string", vcCmdline.fac, initval,
                                   list (width <- 20, macro_on <- TRUE));
      vcTable.Add (table, t_typein);
      vcCmdline.CallOnChange (t_typein, callback);
      }
   return (table);
   }                                             /* end functin STRINGBUTTON */



/* A single select horizontal picklist built from a list */

function flatregion (title, callback, initval, flatlist)
   {
   function flatnotify (data, onoff) 
      if (onoff == vlOnOff.On) callback (car (data)); 
   

   r_flat := vcRegion.Create1 (title + ".flat", vcPicklist.fac, nil,
                                list (macro_on <- TRUE));
   for (i:=flatlist; !null(i); i = cdr (i))
      vcPicklist.Add (r_flat, caar (i), cdar (i));

   setpickmatch (r_flat, flatlist, initval);
   vcPicklist.Notify (r_flat, flatnotify);

   t_top := vcTable.Create ("flatop", 1, 2);
   vcTable.Add (t_top, vcRegion.Create1 ("flatitle", vcStaticText.fac,
                                         title, nil));
   vcTable.Add (t_top, r_flat);
   return (t_top); 
   }                                              /* end funciton FLATREGION */


/* Given a region and a picklist, initialize the picklist to the entry matching
   the initial value */

function setpickmatch (region, matchlist, text)
   {
   declare i, j;
   for (i=0, j=matchlist; !null(j); j=cdr(j), ++i)
      if (string_eq (cadar (j), text))
         return (vcPicklist.SetPick (region, i)); 
   }                                            /* end function SETPICKMATCH */


/*
 * Provide the essential Create method for the facility.  In it, just
 * instantiate a Shell, run /bin/csh, and we're on our way!
 */

/*
 * This function is a "command generator".  Given a list of argument
 * descriptors, as documented in vcWv.Param, it builds a command that
 * appends its arguments together, separated by spaces, and sends the
 * command to the subprocess.
 */

function cmd(cmdname, abbrev, title, params)
   {
   function send_strings (args...)
      {
      declare str, sh, e, a;

      sh  = car (args); args = cdr (args);
      e   = car (args); args = cdr (args);
      for (str = abbrev; !null(args); args = cdr (args))
          {
          a = car (args);
          str = str + " " + (istype (a, string) ? a : number2string (a));
          } 

      /*vcWin.Show( outwin );*/
      }                                  /* end nested function SEND_STRINGS */

   vcCmd.Create (fac, send_strings, cmdname, title, params);
   }                                                     /* end function CMD */


/*---------------------------------------------------------------------------*/
/*                                                                           */
/*   CALL_VIEW_PREOPT  function is the object of the VIEW_PREOPT_CMD to view */
/*   the design hierarchy before the optimization phase.  It is called only  */
/*   with the data and event objects supplied by core (i.e. no Parameters).  */
/*                                                                           */
/*                                                                           */
/*                                                                           */

function call_view_preopt(d,e) 
   {
   /* 1) Look at each element of 'status_list':
         if the vertex is there in preopt,
            find vertex in 'tree_list' and add it to 'preopt_list'
      2) write_tree( 'preopt_list' );
   */
   tmp_status := copy_list( status_list );
   tmp_tree   := copy_list( tree_list );

   while (!null( tmp_status ) )
      {
      entity := car( car( tmp_status ));
      status := cdr( car( tmp_status ));
      if ( (status & 1) == 0)
         {
         /* NOT dissolved in preopt, so in 'preopt' view */

         tmp_tree   := copy_list( tree_list );
         while ( !null( tmp_tree ))
            {
            if ( string_eq( entity, car( car( tmp_tree ))) == TRUE)
               {
               /* add to list of vertices in preopt view */
               if (null( preopt_list ))
                  preopt_list = cons( car( tmp_tree ), nil );
               else
                  if (member( car( tmp_tree), preopt_list ) == FALSE)
                     preopt_list = cons( car( tmp_tree ), preopt_list );

                tmp_tree = nil;
                }
            else   tmp_tree = cdr( tmp_tree );
            }
         }     /* end if status&1 == 0 */
            
      tmp_status = cdr( tmp_status );
      }

   /* remove any dissolved/flattened children from preopt_list */

   tmplist := copy_list( preopt_list );      newlist := nil;

   while (!null( tmplist ))
      {
      /* newchunk is a list with parent at head, children
          that are in preopt view following */
      newchunk := cons( car(car( tmplist )), nil);
      children := cdr( car( tmplist ) );

      while (!null( children )) 
         {
         entity := car( children );
         status := getStatus( entity );
         if ( (status & 1) == 0) 
            /* NOT dissolved in preopt, so in 'preopt' view */
            newchunk = cons(entity,newchunk);
         children = cdr( children );
         }

      tmplist = cdr( tmplist );
      newchunk = reverse_destructive( newchunk );
  
      newlist = cons( newchunk, newlist );
      }                                       /* end while tmplist not null */
          
   preopt_list = copy_list( newlist ); 
       
   write_tree( rootNode, preopt_list, FALSE );
   hac_make2( "Pre-Optimization Hierarchy" );
   }                                        /* end function CALL_VIEW_PREOPT */




view_preopt_cmd := vcWv.Cmd( fac, call_view_preopt, "View Pre-Optimization", "View Pre-Optimization");
vcCmd.SetHelp (view_preopt_cmd, "View hierarchy before optimization phase");


/*---------------------------------------------------------------------------*/


function call_view_premap(d,e) {

/* 1) Look at each element of 'status_list':
      if the vertex is there in premap,
         find vertex in 'tree_list' and add it to 'premap_list'
   2) write_tree( 'premap_list' );
*/
    tmp_status := copy_list( status_list );
    tmp_tree   := copy_list( tree_list );

    while (!null( tmp_status ) ) {
        entity := car( car( tmp_status ));
        status := cdr( car( tmp_status ));
        if ( ((status & 1) == 0) && ((status & 1) == 0) ) {
            /* NOT dissolved in preopt OR premap, so in 'premap' view */

            tmp_tree   := copy_list( tree_list );
            while ((!null( tmp_tree ))) {
                if ( string_eq( entity, car( car( tmp_tree ))) == TRUE ) {
                    /* add to list of vertices in premap view */
                    if (null( preopt_list ))
                        premap_list = cons( car( tmp_tree ), nil );
                    else
                        if (member( car( tmp_tree), premap_list ) == FALSE)
                            premap_list = cons( car( tmp_tree ), premap_list );
                    tmp_tree = nil;
                }
                else
                    tmp_tree = cdr( tmp_tree );
            }
        }
            
        tmp_status = cdr( tmp_status );
    }
    
    /* remove any dissolved/flattened children from premap_list */
    tmplist := copy_list( premap_list );
    newlist := nil;
    while (!null( tmplist )) {
        newchunk:=cons( car(car( tmplist )), nil);
        children := cdr( car( tmplist ) );
        while (!null( children )) {
            entity := car( children );
            status := getStatus( entity );
            if ( ((status & 1) == 0) && ((status & 2) == 0) )
                /* NOT dissolved in preopt or premap, so in 'premap' view */
                newchunk = cons(entity,newchunk);
            children = cdr( children );
        }
        tmplist = cdr( tmplist );
        newchunk = reverse_destructive( newchunk );
        newlist = cons( newchunk, newlist );
     }
          
     premap_list = copy_list( newlist ); 
       
    write_tree( rootNode, premap_list, FALSE );
    hac_make2( "Pre-Mapping Hierarchy" );

}

view_premap_cmd := vcWv.Cmd( fac, call_view_premap, "View Pre-Mapping", "View Pre-Mapping");

vcCmd.SetHelp (view_premap_cmd, "View hierarchy before mapping phase");


/*---------------------------------------------------------------------------*/


function read_synth_ini( data, event ) {

   filename := string_append( work_dir, "/synth.ini" );
   if (fexists( filename )) {
      fpx := fopen( filename, "r" );
      if (!null( fpx )) {
         while ( !null( linein := fgetline( fpx ))) {
            linein = string_token( linein, &token, " " );

            /* check for technology */
            if ((string_length( token ) >= 10) && string_eq( substring(token,0,10), "technology")) {
               linein = string_token( linein, &token, " " );
               string_token( token, &token, "\n" );
               current_tech = string_copy(token);
               post_tech( data, event, current_tech );
            }

            /* check for temperature */
            else if  ((string_length( token ) >= 11) && string_eq( substring(token,0,11), "temperature")) {
               linein = string_token( linein, &token, " " );
               string_token( token, &token, "\n" );
               current_temperature = convert( float, token );
            }

            /* check for voltage */
            else if  ((string_length( token ) >= 7) && string_eq( substring(token,0,7), "voltage")) {
               linein = string_token( linein, &token, " " );
               string_token( token, &token, "\n" );
               current_voltage = convert( float, token );
            }

            /* check for package */
            else if  ((string_length( token ) >= 7) && string_eq( substring(token,0,7), "package")) {
               linein = string_token( linein, &token, " " );
               string_token( token, &token, "\n" );
               current_package = string_copy( token );
            }

            /* check for opt */
            else if  ((string_length( token ) >= 3) && string_eq( substring(token,0,3), "opt")) {
               linein = string_token( linein, &token, " " );
               string_token( token, &token, "\n" );
               if      (string_eq( token, "off" ))   current_optfor = opt.off;
               else if (string_eq( token, "area" ))  current_optfor = opt.area;
               else if (string_eq( token, "speed" )) current_optfor = opt.speed;
            }   
            
            /* check for process */
            else if  ((string_length( token ) >= 7) && string_eq( substring(token,0,7), "process")) {
               linein = string_token( linein, &token, " " );
               string_token( token, &token, "\n" );
               if      (string_eq( token, "1" )) current_process_type = "1";
               else if (string_eq( token, "0" )) current_process_type = "0";
               else if (string_eq( token, "2" )) current_process_type = "2";
            }
             
            /* check for cpu_effort */
            else if  ((string_length( token ) >= 10) && string_eq( substring(token,0,10), "cpu_effort")) {
               linein = string_token( linein, &token, " " );
               string_token( token, &token, "\n" );
               if      (string_eq( token, "low" ))    current_cpu = cpu.low;
               else if (string_eq( token, "medium" )) current_cpu = cpu.medium;
               else if (string_eq( token, "high" ))   current_cpu = cpu.high;
            }   
            
            /* check for flatten */
            else if  ((string_length( token ) >= 7) && string_eq( substring(token,0,7), "flatten")) {
               linein = string_token( linein, &token, " " );
               string_token( token, &token, "\n" );
               if      (string_eq( token, "off" ))    current_flat = flat.off;
               else if (string_eq( token, "low" ))    current_flat = flat.low;
               else if (string_eq( token, "medium" )) current_flat = flat.medium;
               else if (string_eq( token, "high" ))   current_flat = flat.high;
            }   
            
            /* check for redundancy_removal */
            else if  ((string_length( token ) >= 18) && string_eq( substring(token,0,18), "redundancy_removal")) {
               linein = string_token( linein, &token, " " );
               string_token( token, &token, "\n" );
               if      (string_eq( token, "off" )) current_redux = redun.off;
               else if (string_eq( token, "on" ))  current_redux = redun.on;
            }   
            
            /* check for max_delay */
            else if  ((string_length( token ) >= 9) && string_eq( substring(token,0,9), "max_delay")) {
               linein = string_token( linein, &token, " " );
               string_token( token, &token, "\n" );
               current_maxdelay = convert( float, token );
            }


         } /* while !EOF */

         fclose( fpx );

      }  /* if opened synth.ini */

      else
         vlEx.Throw2 (vlEx.FAILURE, "ViewSyn", vlErrSev.Error, sprintf ("Cannot open synth.ini for reading."));

   } /* synth.ini exists */
}




/*---------------------------------------------------------------------------*/
/*                                                                           */
/*   MAKE_PI  function writes the file <work_dir>/synth/<entity>/<entity>.pi */
/*   This file describes the module's pin information, and has the format:   */
/*                                                                           */
/*       MODULE <entity>                                                     */
/*       O <primary output>                                                  */
/*         .                                                                 */
/*         .                                                                 */
/*         .                                                                 */
/*       I <primary input>                                                   */
/*         .                                                                 */
/*         .                                                                 */
/*         .                                                                 */
/*   This file is only needed for compatibility with the ViewScript code     */
/*   from the existing VHDLDES GUI for creating the dialog box for setting   */
/*   port timing constraints.                                                */
/*                                                                           */
/*   MAKE_PI is called from CALL_SET_MAPCONSTRAINT with an entity string.    */
/*                                                                           */

function make_pi( entity )
   {
   declare fp,           /* file pointer to default port file <entity>.pdf   */
           filename,     /* full path name of default port file <entity>.pdf */
           linein,       /* single line read from default port file          */
           token,        /* single word from parsing of <linein>             */
           pifile,       /* full path name of <entity>.pi file               */
           pi_list,      /* list of unique input port data from pdf file     */
           po_list,      /* list of unique output port data from pdf file    */
           tmpstr;       /* used to construct line to be written to <pifile> */

   filename = string_append( work_dir, "/synth/", entity, "/", entity,".pdf");
   fp = fopen( filename, "r" );

   if (null( fp ) )
      vlEx.Throw2 (vlEx.FAILURE, "ViewSyn", vlErrSev.Warning,
          sprintf("Cannot open default port file.", filename) );
      

   while ( !null( linein = fgetline( fp )))
      {
      linein = string_token( linein, &token, " " );
      if (string_eq( token, "input_arrival"))
         {
         linein = string_token( linein, &token, " " );
         linein = string_token( linein, &token, " " );
         linein = string_token( linein, &token, " " );

         if ((pos := rindex(token, '\n')) != nil)
            token = substring( token, 0, pos );

         if (null(pi_list))
            pi_list = cons( token, nil );
         else
            if (! member( token, pi_list))
               pi_list = cons( token, pi_list);
         }

      if (string_eq( token, "output_required"))
         {
         linein = string_token( linein, &token, " " );
         linein = string_token( linein, &token, " " );
         linein = string_token( linein, &token, " " );

         if ((pos := rindex( token, '\n')) != nil)
            token = substring( token, 0, pos );

         if (null(po_list))
            po_list = cons( token, nil );
         else
            if (! member( token, po_list))
               po_list = cons( token, po_list);
         }
      }
   fclose( fp );
  
 
   /* ---  write primary input/output data to file  --- */

   pifile= string_append( work_dir, "/synth/", entity, "/", entity, ".pi" );
   fp = fopen( pifile , "w" );

   if (null( fp ) )
      vlEx.Throw2 (vlEx.FAILURE, "ViewSyn", vlErrSev.Warning,
          sprintf("Cannot open PI file.", pifile) );
      

   tmpstr = sprintf( "MODULE %s\n", string_upper( entity ));
   fputline( fp, tmpstr );
   for( i:= 0; i<length(po_list); ++i )
      {
      tmpstr = sprintf( "O %s\n", string_upper( po_list[i]));
      fputline( fp, tmpstr );
      }
   for( i:= 0; i<length(pi_list); ++i )
      {
      tmpstr = sprintf( "I %s\n", string_upper( pi_list[i]));
      fputline( fp, tmpstr );
      }
   fclose( fp );
   }                                                /* end function MAKE_PI */


/*---------------------------------------------------------------------------*/


declare vhdl_files_tab1;
list_vhdl_init := 0;
declare vhd_picklist;
declare vhdl_status;
declare tech_status;
   

function readpins( d, e ) 
   {
   declare pifile;

   entity := get_current_entity( d ); 
   pifile= string_append( work_dir, "/synth/", entity, "/", entity, ".pi" );
   if (fexists( pifile ))
      {
      in_no  = 0;
      out_no = 0;
      fp := fopen( pifile, "r");

      while (!((line := fgetline (fp)) == nil))
         {
         line_length := string_length (line);
         for (index := 0; index < line_length; ++index)
            {
            previous_index := 0;
            if (string_ref (line, index) == ' ')   /* if#1 */
               {
               token := substring (line, previous_index, index);
               if (string_eq (token, "ERROR" )) return(1);
               if (string_eq (token, "MODULE" ))
                  {
                  previous_index := index + 1;
                  current_module = substring(line, previous_index,line_length);
                  }
               if (string_eq (token, "I" ))       /* if#2 */
                  {
                  previous_index := index + 1;
                  token := substring (line, previous_index, line_length);
                  vector_set( in, in_no, token );
                  ++in_no;
                  }
               if (string_eq (token, "O" ))       /* if#2 */
                  {
                  previous_index := index + 1;
                  token := substring (line, previous_index, line_length);
                  vector_set( out, out_no, token );
                  ++out_no;
                  }
               }
            }     /* end of for index < line_length */
         }       /* end of while not at end of file */

      fclose( fp );

      if (in_no > 0 || out_no > 0 )
         {
         current_outnet =  current_module;
         current_report =  current_module;
         }
      }
   else
      {
      vlEx.Throw2( vlEx.FAILURE, "ViewSyn", vlErrSev.Warning,
          sprintf("Cannot open PI file.", pifile) );
      }
   }                                                /* end function READPINS */




/*---------------------------------------------------------------------------*/
/*                                                                           */
/*   CALL_EDITVHDL  function is the object of the EDITVHDL_CMD...            */
/*                                                        It is called only  */
/*   with the data and event objects supplied by core (i.e. no Parameters).  */
/*                                                                           */
/*                                                                           */
/*                                                                           */
function call_editvhdl( d, e ) 
   {
   entity := get_current_entity( d ); 
   srclist := copy_list( vhdsrc_list );
   
   while (! null(srclist ) && (! string_eq( car(car( srclist )), entity)) )
      srclist = cdr( srclist );

   vhd_file := string_append(work_dir, "/", cdr( car( srclist ))); 
   if (! fexists( vhd_file ))
      vlEx.Throw2( vlEx.FAILURE, "ViewSyn", vlErrSev.Warning,
          sprintf( "VHDL source file does not exist.", vhd_file) );

   vcWin.TextEdit (vdes2_win, vhd_file, nil, nil, FALSE, FALSE);
   }                                           /* end function CALL_EDITVHDL */


/*---------------------------------------------------------------------------*/
/*                                                                           */
/*   CALL_COMPILEVHDL  function is the object of the COMPILEVHDL_CMD  to     */
/*   "Re-compile VHDL Source".  It is called with the data and event objects */
/*   supplied by core, a string representing the VHDL source file, a flag of */
/*   type aluEnum (Yes, No) indicating whether AluCons is to be run, and an  */
/*   integer between 1-100 representing the speed priority (as opposed to    */
/*   area).  This function will call HAC_COMPILE to compile the VHDL file.   */
/*                                                                           */

function call_compilevhdl(d,e, vhdfile, runalu, speed)
   {
   runAluCons = runalu;
   aluSpeed = speed;

   entity := get_current_entity( d ); 
   srclist := copy_list( vhdsrc_list );
   while ( !null(srclist ) && !string_eq(car( car( srclist )), entity)  )
       srclist = cdr( srclist );

   vhd_file := string_append(work_dir, "/", cdr( car( srclist ))); 
   if (! fexists( vhd_file ))
      vlEx.Throw2( vlEx.FAILURE, "ViewSyn", vlErrSev.Warning,
          sprintf( "VHDL source file does not exist.", vhd_file) );

   block_commands( "VHDL Compilation" );
   blocking_popup = 1;
   hac_compile( d, e, vhd_file );
   }                                        /* end function CALL_COMPILEVHDL */



/*---------------------------------------------------------------------------*/
/*                                                                           */
/*  READ STATUS  function reads the $initial section of 'top.ref' file and   */
/*  constructs a global 'status_list', of the form:                          */
/*                                                                           */
/*        ( (v1, status1) (v2, status2) ... (vn, statusn) )                  */
/*                                                                           */
/*                                                                           */ 
/*  where  v is a entity vertex name, and  status is an integer status code. */
/*                                                                           */ 

function readStatus()
   {
   declare fp1;
  
    filename := string_append( work_dir, "/top.ref" );
    if (fexists ( filename ) )
       {
       fp1 = fopen( filename, "r" );

       linein := fgetline( fp1 );           /* eat '$initial' line */

       if ( !null(linein) && string_eq(substring(linein,0,7),"$techno") )
          fgetline( fp1 );       
      /*  eat '$technology foo' line if exists.   bug 18358: 01/04/95 plabee */

       if ( !null( fp1 ))
          {
          while( !null( linein = fgetline( fp1 )) && 
                 (string_eq(substring(linein,0,7),"$preopt")==FALSE))
             {
             if (! lindex(linein,',') )
                vlEx.Throw2 (vlEx.FAILURE, "ViewSyn", vlErrSev.Warning,
                    sprintf( "Syntax Error in %s at:\n%s", filename,linein) );

             entity := substring( linein, 0, lindex(linein,','));
             statuschunk := substring( linein, lindex( linein, ',') +2,0); 
             status := substring( statuschunk, 0, lindex( statuschunk, ',')); 
             status = convert( integer, status );
             if (null( status_list ))
                status_list = cons( cons( entity, status ), nil );
             else
                status_list = cons( cons( entity, status ), status_list );
             }
          fclose( fp1 );
          }
       else
          vlEx.Throw2 (vlEx.FAILURE, "ViewSyn", vlErrSev.Error,
                       sprintf ("Cannot open top.ref for reading."));
      }
   }                                             /* end function READ STATUS */



/*---------------------------------------------------------------------------*/



function hac_hierarchy( d, command )
   {
   vcWin.Busy( vdes2_win, TRUE );
   blocking_popup = 1;
   block_commands( "'Modify Hierarchy'" );
   vcWv.CommandSequence(
      list ("cd " + work_dir + "; " + command),
      nil,
      func(str) {
          vcTxShell.PrintString(nusyn_sh,str);},
      nil,
      func(mode,code) { 
          update_icons( tree_region, TRUE ); 
          readStatus();
          blocking_popup = 0;
          unblock_commands();
          vcWin.Busy( vdes2_win, FALSE );
      } ,nil );
   }                                           /* end function HAC_HIERARCHY */



function hac_cleanup(d,e )  
   {
   vcWin.Busy( vdes2_win, TRUE );
   vcWv.CommandSequence(
        list ("cd " + work_dir + "; vsyn -cleanup" ),
        nil,
        func(str) { vcTxShell.PrintString(nusyn_sh,str);},
        nil,
        func(mode,code)
           {
           if (!null(tree_region)) 
              foreach( v; vcTree.Vertices( tree_region ))
                 {
                 vertex_name := vcTree.VrtxGetItem(v);
                 if ( !null(vertex_name) &&
                      (string_eq(vertex_name, rootNode) == TRUE) )
                    {
                    vcTree.VrtxRemove(v);
                    vcRegion.Refresh(tree_region, vcRegion.Area(tree_region));
                    }
                 }
           text2 := sprintf("To view a design, compile VHDL source files.\n");
           vcWin.ClearStatus (vdes2_win);
           vcWin.AddStatus (vdes2_win, text2);
           text3 := vcRegion.Create("",vcStaticText.fac,"Target Technology: "
                                       +current_tech+"              Design: ");
           vcRegion.Font (text3, vgFont.small);
           vcRegion.AddChild(d.ovly1, text3);
           vcOverlay.SetCurrent(d.ovly1, text3);
           blocking_popup = 0;
           unblock_commands();
           vcWin.Busy( vdes2_win, FALSE );
           vcCmd.Enable( seldesign2_cmd,       vlOnOff.Off);
           vcCmd.SetDisabledMsg( seldesign2_cmd,
                                            " No compiled VHDL data exists." );
           vcCmd.Enable( full_view_cmd,        vlOnOff.Off );
           vcCmd.SetDisabledMsg( full_view_cmd,
                                            " No compiled VHDL data exists." );
           vcCmd.Enable( show_toggle_edge_cmd, vlOnOff.Off );
           vcCmd.SetDisabledMsg( show_toggle_edge_cmd,
                                            " No compiled VHDL data exists." );
           vcCmd.Enable( find_cmd,             vlOnOff.Off );
           vcCmd.SetDisabledMsg( find_cmd,
                                            " No compiled VHDL data exists." );
           vcCmd.Enable( show_level_cmd,       vlOnOff.Off );
           vcCmd.SetDisabledMsg( show_level_cmd,
                                            " No compiled VHDL data exists." );
           vcCmd.Enable( view_preopt_cmd,      vlOnOff.Off );
           vcCmd.SetDisabledMsg( view_preopt_cmd,
                                            " No compiled VHDL data exists." );
           vcCmd.Enable( view_premap_cmd,      vlOnOff.Off );
           vcCmd.SetDisabledMsg( view_premap_cmd,
                                            " No compiled VHDL data exists." );
           vcCmd.Enable( setroot_cmd,          vlOnOff.Off );
           vcCmd.SetDisabledMsg( setroot_cmd,
                                            " No compiled VHDL data exists." );

           vcWin.UpdateMenus (vdes2_win);
           filename := string_append( work_dir, "/top.ref" );
           if ( fexists( filename )) 
              vscript.vsDelete( filename, vscript.vsFILE );
           },
           nil );    /* end Command Sequence */
   
   }                                             /* end function HAC_CLEANUP */




/*---------------------------------------------------------------------------*/
/*                                                                           */
/*   HAC_COMPILE  function will call vsyn to compile a vhdl source file.     */
/*                                                                           */
/*   If the global variable <runAluCons> is set to "Yes", vsyn is called and */
/*   the output is handled differently. In particular, a command file named  */
/*   "alutmp.cmd" is created to call vsyn, and a temporary file is created   */
/*   to hold the output from alu_cons, which is written to stdout.           */
/*                                                                           */
/*   In both cases, after vsyn finishes, the menus are restored, the top.ref */
/*   file is read and the internal data structures are updated, and the      */
/*   dependance diagram is updated.                                          */
/*                                                                           */
/*   This function is called by one of the following functions, which will   */
/*   supply the data and event objects, and with a string of vhdl source     */
/*   names separated by spaces.                                              */
/*                                                                           */
/*        function:              command:            file:                   */
/*                                                                           */
/*        call_compilevhdl       compilevhdl_cmd     vsyn2.vs                */
/*        call_compile_vhdl1     compile_vhdl_cmd1   vsyn_2.vs               */

function hac_compile( d, e, vhdfiles )
   {
   function compile_failed()               /* nested function COMPILE_FAILED */
      {
      msg := " No compiled VHDL data exists.";

      if ( fexists( string_append( work_dir, "/top.ref") ))
         {
         vcCmd.Enable(          seldesign2_cmd,       vlOnOff.Off );
         vcCmd.SetDisabledMsg(  seldesign2_cmd,       msg         );
         }
 
      if (null(tree_region))
         {
         vcCmd.Enable(          full_view_cmd,        vlOnOff.Off );
         vcCmd.SetDisabledMsg(  full_view_cmd,        msg         );

         vcCmd.Enable(          show_toggle_edge_cmd, vlOnOff.Off );
         vcCmd.SetDisabledMsg(  show_toggle_edge_cmd, msg         );

         vcCmd.Enable(          find_cmd,             vlOnOff.Off );
         vcCmd.SetDisabledMsg(  find_cmd,             msg         );

         vcCmd.Enable(          show_level_cmd,       vlOnOff.Off );
         vcCmd.SetDisabledMsg(  show_level_cmd,       msg         );

         vcCmd.Enable(          view_preopt_cmd,      vlOnOff.Off );
         vcCmd.SetDisabledMsg(  view_preopt_cmd,      msg         );

         vcCmd.Enable(          view_premap_cmd,      vlOnOff.Off );
         vcCmd.SetDisabledMsg(  view_premap_cmd,      msg         );

         vcCmd.Enable(          setroot_cmd,          vlOnOff.Off );
         vcCmd.SetDisabledMsg(  setroot_cmd,          msg         );
         }
 
      vcWin.UpdateMenus (vdes2_win);

      vlEx.Throw2 (vlEx.FAILURE, "ViewSyn", vlErrSev.Error,
      sprintf("VHDL Compilation has errors. Please check the synth.err file."));
                      
      }                                /* end nested function COMPILE_FAILED */



   function compile_restore()             /* nested function COMPILE_RESTORE */
      {
      unblock_commands();
      blocking_popup = 0;
      vcWin.Busy( vdes2_win, FALSE );
      }                               /* end nested function COMPILE_RESTORE */



   function compile_succeed()             /* nested function COMPILE_SUCCEED */
      {
      vcWin.ClearStatus( vdes2_win );
      vcWin.AddStatus(vdes2_win, sprintf("Successful compile: %s", vhdfiles));

      read_reffile();                     
      rootNode = rootList[ length(rootList) -1];             /* last in list */
      call_select_design( d,e, rootNode );                 /* update diagram */
      readStatus();
      }                               /* end nested function COMPILE_SUCCEED */




   /* ---------------  HAC_COMPILE  entry point ---------------------------- */

   declare alutmp_files,  /* space-separated string of "_alutmp" file names  */
           alu_temp,      /* temporary "_alutmp" file to hold AluCons output */
           filenum,       /* enumerates <alu_temp> files.                    */
           vhdname;       /* base name of one vhdl file in <vhdfiles> string */

   vcWin.Busy( vdes2_win, TRUE );


   if (runAluCons == aluEnum.Yes)             /* ---- Run AluConstructor ----*/
      {
      alutmp_files = "";   filenum = 0;
      fp :=fopen( work_dir + "/alutmp.cmd", "w" );

      if ( null( fp ) )    vlEx.Throw2(vlEx.FAILURE, "ViewSyn", vlErrSev.Error,
                                 "Cannot open temporary file 'alutmp.cmd'."  );

      foreach( token; string_loop( vhdfiles, " " ))
         {
         ++filenum;
         /* construct temp file name to hold AluCons output */
         vhdname  = substring( token, 0, rindex(token,'.'));
         alu_temp = string_append( vhdname, "_alutmp",
                                   number2string(filenum), ".vhd");

         alutmp_files = string_append( alutmp_files, " ", alu_temp );
         alustr := sprintf("alu_cons %s %s %s > %s\n", token, 
                           number2string(aluSpeed), current_tech, alu_temp);
         fputline( fp, alustr );
    
         }
      fclose(fp);

      vcWv.CommandSequence(
          list (
             func()                                      /* functions to run */
                {
                vcWin.ClearStatus( vdes2_win );
                vcWin.AddStatus(vdes2_win, "Running Alu Constructor...");
                TRUE;
                },
             "cd " + work_dir + "; chmod +x alutmp.cmd; ./alutmp.cmd; "
                   +"vsyn -vhdl " + alutmp_files),
          nil,                                           /* environment list */

          func(str)                                        /* output handler */
             {
             if ( !( string_eq( substring( str, 0, 3), "ld.")
                     && (length(str) > 3)                    ))
                vcTxShell.PrintString(nusyn_sh,str);
             },

          nil,                                              /* error handler */
          func(mode,code)                                    /* exit handler */
             {
             compile_restore();

             if ( fexists( work_dir + "/alutmp.cmd" )) 
                vscript.vsDelete( work_dir +"/alutmp.cmd",vscript.vsFILE);

             foreach( token; string_loop( alutmp_files, " ")) 
                vscript.vsDelete( token, vscript.vsFILE );
              
             if ( (code == 0) && (mode == vcSysMode.Exited))
                {
                /* ---- massage temporary alucons names in top.ref --- */
                /* ---- back to originals - this is --- pretty bad --- */

                vcWv.CommandSequence(
                    list(
                       "cd " + work_dir
                          +"; cat top.ref | sed -e 's/_alutmp[1-9]*\./\./g'"
                          +"> tmpaluh.tmp; mv tmpaluh.tmp top.ref",
                       func()
                          {
                          vcWin.ClearStatus( vdes2_win );
                          vcWin.AddStatus(vdes2_win,"File 'top.ref' restored.");
                          },
                       compile_succeed ),               /* assuming no error */
                                                        /* occurs with 'sed' */
                    nil,
                    func(str) { vcTxShell.PrintString(nusyn_sh,str);},
                    nil,
                    func(m,c) {TRUE;},
                    nil              );
                }                                  /* ---- if Exited OK ---- */
             else   compile_failed();
             },

          nil  );        /* end "runAluCons == aluEnum.Yes" Command Sequence */

      }                                 /* ----  end if running ALUCONS ---- */

   else                                 /* ----  don't run ALUCONS --------- */
      {
      vcWin.Busy( vdes2_win, TRUE);
      vcWv.CommandSequence(
          list ( "cd " + work_dir + "; vsyn -vhdl " + vhdfiles ),
          nil,
          func(str) { vcTxShell.PrintString(nusyn_sh,str);},       /* output */
          nil,

          func(mode,code)                                    /* exit handler */
             {
             compile_restore();

             if ( (code == 0) && (mode == vcSysMode.Exited))
                   compile_succeed();
             else  compile_failed();
             },

          nil );          /* end "runAluCons == aluEnum.No" Command Sequence */
      }                      /* end plain vsyn (hac) invocation - no ALUCONS */

   }                                             /* end funciton HAC_COMPILE */

/*---------------------------------------------------------------------------*/



function synth_cleanup() {
   tmpstr := sprintf( "Synthesis Complete." );
   vcWin.ClearStatus( vdes2_win );
   vcWin.AddStatus(vdes2_win, tmpstr );
   vcWin.Busy( vdes2_win, FALSE );
   unblock_commands(); 
   blocking_popup = 0;
}



/*---------------------------------------------------------------------------*/
/*                                                                           */
/*  HAC_MAKE  function will call vsyn -n <rootNode> if the node is not empty.*/ 
/*                                                                           */ 
/*  It is called by :                                                        */
/*                                                                           */ 
/*     call_set_optconstraint                                                */
 
function hac_make( treeRegion )
   {
   if (string_eq( rootNode , "" ) != TRUE)
      {
      vcWin.Busy( vdes2_win, TRUE );
      blocking_popup = 1;
      block_commands( "'make'" );

      text2 := sprintf( "Verifying synthesis data is up-to-date...\n");
      vcWin.ClearStatus( vdes2_win );
      vcWin.AddStatus(vdes2_win, text2 );
      
      vcWv.CommandSequence(
            list ("cd " + work_dir + "; vsyn -n " + rootNode ),
            nil,
            func(str) { vcTxShell.PrintString(nusyn_sh,str);},
            nil,
            func(mode,code)
                { 
                blocking_popup = 0;
                unblock_commands();
                vcWin.Busy( vdes2_win, FALSE );
                vcWin.ClearStatus( vdes2_win );
                },
            nil           );
      }
   return( TRUE );
   }                                                /* end function HAC_MAKE */




/*---------------------------------------------------------------------------*/
/*                                                                           */
/*  HAC_MAKE2  function ...                                                  */
/*                                                                           */
/*                                                                           */

function hac_make2( title ) 
   {
   declare pwin;

   function close_win()  vcWin.Close( pwin ); 

   vcWin.Busy( vdes2_win, TRUE );
   blocking_popup = 1;
   block_commands( "'make'" );
   vcWv.CommandSequence(
      list ("cd " + work_dir + "; vsyn -n " + rootNode ),
      nil,
      func(str) { vcTxShell.PrintString(nusyn_sh,str); },
      nil,
      func(mode,code)
          { 
          load(graph_file);

          /* Create a main window with no "bindings" area */
          table := vcTable.Create( title, 2, 1);
          
          button := vcWv.LabelButtonCreate("button",
                          "Dismiss Window", nil, close_win,nil);
          vcTable.Add( table, button );
          vcTable.Add( table, newtree );
          pwin = vcWin.Create( table, vcWin.NoBindings);
        
          vcWin.Busy( vdes2_win, FALSE);
          update_icons( newtree, FALSE ); 
          readStatus();
          blocking_popup = 0;
          unblock_commands();
          if ( fexists( graph_file )) 
             vscript.vsDelete( graph_file, vscript.vsFILE );
          } ,nil );

   return( TRUE );
   }                                               /* end function HAC_MAKE2 */




/*---------------------------------------------------------------------------*/
/*  HAC_UNIQ  function ...                                                   */

function hac_uniq( d, e, entity ) 
   {
   vcWv.CommandSequence(
      list ("cd " + work_dir + "; vsyn -uniq " + entity ),
      nil,
      func(str) {
         vcTxShell.PrintString(nusyn_sh,str);},
      nil,
      func(mode,code) { 
          if ( (code == 0) && (mode == vcSysMode.Exited))  {
              read_reffile();
              call_select_design( d, e, rootNode );
              readStatus();
              vcWin.Busy( vdes2_win, FALSE );
              unblock_commands();
              blocking_popup = 0;
          }
      }
      ,nil );
   }  /* end function HAC_UNIQ */



/*---------------------------------------------------------------------------*/


function cbi_action( entity ) {
   mcmfile := string_append( work_dir, "/synth/", entity, "/", entity, ".mcm" );
   save_cons_to_file( mcmfile );
}
    
function cbi_cancel(foo);
    
function cbo_action( entity  )
   {
   mcmfile := string_append( work_dir, "/synth/", entity, "/", entity, ".mcm");
   save_cons_to_file( mcmfile );
   }

function cbo_cancel( foo );
   
function cbsyn_action(d)
   {
   vcCmd.Enable( synth_cmd,         vlOnOff.Off );
   vcCmd.Enable( output_cmd,        vlOnOff.Off );
   vcCmd.Enable( editinput_cmd,     vlOnOff.Off );
   vcCmd.Enable( editoutput_cmd,    vlOnOff.Off );
   vcCmd.Enable( optconstraint_cmd, vlOnOff.Off );
   vcWin.UpdateMenus (vdes2_win);
  
   /* create default mapping file if needed */
   /*make_defaults();*/

   /* perform synthesis */ 
   block_commands( "VHDL Synthesis" );
   blocking_popup = 1;
   hac_synth( current_entity, force, show, iterate ); 
   vcWin.Busy( vdes2_win, FALSE );
   }                                            /* end function CBSYN_ACTION */

function cbsyn_cancel( str );



/*---------------------------------------------------------------------------*/
/*                                                                           */
/*   PUTWINDOW  function will create a dialog box window with 3-button       */
/*   bottom row                                                              */
/*                                                                           */
/*                                                                           */
/*                                                                           */
/* Create a dialog box window with 3-button bottom row */

function putwindow (cb_action, cb_cancel, region, title, d)
   {
   declare window;

   entity := get_current_entity( d );
   function cancel () {
      vcWin.Destroy (window); semaphore = vlOnOff.On; cb_cancel (TRUE); }
   function action () {  cb_action ( entity ); }
   function accept () {  action (); cancel(); }
   b_accept := vcWv.LabelButtonCreate (title + ".a", "Accept", nil, accept,
      list (macro_on <- TRUE));
   b_apply  := vcWv.LabelButtonCreate (title + ".b", "Apply",  nil, action,
      list (macro_on <- TRUE));
   b_cancel := vcWv.LabelButtonCreate (title + ".c", "Cancel", nil, cancel,
      list (macro_on <- TRUE));

   t_buttons := vcTable.Create ("t_buttons", 1, 3);
   vcTable.Add (t_buttons, b_accept);
   vcTable.Add (t_buttons, b_apply);
   vcTable.Add (t_buttons, b_cancel);

   t_top := vcTable.Create (title, 2, 1);
   vcTable.Add (t_top, region);
   vcTable.Add (t_top, t_buttons);

   window = vcWin.Create (t_top,
      vcWin.NoMenus + vcWin.NoCmdline + vcWin.NoStatus);
   vcWin.DestroyNotify (window,
      func (e) { semaphore = vlOnOff.On; cb_cancel (TRUE); });
   if (semaphore == vlOnOff.Off) {
      vcRegion.Enable (b_accept, vlOnOff.Off, TRUE);
      vcRegion.Enable (b_apply,  vlOnOff.Off, TRUE);
   }
   return (list (b_accept, b_apply, window)); 
} 


/*---------------------------------------------------------------------------*/
/*                                                                           */
/*  UPDATE_ICONS  function is called to read the "top.ref" file and build a  */
/*  temporary data structure to represent the design module qualities        */
/*  described therein.  Then vcTree.VrtxChangeDisplayInfo is called on every */
/*  vertex represented to update the displayed graphical representation.     */
/*                                                                           */
/*  It is called by these funtions:                                          */
/*                                                                           */
/*     call_set_optconstraint   vsyn2.vs                                     */
/*     hac_hierarchy            vsyn2.vs                                     */
/*     hac_make2                vsyn2.vs                                     */
/*     call_select_design       vsyn_2.vs                                    */
/*                                                                           */
/*                                                                           */
/*  It is called with two parameters:   the tree region displayed, and a     */
/*  flag which is TRUE unless in the special case in which pre-optimazation  */
/*  or pre-mapping view is requested.  The vertices are only updated if      */
/*  something is displayed.                                                  */
/*                                                                           */

function update_icons( treeRegion, show_dissolved )   if (treeRegion != nil)
   {
   declare iconlist,   /* rep.s top.ref as list of (vertex, icontype) pairs. */
           icontype,   /* vhdlsrc, compdis, vhdlcomp, optdis, opt, syn; or # */
           vert_name,  /* string name of vertex in (vertex, icontype) pair   */
           icon_name,  /* string name of icon type in (vertex, icontype) pair*/
           linein,     /* input string: line from "top.ref" file             */
           section,    /* top.ref: $initial, $technology, $preopt, $premap   */
           inttype,    /* integer representation of entity's VHDL state      */
           itype;      /* integer representation of vertex's icon type       */

   filename := string_append( work_dir, "/top.ref" );
   if (fexists ( filename ) )
      {
      fp := fopen( filename, "r" );

      while ( !null(linein = fgetline(fp)) && !string_eq( linein, "\n")) 
         {
         if ( string_eq(substring(linein,0,1),"$"))
            {
            section = substring( linein, 1, 6);     /* should look at length */
            }
         else   /* process contents of $section */
            { 
            if ( (commapos := lindex(linein,',')) == FALSE) 
               {
               fclose( fp );
               vcRegion.Refresh( treeRegion, vcRegion.Area( treeRegion ));
               unblock_commands();

               vlEx.Throw2 (vlEx.FAILURE, "ViewSyn", vlErrSev.Warning,
                    sprintf( "Syntax Error in %s at:\n%s", filename,linein) ); 
               }
            vertex_name := substring(linein,  0, commapos);
          
            if (string_eq(section, "initi"))
               {
               linein = substring( linein, commapos+2, 0);
               commapos := lindex(linein,',');

               /* get entity's VHDL state*/
               type := substring( linein, 0, commapos );
               inttype = convert( integer, type);

               if ((inttype & 128) >0)   icontype = "vhdlsrc"; 
               else if ( ((inttype & 1) > 0) || ((inttype & 2) > 0) )
                  {
                  /* dissolved */
                  if (show_dissolved == TRUE)   icontype = "compdis";
                  else icontype = "vhdlcomp";
                  }
               else icontype = "vhdlcomp";
                                                    /* add icon pair to list */
               if (null(iconlist))
                  iconlist = list(cons(vertex_name,icontype));
               else if (member(vertex_name, iconlist) == FALSE)  
                  iconlist = cons(cons(vertex_name, icontype), iconlist);
               if (amgdebug == 1) 
                  printf( "In INIT section, icontype = %s\n", icontype );
               }

            else   /*  either $preopt or $premap section */
               {   
               linein = substring( linein, commapos+2, 0);
               commapos := lindex(linein,',');

               /* get entity's synthesis state*/
               icontype = substring( linein, 0, commapos );
               tmplist := copy_list( iconlist );
               cnt := 0;
               while ( !null(tmplist)
                       && !string_eq(car(car(tmplist)), vertex_name) )
                  {
                  tmplist = cdr(tmplist); 
                  cnt = cnt + 1;
                  }

               if ( !null(tmplist)
                    && string_eq(car(car(tmplist)), vertex_name) ) 
                  {
                  itype = convert( integer, icontype );
                  if (string_eq(section, "preop")) 
                     {                           /* begin $preopt section */
                     if ( itype == 0 )
                        index_set( iconlist, cnt, 
                                   cons( vertex_name, "opt"));
                     else if ( (itype & 64) > 0)
                        index_set( iconlist, cnt, 
                                   cons( vertex_name, "vhdlcomp"));
                     else if ( (itype & 32) > 0)
                        index_set( iconlist, cnt, 
                                   cons( vertex_name, "opt"));

                     else if ( ((itype & 1) > 0) || ((itype & 2) > 0)) 
                        {     /* dissolved */
                        if ((itype & 64) > 0)
                           {
                           if (show_dissolved == TRUE)
                           index_set( iconlist, cnt, 
                                      cons( vertex_name, "compdis"));
                           else
                           index_set( iconlist, cnt, 
                                      cons( vertex_name, "vhdlcomp"));
                           }
                        else  
                           {
                           if (show_dissolved == TRUE)
                              index_set( iconlist, cnt, 
                                         cons( vertex_name, "optdis"));
                           else
                              index_set( iconlist, cnt, 
                                         cons( vertex_name, "opt"));
                           }
                        }     /* dissolved */

                     else     /* not 'opt', 'vhdlcomp', nor dissolved */
                        index_set(iconlist,cnt,cons( vertex_name, "syn"));

                     if (amgdebug == 1)
                        printf( "In PREOPT section, icontype = %s\n",
                                index_ref( iconlist, cnt )          );
                     }     /* end $preopt section */

                  else     /* begin $premap section */
                     {
                     if ( (itype == 0) || (itype == 4) || (itype == 8))
                     index_set( iconlist, cnt, cons( vertex_name, "syn"));
                     if (amgdebug == 1)
                        printf( "In PREMAP section,
                          icontype = %s\n", index_ref( iconlist, cnt ));

                     }     /* end $premap section          */
                  }     /* tmplist entry matches vertex    */
               }     /*  end of $premap / $preopt sections */
            }     /*  end processing contents of $section  */
         }     /* end while line in has content            */


      fclose( fp );

      foreach( v; vcTree.Vertices( treeRegion )) 
         {
         vertex_name := vcTree.VrtxGetItem(v);
         for( i:= 0;  (i<length(iconlist) &&  (!null(vertex_name)) &&
                   string_eq( car( iconlist[i]), vertex_name ) != TRUE); ++i);

         if ( (!null(vertex_name))  && (i <= length(iconlist)-1)) 
            {
            vert_name = car( iconlist[i] );
            icon_name = cdr( iconlist[i] );
  
            if (string_eq( vert_name, vertex_name ) == TRUE)
               {
               printf("vcTree.VrtxChangeDisplayInfo( %s, %s);\n", v,icon_name);
               vcTree.VrtxChangeDisplayInfo( v, icon_name );
               updateLabelColor( v, icon_name );
               }
            }
         }     /* foreach vertex */
   
      vcRegion.Refresh( treeRegion, vcRegion.Area( treeRegion ));
      }                                        /* end IF top.ref file exists */
   }                                           /* end function UPDATE_ICONS  */



function make_defaults() {; }                      /* function MAKE_DEFAULTS */

/**********************
   foreach( v; vcTree.Vertices( tree_region ))
      {
      vertex := vcTree.VrtxGetItem( v );
      if ( !null( vertex ) && (member( vertex, inscope_ent ) != FALSE) )
         {
         tclfile := string_append(work_dir,"/synth/", vertex,"/",vertex,".tcl");
         mcmfile := string_append(work_dir,"/synth/", vertex,"/",vertex,".mcm");

         if (fexists( mcmfile ) == FALSE )
            {
            fpm := fopen( mcmfile, "w" );
            if (null( fpm ))
               vlEx.Throw2( vlEx.FAILURE, "ViewSyn", vlErrSev.Warning,
                   sprintf("Cannot open .mcm file for writing.", mcmfile) );
            
            tmpstr:=sprintf("max_delay %s\n", current_maxdelay);
            fputline( fpm, tmpstr );
            fclose( fpm );
            }

         }
      }     
***********************/



/*---------------------------------------------------------------------------*/
/*                                                                           */
/*   WRITE_INI  function will write the keyword, value pair given by the two */
/*   parameters into 'synth.ini' file.  This is the algorithm:               */
/*                                                                           */
/*   Read each line of synth.ini into temp buffer.                           */
/*   If desired keyword is found, write new keyword,value pair               */
/*      to buffer instead of line read.                                      */
/*   If desired keyword isn't found, write line read in.                     */
/*                                                                           */
/*   This function is called by:                                             */
/*                                                                           */
/*      make_synth_ini          vsyn2.vs                                     */
/*      set_operating_points    vsyn2.vs                                     */
/*      call_set_tech           vsyn2.vs                                     */
/*      call_set_map_defaults   vsyn2.vs                                     */

function write_ini( key, value )
   {
   declare linein, token, tmpstr, tmplst, found;

   found = FALSE;
   filename := string_append( work_dir, "/synth.ini" );

   if (fexists( filename ))
      {
      fp := fopen( filename, "r" );
      if (!null( fp ))
         {
         while ( !null( linein = fgetline( fp )) )
            {
            tmpstr = string_copy( linein );
            linein = string_token( linein, &token, " " );
            if (string_eq( token, key ) )
               {
               linein = string_token( linein, &token, " " );
               if ( (string_eq( key, "max_delay")  && (! string_eq(value,"0")))
                    || (! string_eq( key, "max_delay"))  )
                  {
                  tmpstr = sprintf( "%s %s\n", key, value );
                  tmplst = cons( tmpstr, tmplst );
                  }
               found = TRUE;
               }
            else
                 tmplst = cons( tmpstr, tmplst );
    
            } /* while !EOF synth.ini */
    
         if (found == FALSE)
            {
            if ( ( string_eq( key, "max_delay") && (! string_eq(value,"0")) )
                 || (! string_eq( key, "max_delay"))  )
               {
               tmpstr = sprintf( "%s %s\n", key, value );
               tmplst = cons( tmpstr, tmplst );
               }
            }
    
         fclose ( fp );
         tmplst = reverse_destructive( tmplst );
           
         fp:=fopen( filename, "w" );
         if ( !null( fp ))
            {
            while (!null( tmplst ))
               {
               tmpstr := car( tmplst );
               fputline( fp, tmpstr );
              
               if ( !null(tmplst) )   tmplst = cdr( tmplst );
               }
            fclose( fp );
            }
         else
              vlEx.Throw2 (vlEx.FAILURE, "ViewSyn", vlErrSev.Error,
                  sprintf ("Cannot open synth.ini for write operation." ));
         }
       else
           vlEx.Throw2 (vlEx.FAILURE, "ViewSyn", vlErrSev.Error,
               sprintf ("Cannot open synth.ini for read operation." ));
      }
   else                          /* synth.ini file doesn't exist - create it */
      {
      filename = string_append( work_dir, "/synth.ini" );
      fp:=fopen( filename, "w" );
        
      if (!null( fp ))
         {
         /* write command */
         tmpstr := sprintf( "%s %s\n", key, value );
         fputline( fp, tmpstr );
         fclose( fp );
         }
      else 
         vlEx.Throw2 (vlEx.FAILURE, "ViewSyn", vlErrSev.Error,
             sprintf ("Cannot open synth.ini for write operation." ));
      }
   }                                               /* end function WRITE_INI */

     



function make_synth_ini()
   {
   declare fp, tmpstr, linein, token, tmp, found;

   found = 0;
   filename := string_append( work_dir, "/synth.ini" );

   if (fexists( filename ) )
      {
      /* verify technology line exists in synth.ini */
      fp  = fopen( filename, "r" );
      if ( !null( fp ) )
         {
         while ( !null( linein = fgetline( fp )))
            {
            linein = string_token( linein, &token, " " );
            if (string_eq( token, "technology"))  found = 1;
            }

         fclose( fp );
         if (found == 0)   write_ini( "technology", current_tech );
         }
      }
   else
       write_ini( "technology", current_tech );
   }                                          /* end function MAKE_SYNTH_INI */



function call_synth(d,e, entity, tech, pack, proc,volt,temp,show,force,iterate)
   {
   declare tmpstr;

   /* check for synth.ini - create if needed */
   make_synth_ini();

   /* perform synthesis */ 
   vcWin.Busy( vdes2_win, TRUE );
   block_commands( "VHDL Synthesis" );
   blocking_popup = 1;
   hac_synth( current_entity, force, show, iterate ); 
   }                                              /* end function CALL_SYNTH */



changing := FALSE;
declare area_bar;
declare area_cmdline;
declare con_bar;
declare con_cmdline;
declare letter;
/*
declare speed_bar;
*/
area_speed := 1;
temp_value := 1;
last_area_speed := area_speed;


function area_bar_changed(v)
   {
   if (!changing)
      {
      area_speed = v;     /*convert (vlPositiveIntVT, v); */
      changing = FALSE;
      }
   }                                        /* end function AREA_BAR_CHANGED */


function update_areabar(str) {

    if (!changing ) {
        changing = TRUE;
        area_speed = convert( integer, str );
        if( !(area_speed >=1 && area_speed <= 100 )) {
            area_speed = 1;
            vcCmdline.Set(area_cmdline, "     "+number2string(area_speed));
        }
        vcScalebar.set( area_bar, area_speed );
        changing = FALSE;
    }
}


function init_sfile() {

    if( pins_file != nil && pack_file != nil && cons_file != nil ) {
        spins_file = pins_file + "s";
        spack_file = pack_file + "s";
        scons_file = cons_file + "s";
    }
    else {
        set_stdout(TRUE);
        print("***ERROR:  Can NOT produce syn files");
    }
}
    
   
function ini_package() {

   declare token, line; 
   current_temperature = 25.0;
   current_voltage = 5.0;
   current_process_type = "typical";
   current_package = empty_package;
   new_process_type = "typical";
   new_package = empty_package;
   /*fp := fopen( v2.pack_file, "r");
   line := fgetline (fp);
   fclose( fp );
   if( line != nil ) {
      token := substring (line, 0, 3 );
      if( string_eq (token, "ERR" )) return(1);
      else return( 0 );
   }
   else return( 1 );
   */
   return(0);
} 

declare w;
declare filename;
function check_packfile( call_when_done ) {
      if( fexists( spack_file ))
          call_when_done();
        else
          vcWv.Timer( wv, 1000, func(){check_packfile( call_when_done);}
                        , FALSE);
}

function pre_tech() {
      current_tech = " ";
      vcCmd.Enable(set_points_cmd,    vlOnOff.Off); 
      vcCmd.Enable (editinput_cmd,  vlOnOff.Off );
      vcCmd.Enable (editoutput_cmd,  vlOnOff.Off );
      vcCmd.Enable(optconstraint_cmd, vlOnOff.Off); 
      vcCmd.Enable(output_cmd,        vlOnOff.Off); 
      vcCmd.Enable(synth_cmd,         vlOnOff.Off);
      vcCmd.Enable (wire_cmd,         vlOnOff.Off);
      vcCmd.Enable (show_report_cmd,  vlOnOff.Off);
      vcWin.UpdateMenus (vdes2_win);
}


/*---------------------------------------------------------------------------*/
/*                                                                           */
/*  POST_TECH  funciton is the object of the CALL_SET_TECH command, and is   */
/*  also called by these functions:                                          */

function post_tech( d, e, tech )   if (ini_package() == 0)
   {
   current_tech = tech;
   vcCmd.Enable( set_points_cmd,       vlOnOff.On);
   vcCmd.Enable( compile_vhdl_cmd1,    vlOnOff.On);

   filename := string_append( work_dir, "/top.ref" );
   if (fexists( filename ))
      vcCmd.Enable( seldesign2_cmd,       vlOnOff.On);
   else
      {
      vcCmd.Enable( seldesign2_cmd,       vlOnOff.Off);
      vcCmd.SetDisabledMsg( seldesign2_cmd, " No compiled VHDL data exists." );
      }

   vcCmd.Enable( optconstraint_cmd,    vlOnOff.On);

   if( !string_eq(current_design, " " ) ) 
      vcCmd.Enable(synth_cmd,           vlOnOff.On);
   
   vcWin.UpdateMenus (vdes2_win);
   text2 := sprintf( "Compile VHDL or select an already compiled design.\n");
   vcWin.ClearStatus (vdes2_win);
   vcWin.AddStatus (vdes2_win, text2);
   
   text3 := vcRegion.Create ("", vcStaticText.fac, "Target Technology: "+tech);
   vcRegion.Font (text3, vgFont.small);
   vcRegion.AddChild(d.ovly1, text3);
   vcOverlay.SetCurrent(d.ovly1, text3);
   }                                               /* end function POST_TECH */

/*---------------------------------------------------------------------------*/
/*                                                                           */
/*  CALL_SHOW_REPORT  function is the object of the  SHOW_REPORT_CMD.        */

function call_show_report( d, e )
    {
    rpt := string_append( work_dir, "/", get_current_entity( d ), ".rpt" );
    if (fexists( rpt ))
       ret := vcWin.TextEdit (vdes2_win, rpt, nil, nil, FALSE, TRUE);
    else
       vlEx.Throw2 (vlEx.FAILURE, "ViewSyn", vlErrSev.Error, 
                    sprintf ("Cannot open report file for reading."));

    }                                       /* end function CALL_SHOW_REPORT */



/*---------------------------------------------------------------------------*/
/*                                                                           */
/*  CALL_SET_OPTCONSTRAINT  funtion is the object of the OPTCONSTRAINT_CMD.  */
/*                                                                           */

function call_set_optconstraint( d, e, optV, cpuV, flatV, redunV )
   {
   /** vcTxShell.PrintString(nusyn_sh,
      call_set_optconstraint with:\n %s\n %s\n %s\n %s\n",
                         optV, cpuV, flatV, redunV)                        );*/

   declare ctlfile,     /* current entity .ctl control file in synth/entity  */
           fp,          /* <ctlfile> file pointer                            */
           tmp,         /*     */
           tmpstr,      /*     */
           optstr,      /*     */
           flatstr,     /*     */
           cpustr,      /*     */
           redunstr;    /*     */

   if (optV == opt.off)        optstr = "off";
   else if (optV == opt.area)  optstr = "area";
   else if (optV == opt.speed) optstr = "speed";
             
   if (cpuV == cpu.low)         cpustr = "low";
   else if (cpuV == cpu.medium) cpustr = "medium";
   else if (cpuV == cpu.high)   cpustr = "high";
            
   if (flatV == flat.off)         flatstr = "off";
   else if (flatV == flat.low)    flatstr = "low";
   else if (flatV == flat.medium) flatstr = "medium";
   else if (flatV == flat.high)   flatstr = "high";
             
   if (redunV == redun.off)      redunstr = "off";
   else if (redunV == redun.on)  redunstr = "on";

   tmp = get_current_entity( d );
   ctlfile = string_append( work_dir, "/synth/", tmp, "/", tmp, ".ctl");

   fp = fopen( ctlfile ,"w");
   if (fp != nil)
      {     
      tmp = string_append( "opt ",  optstr );
      tmpstr = sprintf( "%s\n", tmp );
      fputline( fp, tmpstr );

      tmp = string_append( "cpu_effort ",  cpustr );
      tmpstr = sprintf( "%s\n", tmp );
      fputline( fp, tmpstr );
         
      tmp = string_append( "flatten ",  flatstr );
      tmpstr = sprintf( "%s\n", tmp );
      fputline( fp, tmpstr );
         
      tmp = string_append( "redundancy_removal ",  redunstr );
      tmpstr = sprintf( "%s\n", tmp );
      fputline( fp, tmpstr );
        
      fclose( fp );
      hac_make( tree_region ); 
      update_icons( tree_region, TRUE ); 
      readStatus();
      }
   else
      vlEx.Throw2 (vlEx.FAILURE, "ViewSyn", vlErrSev.Error, 
                   sprintf ("Cannot open .ctl file for reading."));

   }                                   /* end function CALL_SET_OPTCONSTRAINT */




/* ------------------------------------------- Dead Code----------------------

function file_eq( file1, file2 )
   {
   declare fp1, fp2;

   fp1 = fopen( file1, "r" );
   if (!null(fp1))
      {
      fp2 = fopen( file2, "r" );
      if (!null( fp2 ))
         {
            while ( ( !null(line1 := fgetline( fp1 ))) &&
                    ( !null(line2 := fgetline( fp2 ))) ) {
                if ( !null(line1)  && !null(line2) &&
                     !string_eq( line1, line2 ))
                   return( 1 );
                if ( (null(line1)  && !null(line2)) ||
                     (!null(line1) && null(line2)) )
                   return( 1 );
            }
        }
        else
            error( "Cannot open file.", file2 );
    }
    else
        error( "Cannot open file.", file1 );
    fclose( fp1 );
    fclose( fp2 );
    return( 0 );
} ----------------------------------------more Dead Code-----------------------


function make_mcm_file( mcmfile, prtfile, maxdelay)  {

declare fp1, fp2, fp3, tmpstr, linein;

/* ----------------------------------
   mcm file content:
  
   -max_delay <integer>
  
   mapping constraints from .prt file
   ----------------------------------
   fp1 = fopen( mcmfile, "w" );
   if (!null( fp1 )) {

      /* get <entity>.prt contents *//*---
      if (fexists( prtfile )) {
          fp3 = fopen( prtfile, "r" );
          if (!null( fp3 )) {
              while( !null( linein=fgetline( fp3 ) ))
                  fputline( fp1, linein );
              fclose( fp3 );
          }
          else
              error( "Cannot open '<entity>.prt'.", fp3 );
       }

       /* put max_delay command in .mcm file *//*---
       if (current_maxdelay != 0)
           tmpstr:=sprintf("max_delay %s\n", current_maxdelay);
       fputline( fp1, tmpstr );

       fclose( fp1 );
   }
   else
        error( "Cannot open filename.", mcmfile );
} ---------------------------------------- End Dead Code---------------------*/
     



/*---------------------------------------------------------------------------*/

function update_arrive_table(s) {

         if (amgdebug==1) printf("Inside 'update_arrive_table'...\n");
         if (amgdebug==1) printf("in_bar_reg = '%s'...\n", in_bar_reg);
         if (amgdebug==1) printf("in_arrive_rise = '%s'...\n", in_arrive_rise);
         if (amgdebug==1) printf("in_arrive_fall = '%s'...\n", in_arrive_fall);
         if( string_eq(s, "rsfa") || string_eq(s, "rise") ){ 
             for( i:=0; i < in_no; ++i ){
                  logscale_set(vector_ref(in_bar_reg, i), 
                                vector_ref(in_arrive_rise, i));
             }
         }
         else {
             for( i:=0; i < in_no; ++i ) {
                  logscale_set(vector_ref(in_bar_reg, i),
                                vector_ref(in_arrive_fall, i));
             }
        }

}

    

/*---------------------------------------------------------------------------*/

function update_require_table(s) {
         if (amgdebug==1) printf("Inside 'update_require_table'...\n");
         if (amgdebug==1) printf("out_bar_reg = '%s'...\n", out_bar_reg);
         if (amgdebug==1) printf("out_require_rise = '%s'...\n", out_require_rise);
         if (amgdebug==1) printf("out_require_fall = '%s'...\n", out_require_fall);


         if( string_eq(s, "rsfa") || string_eq(s, "rise") ) 
             for( i:=0; i < out_no; ++i ) 
                  logscale_set(vector_ref(out_bar_reg, i),  
                                vector_ref(out_require_rise, i));
         else
             for( i:=0; i < out_no; ++i )
                  logscale_set(vector_ref(out_bar_reg, i), 
                                vector_ref(out_require_fall, i));
    }

    

/*---------------------------------------------------------------------------*/

function call_clear_arrival() {
         for( i:=0; i < in_no; ++i )
              logscale_set(vector_ref(in_bar_reg, i), 
                            0);

    }

    function call_clear_require() {
         for( i:=0; i < out_no; ++i )
              logscale_set(vector_ref(out_bar_reg, i), 
                            max_time);
    }

    function in_bar_changed(i) {
        

         if (!changing ) {
             if( string_eq(input_cons_type, "rsfa")) {
                 vector_set( in_arrive_rise, i, vector_ref(arrive_time,i) );
                 vector_set( in_arrive_fall, i, vector_ref(arrive_time,i)); }
             else if( string_eq(input_cons_type, "rise"))
                      vector_set( in_arrive_rise, i, vector_ref(arrive_time,i));
             else
                      vector_set( in_arrive_fall, i, vector_ref(arrive_time,i) );              
             changing = FALSE;
         }
    }

    function out_bar_changed(i) {

         declare tt;

         if (!changing ) {
             if( string_eq(output_cons_type, "rsfa")) {
                 vector_set( out_require_rise, i, vector_ref(require_time,i));
                 vector_set( out_require_fall, i, vector_ref(require_time,i));}
             else if( string_eq(output_cons_type, "rise"))
                      vector_set( out_require_rise, i, vector_ref(require_time,i));
             else
                      vector_set( out_require_fall, i,vector_ref(require_time,i));
            changing = FALSE;
        }
    }


function load_cons_from_file( filename ) {
          
   load_cons( filename );
   update_require_table( "rsfa" );
   update_arrive_table( "rsfa" );
   for (j:=0; j< in_no; ++j ) {
      stringregion_set( vector_ref(in_load_reg, j), vector_ref(in_load,j) );
      stringregion_set( vector_ref(in_drive_rise_reg, j), vector_ref(in_drive_rise,j) );
      stringregion_set( vector_ref(in_drive_fall_reg, j), vector_ref(in_drive_fall,j) );
   }
   for (j:=0; j< out_no; ++j )
      stringregion_set( vector_ref(out_load_reg, j), vector_ref(out_load,j));
             
}

function save_cons_to_file( filename ) {

   fp := fopen( filename, "w" );
   if (amgdebug==1) {
       printf( "\n\n\tin_no = %d, out_no = %d\n", in_no, out_no );
       printf( "in_arrive_rise = %s\n", in_arrive_rise );
       printf( "in_arrive_fall = %s\n", in_arrive_fall );
       printf( "in_load        = %s\n", in_load);
       printf( "in             = %s\n", in);
       printf( "in_drive_rise  = %s\n", in_drive_rise);
       printf( "in_drive_fall  = %s\n", in_drive_fall);
       printf( "out_require_rise  = %s\n", out_require_rise);
       printf( "out_require_fall  = %s\n", out_require_fall);
       printf( "out_load        = %s\n", out_load);
       printf( "out        = %s\n", out);
   }
   for (i := 0; i < in_no; ++i ) {
      if( !string_eq(vector_ref( in_arrive_rise, i), max_time ) 
         && !string_eq(vector_ref( in_arrive_fall, i), max_time ))
            fprintf( fp, "input_arrival %s %s %s\n",
                         vector_ref( in_arrive_rise, i),
                         vector_ref( in_arrive_fall, i),
                         vector_ref( in, i ));
      if( !string_eq(vector_ref( in_load, i), max_time )) 
                  fprintf( fp, "max_input_load %s %s\n",
                               vector_ref( in_load, i),
                               vector_ref( in, i ));
      if( !string_eq(vector_ref( in_drive_rise, i), max_time )
                    && !string_eq(vector_ref( in_drive_fall, i), max_time ))
                  fprintf( fp, "input_drive %s %s %s\n",
                               vector_ref( in_drive_rise, i),
                               vector_ref( in_drive_fall, i),
                               vector_ref( in, i ));
   } /* ----- for ----- */

   for (i := 0; i < out_no; ++i ) {
      if( !string_eq(vector_ref( out_require_rise, i), max_time )
           && !string_eq(vector_ref( out_require_fall, i), max_time ))
              fprintf( fp, "output_required %s %s %s\n",
                               vector_ref( out_require_rise, i),
                               vector_ref( out_require_fall, i),
                               vector_ref( out, i ));
      if( !string_eq(vector_ref( out_load, i), max_time ))
              fprintf( fp, "output_load  %s %s\n",
                               vector_ref( out_load, i),
                               vector_ref( out, i ));
   } /* ----- for ----- */


   fclose( fp );
}



/*---------------------------------------------------------------------------*/

function call_set_mapconstraint( d, e )
   {
   declare load_cons_file;
   declare save_cons_file;
   declare prtfile, pdffile, tmpfile, mcmfile ;

   function load_cons( filename)
      {
      declare pos;

      function findpin( str, flg ) 
         {
         if (string_eq(flg, "I" ))
            {
            for( j :=0; j < in_no; ++j )  
               if( string_eq( vector_ref( in, j ), str ))   return(j); 
            }
         else if( string_eq(flg, "O" ))
            { 
            for( j :=0; j < out_no; ++j )
               if( string_eq( vector_ref( out, j ), str ))  return(j);
            }
         return( -1 );
         }                                   /* end nested function FINDPIN */
     
 
      function init_cons()
         { 
         /* reinitialize constrain vectors */

         for(i := 0; i < in_no; ++i ) 
            {
            vector_set( in_arrive_rise, i, "0" );
            vector_set( in_arrive_fall, i, "0" );
            vector_set( in_drive_rise, i, max_time );
            vector_set( in_drive_fall, i, max_time );
            vector_set( in_load, i, max_time );
            }
         for(i := 0; i < out_no; ++i ) 
            {
            vector_set( out_require_rise, i, max_time );
            vector_set( out_require_fall, i, max_time );
            vector_set( out_load, i, max_time );
            }
         }                                 /* end nested function INIT_CONS */

      function set_cons_all( pin_name, type, val1, val2 )
         {
         if (!char_eq( pin_name[0], '*') ) return( -1 ); 
         if (string_eq (type, "input_arrival" )) 
            for (i := 0; i < in_no; ++i )
               {
               vector_set(in_arrive_rise, i, val1 );
               vector_set(in_arrive_fall, i, val2 ); 
               }

         if (string_eq (type, "input_drive" )) 
            for (i := 0; i < in_no; ++i ) 
               {
               vector_set(in_drive_rise, i, val1 );
               vector_set(in_drive_fall, i, val2 ); 
               }

         if (string_eq (type, "input_load" ))
            for (i := 0; i < in_no; ++i )
               vector_set(in_load, i, val1 );

         if (string_eq (type, "output_required" ))
            for (i := 0; i < out_no; ++i )
               {
               vector_set(out_require_rise, i, val1 );
               vector_set(out_require_fall, i, val2 ); 
               }
         if( string_eq (type, "output_load" ))
            for( i := 0; i < out_no; ++i ) 
               vector_set(out_load, i, val1 );

         return( 1 );
         }                               /* end nested function SET_CONS_ALL */

 
      /* . . . . . . . . . . . . . entry point for nested function LOAD_CONS */

      init_cons();
      fp := fopen( filename, "r");
      if (amgdebug==1)
         printf("Inside 'load_cons', opened file '%s'...\n", filename );

      while (!((line := fgetline (fp)) == nil))
         {
         line_length := string_length (line);
         for (index := 0; index < line_length; ++index)
            {
            previous_index := 0;
            if (string_ref (line, index) == ' ')   /* if#1 */
               {
               token := substring (line, previous_index, index); 
               if ( string_eq (token, "input_arrival" ))       /* if#2 */
                  {
                  previous_index := index + 1;
                  for (++index; index < line_length; ++index)
                     {
                     if (string_ref (line, index) == ' ')
                        {
                        val1 := substring (line, previous_index, index);
                        previous_index := index + 1;
                        for (++index; index < line_length; ++index)
                           {
                           if (string_ref (line, index) == ' ')
                              {
                              val2 := substring (line, previous_index, index);
                              previous_index := index + 1;
                              name :=substring(line,previous_index,line_length);

                              if ( set_cons_all( name, token, val1, val2 ) < 0 )
                                 {
                                 pos = findpin( name, "I" );
                                 if ( pos >= 0 )
                                    {
                                      vector_set(in_arrive_rise, pos, val1 ); 
                                      vector_set(in_arrive_fall, pos, val2 ); 
                                    }
                                 }
                              }     /* if line[ index ] == ' ' */
                           }     /* for index loop */
                        }     /* if line[ index ] == ' ' */
                     }     /* for index loop */
                  }     /* end if#2 */

               if ( string_eq (token, "input_drive" ))       /* if#2 */
                  {
                  previous_index := index + 1;
                  for (++index; index < line_length; ++index)
                     {
                     if (string_ref (line, index) == ' ')
                        {
                        val1 := substring (line, previous_index, index);
                        previous_index := index + 1;
                        for (++index; index < line_length; ++index)
                           {
                           if (string_ref (line, index) == ' ')
                              {
                              val2 := substring (line, previous_index, index);
                              previous_index := index + 1;
                              name :=substring(line,previous_index,line_length);

                              if ( set_cons_all(  name, token, val1, val2) < 0)
                                 {
                                 pos = findpin( name, "I" );
                                 if ( pos >= 0 )
                                    {
                                    vector_set(in_drive_rise, pos, val1 );
                                    vector_set(in_drive_fall, pos, val2 );
                                    }
                                 }
                              }     /* if line[ index ] == ' ' */
                           }     /* for index loop */
                        }     /* if line[ index ] == ' ' */
                     }     /* for index loop */
                  }

               if ( string_eq (token, "max_input_load" ))       /* if#2 */
                  {
                  previous_index := index + 1;
                  for (++index; index < line_length; ++index)
                     {
                     if (string_ref (line, index) == ' ')
                        {
                        val1 := substring (line, previous_index, index);
                        previous_index := index + 1;
                        name := substring (line, previous_index, line_length);
                        if ( set_cons_all( name, token, val1, val2 ) < 0 )
                           {
                           pos = findpin( name, "I" ); 
                           if( pos >= 0 )  vector_set(in_load, pos, val1 );
                           }
                        }
                     }
                  }     /* end if#2 */

               if ( string_eq (token, "output_required" ))       /* if#2 */
                  {
                  previous_index := index + 1;
                  for (++index; index < line_length; ++index)
                     {
                     if (string_ref (line, index) == ' ')
                        {
                        val1 := substring (line, previous_index, index);
                        previous_index := index + 1;
                        for (++index; index < line_length; ++index)
                           {
                           if (string_ref (line, index) == ' ')
                              {
                              val2 := substring (line, previous_index, index);
                              previous_index := index + 1;
                              name :=substring(line,previous_index,line_length);

                              if (set_cons_all( name, token, val1, val2 ) < 0 )
                                 {
                                 pos = findpin( name, "O" ); 
                                 if ( pos >= 0 )
                                    {
                                    vector_set(out_require_rise, pos, val1 );
                                    vector_set(out_require_fall, pos, val2 );
                                    }
                                 }
                              }
                           }
                        }     /* if line[ index ] == ' ' */
                     }     /* for index loop */
                  }     /* end token = "output_required" */

               if ( string_eq (token, "output_load" ))       /* if#2 */
                  {
                  previous_index := index + 1;
                  for (++index; index < line_length; ++index)
                     {
                     if (string_ref (line, index) == ' ')
                        {
                        val1 := substring (line, previous_index, index);
                        previous_index := index + 1;
                        name := substring (line, previous_index, line_length);

                        if (set_cons_all(  name, token, val1, val2 ) < 0 )
                           {
                           pos = findpin( name, "O" );
                           if( pos >= 0 )  vector_set(out_load, pos, val1 );
                           }
                        }
                     }     /* for index loop */
                  }     /* end token = "output_load" */

               }    /* end of if#1 */
            }    /* end of line */
         }    /* end while line in not nil */

      fclose( fp );
      if (amgdebug==1)printf("Exiting 'load_cons'...\n");
      }                                      /* end nested function LOAD_CONS */
     
    


   /* ===================== entry point main function CALL_SET_MAPCONSTRAINT */

   if (amgdebug == 1) printf("Running function 'call_set_mapconstraint'...\n");

   entity := get_current_entity( d ); 
   make_pi( entity );
   readpins( d, e );
   optfor     = current_optfor;
   maxdelay   = current_maxdelay;
   area_speed = current_area_speed;

   load_cons_file = "";


   /*  set 'cons_file' to be 'synth/<entity>/<entity>.prt, if it exists, */
   /*  otherwise use 'synth/<entity>/<entity>.pdf (also, if it exists)   */

   prtfile = string_append( work_dir, "/synth/", entity, "/", entity, ".prt" );
   tmpfile = string_append( work_dir, "/synth/", entity, "/", entity, ".tmp" );
   pdffile = string_append( work_dir, "/synth/", entity, "/", entity, ".pdf" );
   mcmfile = string_append( work_dir, "/synth/", entity, "/", entity, ".mcm" );

   if (fexists( mcmfile )) 
      cons_file = string_copy( mcmfile );
   else
      {
      if (fexists( pdffile )) 
         cons_file = string_copy( pdffile );
      else
         vlEx.Throw2( vlEx.FAILURE, "ViewSyn", vlErrSev.Error,
             sprintf("Default port file does not exist:\n\n%s", pdffile) );
      }

   save_cons_file = string_copy( prtfile );

   /* save current constraints in file so that text in shell is not lost */

   load_cons( cons_file );
   vcCmd.Enable( editinput_cmd,     vlOnOff.On);
   vcCmd.Enable( editoutput_cmd,    vlOnOff.On);
   vcCmd.Enable( optconstraint_cmd, vlOnOff.On);
   vcWin.UpdateMenus (vdes2_win);

   if(amgdebug==1)printf("Exiting 'call_set_mapconstraints'...\n" );

   }                                          /* end of CALL_SET_CONSTRAINT */
    


/*---------------------------------------------------------------------------*/
/*                                                                           */
/*   CALL_EDIT_INPUT_CONSTRAINTS function is the object of the EDITINPUT_CMD */
/*                                                                           */
/*                                                                           */
/*                                                                           */

function call_edit_input_constraints(d,e)
   {
   if (amgdebug==1) printf("Inside 'call_edit_input_constraints...\n" ); 

   call_set_mapconstraint(d,e);
    
   if (amgdebug==1) printf("Creating input constraint table...\n" ); 

   in_name_reg       := make_vector( in_no );
   in_cmdline_reg    := make_vector( in_no );
   in_bar_reg         = make_vector( in_no );
   in_load_reg        = make_vector( in_no );
   in_drive_rise_reg := make_vector( in_no );
   in_drive_fall_reg := make_vector( in_no );
   label_drive_reg   := make_vector( in_no );
   label_load_reg    := make_vector( in_no );
   label_arrive_reg  := make_vector( in_no );
   /* set up initial value of arrival time */

   in_table := vcTable.Create("input constraint", in_no+1, 5 );
       
   vcTable.Add( in_table, vcRegion.Create("ic1",vcLabel.fac, "Port"         ));
   vcTable.Add( in_table, vcRegion.Create("ic2",vcLabel.fac, "Arrival Time" ));
   vcTable.Add( in_table, vcRegion.Create("ic3",vcLabel.fac, "Load"         ));
   vcTable.Add( in_table, vcRegion.Create("ic4",vcLabel.fac, "Drive (Rise)" ));
   vcTable.Add( in_table, vcRegion.Create("ic5",vcLabel.fac, "Drive (Fall)" ));
                         
   foreach( i; from_to (0, in_no))
      {
      /* set up initial value of arrival time */

      if ( string_eq(input_cons_type, "fall")) 
          vector_set(arrive_time ,i, vector_ref(in_arrive_fall, i));
      else
          vector_set(arrive_time ,i, vector_ref(in_arrive_rise, i));
              
      vector_set(label_arrive_reg, i, vcRegion.Create ("", 
                     vcLabel.fac, "    arrival time: "));

      vector_set(label_drive_reg, i, vcRegion.Create ("", 
                     vcLabel.fac, "   drive: "));

      vector_set(in_name_reg, i , vcRegion.Create ("", vcLabel.fac, 
                     vector_ref( in, i))); 

      vector_set(label_arrive_reg, i, vcRegion.Create1 ("arrival time:", vcLabel.fac, "  arrival time:", nil));

      vector_set(in_bar_reg, i, logarithmic_scalebar( "bar",
                  vector_ref(arrive_time,i), 0, 1000, func(str) { 
                  vector_set(arrive_time,i,str);in_bar_changed(i);})); 

      vector_set(in_load_reg, i, stringregion (list (
                list (func (s) { vector_set( in_load, i, s); }, 
                "", vector_ref(in_load,i)))));

      vector_set(in_drive_rise_reg, i, stringregion (list (
                list (func (s) { vector_set( in_drive_rise, i, s); }, 
                "", vector_ref(in_drive_rise,i)))));

      vector_set(in_drive_fall_reg, i, stringregion (list (
                list (func (s) { vector_set( in_drive_fall, i, s); }, 
                "", vector_ref(in_drive_fall,i)))));

      vcTable.Add( in_table, vector_ref(in_name_reg, i));
      vcTable.Add( in_table, vector_ref(in_bar_reg, i));
      vcTable.Add( in_table, vector_ref(in_load_reg, i));
      vcTable.Add( in_table, vector_ref( in_drive_rise_reg, i) );
      vcTable.Add( in_table, vector_ref( in_drive_fall_reg, i) );
      }
         
   scrolled_region1 := vcTable.Scroll ("in", in_table, in_table, 
                             1, 8, 10 );

   t_top := vcTable.Create ("constraints", 6, 1);

   vcTable.Add (t_top, flatregion ("Input Constraints:",
                      func (s) { print("Inside 'func'!!");
                                 print(s); 
                                 input_cons_type = s; 
                                 update_arrive_table( input_cons_type);
                               }, 
                      input_cons_type, list (
                          list ("rise/fall", "rsfa"),
                          list ("rise", "rise"),
                          list ("fall", "fall"))));

   vcTable.Add (t_top, scrolled_region1 );

   /* create acceept, apply, cancel button */
   entity := get_current_entity( d ); 
   butlist := putwindow (cbi_action, cbi_cancel, t_top,
                         "Set Input Constraints", d);
   }                             /* end function CALL_EDIT_INPUT_CONSTRAINTS */



/*---------------------------------------------------------------------------*/
/*                                                                           */
/*   CALL_EDIT_OUTPUT_CONSTRAINTS function is the object of EDITOUTPUT_CMD   */
/*   ...................................................  It is called only  */
/*   with the data and event objects supplied by core (i.e. no Parameters).  */
/*                                                                           */
/*                                                                           */
/*                                                                           */

function call_edit_output_constraints(d,e)
   {
   call_set_mapconstraint(d,e);

   /* create output constraint table */
   if (amgdebug==1) printf("Creating output constraint table...\n" ); 
   if (amgdebug==1) printf("out_no = %d...\n", out_no ); 

   out_name_reg         := make_vector( out_no );
   out_cmdline_reg      := make_vector( out_no );
   out_bar_reg           = make_vector( out_no );
   out_load_reg          = make_vector( out_no );
   out_require_reg      := make_vector( out_no );
   labelout_load_reg    := make_vector( out_no );
   labelout_require_reg := make_vector( out_no );

   out_table := vcTable.Create("output constraint", out_no+2, 3 );

   vcTable.Add( out_table, vcRegion.Create("c1",vcLabel.fac, "Port"         ));
   vcTable.Add( out_table, vcRegion.Create("c2",vcLabel.fac, "Required Time"));
   vcTable.Add( out_table, vcRegion.Create("c3",vcLabel.fac, "Load"         ));

   foreach( i; from_to(0, out_no) )
      {
      if ( string_eq(output_cons_type, "fall")) 
         vector_set(require_time , i, vector_ref(out_require_fall, i));
      else
         vector_set(require_time , i, vector_ref(out_require_rise, i));
 

      vector_set(labelout_require_reg, i, vcRegion.Create ("", vcLabel.fac,
                                                         "    require time: "));
      vector_set(out_name_reg,         i, vcRegion.Create ("", vcLabel.fac,
                                                         vector_ref( out, i)) );


      vector_set(out_bar_reg, i,
                 logarithmic_scalebar("bar",vector_ref(require_time,i), 0,1000,
                                      func(str)
                                         {
                                         vector_set(require_time,i,str);
                                         out_bar_changed(i);
                                         }
                                     )   );
      vector_set(out_load_reg, i,
                 stringregion (list(list (func(s) {vector_set(out_load,i,s);},
                                          "",
                                          vector_ref(out_load,i))
                              )     )    );

      vcTable.Add( out_table, vector_ref( out_name_reg, i) );
      vcTable.Add( out_table, vector_ref( out_bar_reg,  i) );
      vcTable.Add( out_table, vector_ref( out_load_reg, i) );
      }

   scrolled_region2 := vcTable.Scroll ("out", out_table, out_table, 1,8,10 );

   t_top2 := vcTable.Create ("constraints", 6, 1);
   vcTable.Add (t_top2, flatregion ("Output Constraints:",
                     func (s)
                        {
                        output_cons_type = s; 
                        update_require_table( output_cons_type);
                        }, 
                     output_cons_type, 
                     list ( list ("rise/fall", "rsfa"),
                            list ("rise", "rise"),
                            list ("fall", "fall"))             ) );

   vcTable.Add (t_top2, scrolled_region2 );

   /* create acceept, apply, cancel button */

   butlist :=putwindow(cbo_action,cbo_cancel,t_top2,"Set Output Constraints",d);
   }                            /* end function CALL_EDIT_OUTPUT_CONSTRAINTS */


editinput_cmd := vcWv.Cmd(fac, call_edit_input_constraints, 
                              "Edit Input Constraints", 
                              "Edit Input Pin Timing Constraints" ); 
vcCmd.SetHelp (editinput_cmd, "Edit input pin timing constraints" );

editoutput_cmd :=vcWv.Cmd(fac, call_edit_output_constraints, 
                              "Edit Output Constraints", 
                              "Edit Output Pin Timing Constraints" ); 
vcCmd.SetHelp (editoutput_cmd,"Edit output pin timing constraints" );



/*---------------------------------------------------------------------------*/
/*                                                                           */
/*   SET_OPERATING_POINTS  function is the object of the SET_POINTS_CMD.     */
/*                                                                           */
/*                                                                           */
/*                                                                           */

function set_operating_points(d, e, voltage, temperature, pkg, process) 
   {
   declare tmp, tmpstr, fp;

   new_package = convert( string, pkg );
   new_process_type = convert( string, process );
   new_voltage = convert( float, voltage);
   new_temperature = convert( float, temperature);

   if (!null(new_package) && (string_eq( new_package, "") != TRUE))
      {
      write_ini( "package", new_package );
      current_package = new_package;
      }

   write_ini( "temperature", convert( string,new_temperature));
   current_temperature = new_temperature;
         
   write_ini( "voltage", convert( string, new_voltage));
   current_voltage = new_voltage;
     
   if( string_eq(new_process_type, "typical" ))
         write_ini( "process","1" );
   if( string_eq(new_process_type, "slow" ))
         write_ini( "process","0" );
   if( string_eq(new_process_type, "fast" ))
         write_ini( "process","2" );
     
   current_process_type = new_process_type;
   }                                    /* end function SET_OPERATING_POINTS */


function get_current_module( data ) 
     return( current_module );

function get_current_tech( data )
     return( current_tech );

function get_current_tech2( data ) {
function make_tech_list() {
  
    declare filename, techs;
    declare cmd, ignore, path, alias;

    function append_to_list( string file ) {
        declare n_rows, n_cols, r, c, border, region;
        
        file = caddr (vscript.vsParse (file));       
        if( !vsyntest.IsInPicklist( techs, file ))
            vcPicklist.Add(techs, file, file );
    }
 

    function search_primary_dir() {
    
    declare filename;

    if( primary_path != nil ) {
        filename = vscript.vsAbsPath (primary_path) + "/*.sml";
        vscript.vsLoop(filename, vscript.vsFILE, append_to_list); }
    } /* end of search_primary_dir */
           
    function search_vdraw_dir() {

        declare path_l, alias_l, path, alias, filename;

        path_l = vdraw_path;
        alias_l = vdraw_alias;
        for(; !null( path_l ); path_l = cdr( path_l )) {
            path =  car( path_l );
            alias = car( alias_l );
            alias_l = cdr( alias_l );
            filename = vscript.vsAbsPath (path) + "/*.sml";
            foreach (file;  vscript.TraverseDir( filename,
                     vscript.vsFILE)) {
                file := caddr (vscript.vsParse (file));
                if( alias != nil ) file := alias  + ":" + file;
                append_to_list( file );
            }
        }
    } /* end of search_vdraw_dir */
 
  
    function search_wdir() {
    /* get a list of sml files from WDIR */

    foreach (path; vscript.env_path("WDIR"))
        {
            filename = vscript.vsAbsPath (path) + "/*.sml";
            vscript.vsLoop(filename, vscript.vsFILE, append_to_list);
        }
    } /* end of search_wdir */

 
    /* create pick_list region */
   
    techs = vcRegion.Create1("Exclusive Scroll", vcPicklist.fac, nil,
                             list(columns <- 1));
    search_primary_dir();
    search_vdraw_dir();
    search_wdir();
    tech_picklist := vcPicklist.Scroll("tech", techs, 5, 2, 10);
    vcPicklist.Notify ( techs, func( tech, on ) if (on) { 
                        vcCmdline.Set( tech_string, tech );}); 
    return( tech_picklist );

}
    function callmaketech()
        tech_list_table = make_tech_list();

    vcWin.WithBusy( vdes2_win, callmaketech );
    return( current_tech );
}
 
function get_current_voltage( data )  {
    filename := string_append( work_dir, "/synth.ini" );
    if (fexists( filename )) {
        fp := fopen( filename, "r" );
        if ( !null( fp ) ) {
            while ( !null( linein := fgetline( fp ))) {
                linein = string_token( linein, &token, " " );
                if (string_eq( token, "voltage")) {
                    linein = string_token( linein, &token, " " );
                    token = substring(token, 0, string_length(token)-1);
                    token = convert( float, token );
                    fclose( fp );
                    return( token );
                }
            }
            fclose( fp );
        }
    }
    return( current_voltage );
}
 
function get_current_temperature( data ) {
    filename := string_append( work_dir, "/synth.ini" );
    if (fexists( filename )) {
        fp := fopen( filename, "r" );
        if ( !null( fp ) ) {
            while ( !null( linein := fgetline( fp ))) {
                linein = string_token( linein, &token, " " );
                if (string_eq( token, "temperature")) {
                    linein = string_token( linein, &token, " " );
                    token = substring(token, 0, string_length(token)-1);
                    token = convert( float, token );
                    fclose( fp );
                    return( token );
                }
            }
            fclose( fp );
        }
    }
    return( current_temperature);
}
 
function get_current_package( data ) {
    filename := string_append( work_dir, "/synth.ini" );
    if (fexists( filename )) {
        fp := fopen( filename, "r" );
        if ( !null( fp ) ) {
            while ( !null( linein := fgetline( fp ))) {
                linein = string_token( linein, &token, " " );
                if (string_eq( token, "package")) {
                    linein = string_token( linein, &token, " " );
                    token = substring(token, 0, string_length(token)-1);
                    fclose( fp );
                    return( token );
                }
            }
            fclose( fp );
        }
    }
    return( current_package);
}
 
function get_current_process_type( data ) {
    filename := string_append( work_dir, "/synth.ini" );
    if (fexists( filename )) {
        fp := fopen( filename, "r" );
        if ( !null( fp ) ) {
            while ( !null( linein := fgetline( fp ))) {
                linein = string_token( linein, &token, " " );
                if (string_eq( token, "process")) {
                    linein = string_token( linein, &token, " " );
                    fclose( fp );
                    token = substring(token, 0, string_length(token)-1);
                    if (string_eq( token, "0") == TRUE)
                        return( Process.slow );
                    else if (string_eq( token, "1") == TRUE)
                        return( Process.typical );
                    else if (string_eq( token, "2") == TRUE)
                        return( Process.fast );
                    else
                        vlEx.Throw2 (vlEx.FAILURE, "ViewSyn",
                          vlErrSev.Error,
                          sprintf ("Unknown process type in synth.ini: '%s'.", token));
                }
            }
            fclose( fp );
        }
    }
    return( Process.typical );
}

function get_current_opt( data )  {
    filename := string_append( work_dir, "/synth.ini" );
    if (fexists( filename )) {
        fp := fopen( filename, "r" );
        if ( !null( fp ) ) {
            while ( !null( linein := fgetline( fp ))) {
                linein = string_token( linein, &token, " " );
                if (string_eq( token, "opt")) {
                    linein = string_token( linein, &token, " " );
                    token = substring(token, 0, string_length(token)-1);
                    if (string_eq( token, "off") == TRUE)
                        return( opt.off );
                    else if (string_eq( token, "area") == TRUE)
                        return( opt.area);
                    else if (string_eq( token, "speed") == TRUE)
                        return( opt.speed );
                }
            }
            fclose( fp );
        }
    }
    return( opt.area ); 
}
 
function get_current_cpu( data )  {
    filename := string_append( work_dir, "/synth.ini" );
    if (fexists( filename )) {
        fp := fopen( filename, "r" );
        if ( !null( fp ) ) {
            while ( !null( linein := fgetline( fp ))) {
                linein = string_token( linein, &token, " " );
                if (string_eq( token, "cpu_effort")) {
                    linein = string_token( linein, &token, " " );
                    token = substring(token, 0, string_length(token)-1);
                    if (string_eq( token, "low") == TRUE)
                        return( cpu.low);
                    else if (string_eq( token, "medium") == TRUE)
                        return( cpu.medium);
                    else if (string_eq( token, "high") == TRUE)
                        return( cpu.high);
                }
            }
            fclose( fp );
        }
    }
    return( cpu.low); 
}
function get_current_collapse( data )  {
    filename := string_append( work_dir, "/synth.ini" );
    if (fexists( filename )) {
        fp := fopen( filename, "r" );
        if ( !null( fp ) ) {
            while ( !null( linein := fgetline( fp ))) {
                linein = string_token( linein, &token, " " );
                if (string_eq( token, "flatten")) {
                    linein = string_token( linein, &token, " " );
                    token = substring(token, 0, string_length(token)-1);
                    if (string_eq( token, "off") == TRUE)
                        return( flat.off);
                    else if (string_eq( token, "low") == TRUE)
                        return( flat.low);
                    else if (string_eq( token, "medium") == TRUE)
                        return( flat.medium);
                    else if (string_eq( token, "high") == TRUE)
                        return( flat.high);
                }
            }
            fclose( fp );
        }
    }
    return( flat.off); 
}

function get_current_redun( data )  {
    filename := string_append( work_dir, "/synth.ini" );
    if (fexists( filename )) {
        fp := fopen( filename, "r" );
        if ( !null( fp ) ) {
            while ( !null( linein := fgetline( fp ))) {
                linein = string_token( linein, &token, " " );
                if (string_eq( token, "redundancy_removal")) {
                    linein = string_token( linein, &token, " " );
                    token = substring(token, 0, string_length(token)-1);
                    if (string_eq( token, "off") == TRUE)
                        return( redun.off);
                    else if (string_eq( token, "on") == TRUE)
                        return( redun.on);
                }
            }
            fclose( fp );
        }
    }
    return( redun.off); 
}

function get_current_maxdelay( data ) {
    filename := string_append( work_dir, "/synth.ini" );
    if (fexists( filename )) {
        fp := fopen( filename, "r" );
        if ( !null( fp ) ) {
            while ( !null( linein := fgetline( fp ))) {
                linein = string_token( linein, &token, " " );
                if (string_eq( token, "max_delay")) {
                    linein = string_token( linein, &token, " " );
                    token = substring(token, 0, string_length(token)-1);
                    token = convert( float, token );
                    fclose( fp );
                    return( token );
                }
            }
            fclose( fp );
        }
    }
    return( 0 );
}
alias_cmd := cmd ("alias", "alias",  "alias",
        list(vcWv.Param("alias [ a [b] ]", string, vcWv.Sticky, "")));
vcCmd.EnableApply(alias_cmd, vlOnOff.On);

temperature_cmd := cmd ("temp", "temp", "temperature",
    list(vcWv.Param("temperature",string,  vcWv.Sticky, "25.0")));
    vcCmd.EnableApply(temperature_cmd, vlOnOff.On);
voltage_cmd := cmd ("volt", "volt", "voltage",
    list(vcWv.Param("voltage",string,  vcWv.Sticky, "5.0")));
    vcCmd.EnableApply(voltage_cmd, vlOnOff.On);

run_system_cmd := cmd ("%", "%", "%",
    list(vcWv.Param("Run program < program args >",string,  vcWv.Sticky, "")));
    vcCmd.EnableApply(run_system_cmd, vlOnOff.On);

set_alias_cmd := cmd ("set_alias", "alias", "alias",
    list(vcWv.Param("alias [ name ]",string,  vcWv.Sticky, ""),
         vcWv.Param("is defined as ",string,  vcWv.Sticky, "")));
    vcCmd.EnableApply(set_alias_cmd, vlOnOff.On);

remove_alias_cmd := cmd ("unalias", "unalias", "unalias",
    list(vcWv.Param("remove alias [ name1 name2 ... ]",string,vcWv.Sticky,"")));
    vcCmd.EnableApply(remove_alias_cmd, vlOnOff.On);

show_aliases_cmd := cmd("show_alias_cmd", "alias", nil, nil);

start_macro_cmd := cmd ("macro", "macro", "macro",
    list(vcWv.Param("recording macro filename", string,  vcWv.Sticky, "")));
    vcCmd.EnableApply(start_macro_cmd, vlOnOff.On);

close_macro_cmd := cmd ("close_macro", "mclose", nil, nil );

run_macro_cmd := cmd ("do_macro", "mex", "mex",
    list(vcWv.Param("execute macro filename", string,  vcWv.Sticky, "")));
    vcCmd.EnableApply(run_macro_cmd, vlOnOff.On);

clear_lib_cmd := cmd ("clear_lib", "clear_work_library", nil, nil);

list_lib_cmd := cmd ("list_lib", "list_work_library", nil, nil);

show_setup_cmd := cmd("show_setup_cmd", "setup", nil, nil);

show_history_cmd := cmd("show_history_cmd", "history", nil, nil);

version_cmd := cmd("version", "version", nil, nil);



/*
  * Define enumerated types needed to set operating points
  */
 vcWv.MakeEnum ("OptimizeVT", list ("area", "speed", "area/speed" ));
 vcWv.MakeEnum ("LogicVT",    list ("default", "fsm", "large"));
 vcWv.MakeEnum ("ProcessVT", list ("slow", "typical", "fast"));

 set_points_cmd := vcWv.Cmd (fac, set_operating_points, "Set Operating Points",
                             "Set Operating Points",
     vcWv.Param ("Voltage", float, vcWv.Dynamic, get_current_voltage),
     vcWv.Param ("Temperature (C)", float, vcWv.Dynamic, get_current_temperature),
     vcWv.Param ("Package", string, vcWv.Dynamic,get_current_package),
     vcWv.Param ("Process Type", ProcessVT, vcWv.Dynamic, get_current_process_type));

vcCmd.SetHelp (set_points_cmd, "Set global operating points");




function call_set_tech( d, e, tech )
   {
   if (tech == "" )
      vlEx.Throw2 (vlEx.FAILURE, "ViewSyn", vlErrSev.Status,
                   "Please specify a target technology."); 

   pre_tech();
   /*check_packfile( func() { post_tech( d, e, tech ); });*/
   post_tech(d,e,tech);
   write_ini( "technology", tech );
   vcCmd.EnableApply (set_points_cmd, TRUE);
   }                                            /* end fucntion CALL_SET_TECH */

     
set_tech_cmd := vcWv.Cmd (fac, call_set_tech,"Set Target Technology","Specify Target Technology",
   vcWv.Param ("Technology", string, vcWv.Dynamic, get_current_tech2, vsyn_3.fac));
vcCmd.SetHelp (set_tech_cmd, "Set target technology for synthesis");
vcCmd.EnableApply(set_tech_cmd, vlOnOff.On); 


   /*---------------------------------
   vcWv.Param ("Optimize", optVT, vcWv.Sticky, opt.area),
   vcWv.Param ("CPU Effort", cpuVT,   vcWv.Sticky, cpu.low),
   vcWv.Param ("Flatten Effort", flatVT,  vcWv.Sticky, flat.low),
   vcWv.Param ("Redundancy Removal", redunVT, vcWv.Sticky, redun.off),
   vcWv.Param ("Maximum Delay", float, vcWv.Sticky, 0),
   vcWv.Param ("(Xilinx) Automatic IO Pad Insertion", vlYesNoVT, vcWv.Sticky,
               vlYesNo.Yes ),
   vcWv.Param ("(Xilinx) Write Timing Data In WIR File", vlYesNoVT, vcWv.Sticky,
               vlYesNo.Yes ));
   vcWv.Param ("(Xilinx) Pack Into CLBs", vlYesNoVT, vcWv.Sticky,vlYesNo.Yes ));
   -------------------------------*/



function call_set_map_defaults(d,e, optfor,cpue,flate, redux,maxdelay,runio,clb)
   {
   declare fp, tmp, tmpstr, optstr, cpustr, flatstr, redunstr;

   current_optfor = optfor;
   current_cpu    = cpue;
   current_redux  = redux;
   current_flat   = flate;
   current_maxdelay = convert(float, maxdelay);
   printf("current_maxdelay = '%f'\n", current_maxdelay);
   printf("maxdelay = '%s'\n", maxdelay);
   
   if (optfor == opt.off)        optstr = "off";
   else if (optfor == opt.area)  optstr = "area";
   else if (optfor == opt.speed) optstr = "speed";
   write_ini( "opt", optstr ); 
             
   if (cpue == cpu.low)         cpustr = "low";
   else if (cpue == cpu.medium) cpustr = "medium";
   else if (cpue == cpu.high)   cpustr = "high";
   write_ini( "cpu_effort", cpustr ); 
            
   if (flate == flat.off)         flatstr = "off";
   else if (flate == flat.low)    flatstr = "low";
   else if (flate == flat.medium) flatstr = "medium";
   else if (flate == flat.high)   flatstr = "high";
   write_ini( "flatten", flatstr ); 
             
   if (redux == redun.off)      redunstr = "off";
   else if (redux == redun.on)  redunstr = "on";
   write_ini( "redundancy_removal", redunstr); 

   maxdelay = convert(float,maxdelay);
   write_ini( "max_delay", convert(string, maxdelay ));
   printf("maxdelay = '%s'\n", convert(string, maxdelay ));

   /* these are for Xilinx processing - not in synth.ini, just globals */
   if (runio == vlYesNo.Yes)
      run_iopad = TRUE;
   else
      run_iopad = FALSE;

   /*if (gtime == vlYesNo.Yes)
      run_xcons = TRUE;
   else
      run_xcons = FALSE;*/
   
   if (clb == vlYesNo.Yes)
      run_xtech = TRUE;
   else
      run_xtech = FALSE;

   }                   /* end function CALL_SET_MAP_DEFAULTS */

set_map_defaults_cmd := vcWv.Cmd( fac, call_set_map_defaults,"Set Defaults", "Set Defaults",

     vcWv.Param ("Optimize", optVT, vcWv.Dynamic, get_current_opt),
     vcWv.Param ("CPU Effort", cpuVT,   vcWv.Dynamic, get_current_cpu),
     vcWv.Param ("Collapse Effort", flatVT,  vcWv.Dynamic, get_current_collapse),
     vcWv.Param ("Redundancy Removal", redunVT, vcWv.Dynamic, get_current_redun),
     vcWv.Param ("Maximum Delay", float, vcWv.Dynamic, get_current_maxdelay),
     vcWv.Param ("(Xilinx) Automatic IO Pad Insertion", vlYesNoVT, vcWv.Sticky,vlYesNo.Yes ),
     /*vcWv.Param ("(Xilinx) Write Timing Data In WIR File", vlYesNoVT, vcWv.Sticky,vlYesNo.Yes ),*/
   vcWv.Param ("(Xilinx) Pack Into CLBs", vlYesNoVT, vcWv.Sticky,vlYesNo.Yes ));

vcCmd.SetHelp (set_map_defaults_cmd, "Set synthesis defaults");
function get_current_outdir( data ) 
     return( current_outdir );


/* ------------------------------------------- Dead Code----------------------
function call_outdir( d, e , in ) {

    if( current_outdir == "" ) {
        error("ERROR: Must specify alias before applied",current_outdir);
    }
    current_outdir = in;
    vcSys.TypeIn( sys,"out_dir "+current_outdir+"\n");
} -----------------------------------------End Dead Code---------------------*/

  
function get_current_wire( data )
   return( current_outnet );

function call_wire( d, e, in1, in2 ) {

   current_outnet = in2;
   vcSys.TypeIn( sys,"wire "+ in1 + current_outnet+"\n");
} 

wire_cmd := vcWv.Cmd (fac, call_wire, "wire_cmd", "specify output wire file",
   vcWv.Param ("Wire alias name", string, vcWv.Dynamic, get_current_outdir),
   vcWv.Param ("Wire file name", string, vcWv.Dynamic, get_current_wire));
vcCmd.EnableApply( wire_cmd, vlOnOff.On);

function get_current_report( data )
   return( current_report );

function call_report( d, e, in1, in2 ) {

   current_report = in2;
   vcSys.TypeIn( sys,"report "+ in1+ current_report+"\n");
}


show_report_cmd := vcWv.Cmd (fac, call_show_report, "View Report" );

vcCmd.SetHelp (show_report_cmd, "View synthesis report");


editvhdl_cmd := vcWv.Cmd (fac, call_editvhdl, "Edit VHDL" );

vcCmd.SetHelp (editvhdl_cmd, "Edit VHDL source for this entity");


compilevhdl_cmd := vcWv.Cmd (fac, call_compilevhdl, "Re-Compile VHDL",
                                                    "Re-compile VHDL Source",
   vcWv.Param( "VHDL File", string, vcWv.Dynamic,getsrcfile, vcStaticText.fac),
   vcWv.Param( "Run AluConstructor", aluEnumVT, vcWv.Sticky, aluEnum.No,
               vcPickEnum.fac),
   vcWv.Param( "Speed", integer, vcWv.Sticky, aluSpeed, vcScalebar.fac,
               increment <-1, max <-100, min<-1));

vcCmd.SetHelp (compilevhdl_cmd, "Re-compile VHDL source for this entity");


function call_clone_cmd( d, e ) {
   entity := get_current_entity( d ); 
   vcWin.Busy( vdes2_win, TRUE );
   block_commands( "Instance Clone" );
   blocking_popup = 1;
   hac_uniq( d, e, entity );
}
clone_cmd := vcWv.Cmd (fac, call_clone_cmd,"Clone" );
vcCmd.SetHelp (clone_cmd, "Clone this entity");

mapconstraint_cmd := vcWv.Cmd (fac, call_set_mapconstraint, "mapconstraint_cmd");
vcCmd.SetHelp (mapconstraint_cmd, "Set mapping constraints");




/*---------------------------------------------------------------------------*/
/*                                                                           */
/*   getOpt  function sets the initial value of the "Optimize For" parameter */
/*   of the OPTCONSTRAINT_CMD.  It takes a single argument (unused), and     */
/*   returns a value of type optVT ("off", "area", "speed" ).                */
/*                                                                           */
/*   This function will read the synth/<entity>/<entity>.ctl file, and set   */
/*   global variables <optVal>, <cpuVal> <flatVal,> <redunVal> to be used as */
/*   defaults in the dialog box.                                             */

function getOpt( d )
   {
   declare ctlfile, fp, linein, token; 

   function getval( line, token )
      {
      line = string_token( line, &token, " ");
      substring(token, 0, string_length(token)-1);
      }
   
   entity := get_current_entity( d ); 
   ctlfile = string_append( work_dir, "/synth/", entity, "/", entity, ".ctl" );

   optVal  = current_optfor;
   cpuVal  = current_cpu;
   redunVal = current_redux;
   flatVal = current_flat;

   if (fexists( ctlfile ))
      { 
      fp = fopen( ctlfile, "r" );
      if ( null(fp) )
         vlEx.Throw2( vlEx.FAILURE, "ViewSyn", vlErrSev.Error,
             sprintf( "Cannot open file '<entity>.ctl'.", fp) );
       
      token  = " ";
      linein = fgetline(fp);
      while (!null(linein))
         {
         linein = string_token( linein, &token, " ");
         if (string_eq( token, "opt" ))
            {
            tmp := getval( linein, token );
            if (string_eq( tmp, "off" ))        optVal = opt.off;
            else if (string_eq( tmp, "area" ))  optVal = opt.area;
            else if (string_eq( tmp, "speed"))  optVal = opt.speed;
            }
         else if (string_eq( token, "cpu_effort" ))
            {
            tmp := getval( linein, token );
            if (string_eq( tmp, "low" ))        cpuVal = cpu.low;
            else if (string_eq( tmp, "medium")) cpuVal = cpu.medium;
            else if (string_eq( tmp, "high"  )) cpuVal = cpu.high;
            }
         else if (string_eq( token, "flatten" ))
            {
            tmp := getval( linein, token );
            if (string_eq( tmp, "off" ))        flatVal = flat.off;
            else if (string_eq( tmp, "low" ))   flatVal = flat.low;
            else if (string_eq( tmp, "medium")) flatVal = flat.medium;
            else if (string_eq( tmp, "high" ))  flatVal = flat.high;
            }
         else if (string_eq( token, "redundancy_removal" ))
            {
            tmp := getval( linein, token );
            if (string_eq( tmp, "off" ))        redunVal = redun.off;
            else if (string_eq( tmp, "on" ))    redunVal = redun.on;
            }
         linein = fgetline( fp );
         }
      fclose(fp);
      }
  optVal;
  }                                                   /* end function getOpt */

function getCpu  ( d ) return( cpuVal   );
function getFlat ( d ) return( flatVal  );
function getRedun( d ) return( redunVal );

optconstraint_cmd := vcWv.Cmd (fac, call_set_optconstraint,
                                   "Set Optimization Constraints",
                                   "Set Optimization Constraints",
     vcWv.Param ("Optimize For",       optVT,   vcWv.Dynamic, getOpt ),
     vcWv.Param ("CPU Effort",         cpuVT,   vcWv.Dynamic, getCpu ),
     vcWv.Param ("Flatten Effort",     flatVT,  vcWv.Dynamic, getFlat ),
     vcWv.Param ("Redundancy Removal", redunVT, vcWv.Dynamic, getRedun ));

vcCmd.SetHelp (optconstraint_cmd, "Set optimization constraints");




/*---------------------------------------------------------------------------*/
/*                                                                           */
/*   DISPREOPT_CMD1  function ...                                            */

function dispreopt_cmd1( d, e )
   {
   entity := get_current_entity( d ); 
   command := string_append( "vsyn -dis_preopt ", entity );
   hac_hierarchy( d, command );
   }

function dispremap_cmd1( d, e )
   {
   entity := get_current_entity( d ); 
   command := string_append( "vsyn -dis_premap ", entity );
   hac_hierarchy( d, command );
   }

function hier_undo_cmd1( d, e ) {
    entity := get_current_entity( d ); 
    hier_status := show_hierctl( get_statusflag( entity ) );
    if (amgdebug == 1) printf( "hier_status = %d\n", hier_status );
    if (hier_status == 8)
        command := string_append( "vsyn -undo -fla_premap ", entity );
    else if (hier_status == 4)
        command := string_append( "vsyn -undo -fla_preopt ", entity );
    else if (hier_status == 2)
        command := string_append( "vsyn -undo -dis_premap ", entity );
    else if (hier_status == 1)
        command := string_append( "vsyn -undo -dis_preopt ", entity );
    hac_hierarchy( d, command );
}

dispreopt_cmd := vcWv.Cmd( fac, dispreopt_cmd1, "Dissolve Pre-Optimization", "Dissolve Pre-Optimization" );
vcCmd.SetHelp (dispreopt_cmd, "Dissolve before optimization");

dispremap_cmd := vcWv.Cmd( fac, dispremap_cmd1, "Dissolve Pre-Mapping", "Dissolve Pre-Mapping" );
vcCmd.SetHelp (dispremap_cmd, "Dissolve before mapping");
disundo_cmd   := vcWv.Cmd( fac, hier_undo_cmd1, "Undo Dissolve", "Undo Dissolve" );
flaundo_cmd   := vcWv.Cmd( fac, hier_undo_cmd1, "Undo Flatten", "Undo Flatten" );
function flapreopt_cmd1( d, e ) {
    entity := get_current_entity( d ); 
    command := string_append( "vsyn -fla_preopt ", entity );
    hac_hierarchy( d, command );
}
function flapremap_cmd1( d, e ) {
    entity := get_current_entity( d ); 
    command := string_append( "vsyn -fla_premap ", entity );
    hac_hierarchy( d, command );
}
flapreopt_cmd := vcWv.Cmd( fac, flapreopt_cmd1, "Flatten Pre-Optimization", "flapreo" );
vcCmd.SetHelp (flapreopt_cmd, "Flatten before optimization");
flapremap_cmd := vcWv.Cmd( fac, flapremap_cmd1, "Flatten Pre-Mapping", "flaprem" );
vcCmd.SetHelp (flapremap_cmd, "Flatten before mapping");


function call_set_output(data,event,sch,rep) {
        win := vcEvent.Window(event);
        vcWin.ClearStatus(win);
}
output_cmd := vcWv.Cmd(fac, call_set_output, nil, 
    "Create Output Files", 
    vcWv.Param ("Create Schematic  ", vlYesNoVT, vcWv.Sticky,vlYesNo.Yes ),
    vcWv.Param ("Create Report File", vlYesNoVT, vcWv.Sticky,vlYesNo.Yes ));




/*---------------------------------------------------------------------------*/
/*                                                                           */
/*   CALL_SHOW_SCHEMATIC  function is the object of the SHOW_SCHEMATIC_CMD.  */
/*   It is called only with the data and event objects supplied by core      */
/*   (i.e. no Parameters).                                                   */
/*                                                                           */
/*                                                                           */
/*                                                                           */

function call_show_schematic(data,event) 
   {
   declare runviewgen,fp,vgenruns;


   vgenruns = 0;

   filename := string_append( work_dir, "/viewgen.cmd" );
   fp = fopen( filename, "w" );
   if ( null( fp ))
      vlEx.Throw2 (vlEx.FAILURE, "ViewSyn", vlErrSev.Error,
                                 "Cannot open viewgen command file.");

   foreach( v; vcTree.VrtxSubtree( current_vertex ))
      {
      entity := vcTree.VrtxGetItem(v);
      runviewgen = FALSE;

      /* see if this entity has been dissolved or is out-of-scope */
      status := getStatus( entity );
      if ( (member( entity, inscope_ent ) != FALSE)
           && ( ((status & 1) == 0) && ((status & 2) == 0) ) )
         {
         wirfile := string_append( work_dir, "/wir/", entity, ".1" );
         schfile := string_append( work_dir, "/sch/", entity, ".1" );

         if (! fexists( wirfile ))
            vlEx.Throw2 (vlEx.FAILURE, "ViewSyn", vlErrSev.Error,
                sprintf("Wire file for entity does not exist.", wirfile) );
             
         if (fexists( schfile ) == FALSE )       
            runviewgen = TRUE;
         else                            /* check timestamp against WIR file */
            {                  
            time_wir := car( vscript.vsInfo( wirfile ) );
            time_sch := car( vscript.vsInfo( schfile ) );
            if ((time_wir ==nil) || (time_sch ==nil) || (time_wir > time_sch))
               runviewgen = TRUE;
            }

         if (runviewgen == TRUE)
            {
            ++vgenruns;
            tmpstr := sprintf( "viewgen %s\n", entity );
            fputline( fp, tmpstr );
            }
         }  /* entity is not dissolved */
      }     /* foreach */

   fclose( fp );


   vcWin.Busy( vdes2_win, TRUE );
   vcWv.CommandSequence(
       list (
          func()
             {
             if (vgenruns >0)  vcTxShell.PrintString(nusyn_sh,
                                           "\n\nCreating Schematics...\n" );
             return(TRUE);
             }, 
          "cd " + work_dir + "; chmod +x ./viewgen.cmd; ./viewgen.cmd",
          func()
             {
             vcTxShell.PrintString(nusyn_sh, "\n\nStarting ViewDraw...\n" );
             return(TRUE);
             }, 
          "cd " + work_dir + "; viewdraw -sch "+ current_entity ),
       nil,
       func(str) { vcTxShell.PrintString(nusyn_sh,str);},
       nil,
       func(mode,code) { vcWin.Busy( vdes2_win, FALSE );},
       nil             );
   vcWin.Busy( vdes2_win, FALSE );
   }                                     /* end function CALL_SHOW_SCHEMATIC */


show_schematic_cmd := vcWv.Cmd( fac, call_show_schematic, "View Schematic" );
vcCmd.SetHelp (show_schematic_cmd, "View schematic for this entity");



function call_setroot(data,event) {
    entity := get_current_entity( data );
    call_select_design( data, event, entity );
}

setroot_cmd := vcWv.Cmd( fac, call_setroot, "Set Graph Root" );
vcCmd.SetHelp (setroot_cmd, "Set root entity for graph");

function call_view_synth_err( d, e ) {
   filename := string_append( work_dir, "/synth.err" );
   if (fexists( filename )) {

     ret := vcWin.TextEdit (vdes2_win,
                            filename,      
                            nil,
                            nil,
                            FALSE,
                            TRUE);

   }
   else
         vlEx.Throw2 (vlEx.FAILURE, "ViewSyn", vlErrSev.Error, sprintf ("synth.err does not exist."));
}

view_synth_err_cmd := vcWv.Cmd( fac, call_view_synth_err, "View Error Listing" );
vcCmd.SetHelp (view_synth_err_cmd, "View error listing file");
   
/* main_menu */


m_misc := vcWv.make_menu ("Command",
  /*list ("Run viewgen", viewgen_cmd),
  list ("Open macro...", start_macro_cmd),
  list ("Close macro", close_macro_cmd),
  list ("Run macro...", run_macro_cmd),
  list ("Show aliases", show_aliases_cmd),
  list ("Set alias...", set_alias_cmd),
  list ("Remove alias...", remove_alias_cmd),
  list ("Run system command", run_system_cmd),*/
  list ("Clear VHDL working library", clear_lib_cmd),
  list ("List VHDL working library", list_lib_cmd),
  list ("Show Setup", show_setup_cmd),
  /*list ("Show history", show_history_cmd),*/
  list ("Show Version", version_cmd));


/* load viewscript files upon the product being invked */

if( string_ref(sec_code, 0) == string_ref(VHDLDES,0))
    load( "vsyn_2.vs");
else
    load( "retarg2.vs");


function _Size(region,size,region,wv)
{
    /* set the size of the window (ideal, minimum, maximum) */
    vcSize.Set(size,700,600,600,400,1000,1000);
}

    
/* set edge thickness, color */
desc := vcTree.EdgeDescriptorCreate (color <- vgColor.LightBlue, thickness <- 1 );
   



/*---------------------------------------------------------------------------*/
/*                                                                           */
/*   GET STATUS  function will, given a vertex name, return a status flag    */
/*   from the global <statList>, which is of the form:                       */
/*                                                                           */
/*        ( (v1, status1) (v2, status2)...)                                  */
/*                                                                           */
/*   getStatus is called by:                                                 */
/*                                                                           */
/*        popup_func                                                         */
/*        call_view_preopt                                                   */
/*        call_view_premap                                                   */
/*        call_show_schematic                                                */

function getStatus( vertex )
   {
   if (! member( vertex, inscope_ent ))   return( 0 );


   tmplist := copy_list( status_list );

   while( (!null( tmplist )) &&
          (string_eq( vertex, car( car( tmplist ))) == FALSE))
      tmplist = cdr( tmplist );

   if ( !null(vertex) && !null( tmplist ) )
      {
      if (string_eq( vertex, car( car( tmplist ))) == TRUE)
         {
         status := cdr( car( tmplist ) );
         return( status );
         }
      }
   else
      vlEx.Throw2 (vlEx.FAILURE, "ViewSyn", vlErrSev.Warning,
          sprintf( "Vertex not found in status_list", vertex) );
   }                                              /* end function GET STATUS */



function not_in_opt( vertex, status )
    if ((status & 1) > 0)
        return( TRUE );
    else
        return( FALSE );

function not_in_map( vertex, status )
    if ((status & 2) > 0)
        return( TRUE );
    else
        return( FALSE );



function get_statusflag( entity ) {
/*
------------------------------------------------------
   Read entries from top.ref for a given entity
   and determine its status flag
------------------------------------------------------
*/
declare linein, token, i_status, po_status, pm_status, found, done, status_flag;

   i_status = -1;
   po_status = -1;
   pm_status = -1;
   done = FALSE;

   filename := string_append( work_dir, "/top.ref" );
   if (fexists( filename )) {

   fp :=fopen( filename, "r");
   if (!null( fp )) {

      while ( !done && !null( linein = fgetline( fp )))  {
          linein = string_token( linein, &token, " " );
          
          if (string_eq( token, "$initial\n" )) {
              found = FALSE;
              while ( !found && !done && !null( linein = fgetline( fp ))) {
                 linein = string_token( linein, &token, " " );
                 if (string_eq( token, "$preopt\n"))
                    done = TRUE;
                 else {
                    ename := substring( token, 0, length(token)-1); 
                    if (string_eq( ename, entity))  {
                       found = TRUE;
                       linein = string_token( linein, &token, " " );
                       i_status = substring( token, 0, length(token)-1);
                    }
                  }
              }
          }

          if (string_eq( token, "$preopt\n" )) {
              found = FALSE; 
              done = FALSE; 
              while ( !found && !done && !null( linein = fgetline( fp ))) {
                 linein = string_token( linein, &token, " " );
                 if (string_eq( token, "$premap\n"))
                    done = TRUE;
                 else {
                    ename := substring( token, 0, length(token)-1); 
                    if (string_eq( ename, entity))  {
                       found = TRUE;
                       linein = string_token( linein, &token, " " );
                       po_status = substring( token, 0, length(token)-1);
                     }
                 }
              }
          }

          if (string_eq( token, "$premap\n" )) {
              found = FALSE; 
              while ( !found && !null( linein = fgetline( fp ))) {
                 linein = string_token( linein, &token, " " );
                 ename := substring( token, 0, length(token)-1); 
                 if (string_eq( ename, entity))  {
                    found = TRUE;
                    linein = string_token( linein, &token, " " );
                    pm_status = substring( token, 0, length(token)-1);
                  }
              }
          }
      }

      pm_status = convert( integer, pm_status );
      po_status = convert( integer, po_status );
      i_status = convert( integer, i_status );
      
      if (pm_status != -1)
          status_flag = pm_status;
      else if (po_status != -1)
          status_flag = po_status;
      else
          status_flag = i_status;

      fclose( fp );
      return( status_flag );

   }
   else
         vlEx.Throw2 (vlEx.FAILURE, "ViewSyn", vlErrSev.Error, sprintf ("Cannot open synth.ini for reading."));
  }
}



dissolve_menu := vcWv.make_menu("dmenu",
                       list("Pre-Optimization", dispreopt_cmd),
                       list("Pre-Mapping",      dispremap_cmd)
                       /*list("Undo",             disundo_cmd)*/);


flatten_menu := vcWv.MakeMenu ("fmenu",
                       list ("Pre-Optimization", flapreopt_cmd),
                       list ("Pre-Mapping",      flapremap_cmd)
                       /*list ("Undo",             flaundo_cmd)*/);

mapconstraint_menu := vcWv.MakeMenu ("mmenu",
                       list ("Inputs  ...", editinput_cmd),
                       list ("Outputs ...", editoutput_cmd));
                    
function block_commands( operation ) {                       
   /* entity popup menu */
   vcCmd.Enable( editvhdl_cmd,       vlOnOff.Off );
   vcCmd.SetDisabledMsg( editvhdl_cmd, " " + operation + " is in progress." );
   vcCmd.Enable( compilevhdl_cmd,    vlOnOff.Off );
   vcCmd.SetDisabledMsg( compilevhdl_cmd, " " + operation + " is in progress." );
   vcCmd.Enable( clone_cmd,    vlOnOff.Off );
   vcCmd.SetDisabledMsg( clone_cmd, " " + operation + " is in progress." );
   vcCmd.Enable( optconstraint_cmd,  vlOnOff.Off );
   vcCmd.SetDisabledMsg( optconstraint_cmd, " " + operation + " is in progress." );
   vcCmd.Enable( dispreopt_cmd,      vlOnOff.Off );
   vcCmd.SetDisabledMsg( dispreopt_cmd, " " + operation + " is in progress." );
   vcCmd.Enable( dispremap_cmd,      vlOnOff.Off );
   vcCmd.SetDisabledMsg( dispremap_cmd, " " + operation + " is in progress." );
   vcCmd.Enable( flapreopt_cmd,      vlOnOff.Off );
   vcCmd.SetDisabledMsg( flapreopt_cmd, " " + operation + " is in progress." );
   vcCmd.Enable( flapremap_cmd,      vlOnOff.Off );
   vcCmd.SetDisabledMsg( flapremap_cmd, " " + operation + " is in progress." );
   vcCmd.Enable( editinput_cmd,      vlOnOff.Off );
   vcCmd.SetDisabledMsg( editinput_cmd, " " + operation + " is in progress." );
   vcCmd.Enable( editoutput_cmd,     vlOnOff.Off );
   vcCmd.SetDisabledMsg( editoutput_cmd, " " + operation + " is in progress." );
   vcCmd.Enable( synth_cmd,          vlOnOff.Off );
   vcCmd.SetDisabledMsg( synth_cmd, " " + operation + " is in progress." );
   vcCmd.Enable( show_report_cmd,    vlOnOff.Off );
   vcCmd.SetDisabledMsg( show_report_cmd, " " + operation + " is in progress." );
   vcCmd.Enable( show_schematic_cmd, vlOnOff.Off );
   vcCmd.SetDisabledMsg( show_schematic_cmd, " " + operation + " is in progress." );
  
   /* setup defaults menu */
   vcCmd.Enable( set_dir_cmd,         vlOnOff.Off );
   vcCmd.SetDisabledMsg( set_dir_cmd, " " + operation + " is in progress." );
   vcCmd.Enable( set_tech_cmd,         vlOnOff.Off );
   vcCmd.SetDisabledMsg( set_tech_cmd, " " + operation + " is in progress." );
   vcCmd.Enable( set_points_cmd,       vlOnOff.Off );
   vcCmd.SetDisabledMsg( set_points_cmd, " " + operation + " is in progress." );
   vcCmd.Enable( compile_vhdl_cmd1,    vlOnOff.Off );
   vcCmd.SetDisabledMsg( compile_vhdl_cmd1, " " + operation + " is in progress." );
   vcCmd.Enable( seldesign2_cmd,       vlOnOff.Off );
   vcCmd.SetDisabledMsg( seldesign2_cmd, " " + operation + " is in progress." );
   vcCmd.Enable( set_map_defaults_cmd, vlOnOff.Off );
   vcCmd.SetDisabledMsg( set_map_defaults_cmd, " " + operation + " is in progress." );
   vcCmd.Enable( cleanup_cmd,          vlOnOff.Off );
   vcCmd.SetDisabledMsg( cleanup_cmd, " " + operation + " is in progress." );

   /* display menu */
   vcCmd.Enable( full_view_cmd,        vlOnOff.Off );
   vcCmd.SetDisabledMsg( full_view_cmd, " " + operation + " is in progress." );
   vcCmd.Enable( show_toggle_edge_cmd, vlOnOff.Off );
   vcCmd.SetDisabledMsg( show_toggle_edge_cmd, " " + operation + " is in progress." );
   vcCmd.Enable( find_cmd,             vlOnOff.Off );
   vcCmd.SetDisabledMsg( find_cmd, " " + operation + " is in progress." );
   vcCmd.Enable( show_level_cmd,       vlOnOff.Off );
   vcCmd.SetDisabledMsg( show_level_cmd, " " + operation + " is in progress." );
   vcCmd.Enable( view_preopt_cmd,      vlOnOff.Off );
   vcCmd.SetDisabledMsg( view_preopt_cmd, " " + operation + " is in progress." );
   vcCmd.Enable( view_premap_cmd,      vlOnOff.Off );
   vcCmd.SetDisabledMsg( view_premap_cmd, " " + operation + " is in progress." );
   vcCmd.Enable( setroot_cmd,          vlOnOff.Off );
   vcCmd.SetDisabledMsg( setroot_cmd, " " + operation + " is in progress." );
   vcCmd.Enable( view_synth_err_cmd,          vlOnOff.Off );
   vcCmd.SetDisabledMsg( view_synth_err_cmd, " " + operation + " is in progress." );
   vcWin.UpdateMenus (vdes2_win);
}

function unblock_commands() {                       
   /* entity popup menu */
   vcCmd.Enable( editvhdl_cmd,       vlOnOff.On );
   vcCmd.Enable( compilevhdl_cmd,    vlOnOff.On );
   vcCmd.Enable( clone_cmd,    vlOnOff.On );
   vcCmd.Enable( optconstraint_cmd,  vlOnOff.On );
   vcCmd.Enable( dispreopt_cmd,      vlOnOff.On );
   vcCmd.Enable( dispremap_cmd,      vlOnOff.On );
   vcCmd.Enable( flapreopt_cmd,      vlOnOff.On );
   vcCmd.Enable( flapremap_cmd,      vlOnOff.On );
   vcCmd.Enable( editinput_cmd,      vlOnOff.On );
   vcCmd.Enable( editoutput_cmd,     vlOnOff.On );
   vcCmd.Enable( synth_cmd,          vlOnOff.On );
   vcCmd.Enable( show_report_cmd,    vlOnOff.On );
   vcCmd.Enable( show_schematic_cmd, vlOnOff.On );
  
   /* setup defaults menu */
   vcCmd.Enable( set_dir_cmd,         vlOnOff.On );
   vcCmd.Enable( set_tech_cmd,         vlOnOff.On );
   vcCmd.Enable( set_points_cmd,       vlOnOff.On );
   vcCmd.Enable( compile_vhdl_cmd1,    vlOnOff.On );
   filename := string_append( work_dir, "/top.ref" );
   if (fexists( filename )) 
       vcCmd.Enable( seldesign2_cmd, vlOnOff.On);
   else {
       vcCmd.Enable (seldesign2_cmd, vlOnOff.Off );
       vcCmd.SetDisabledMsg( seldesign2_cmd, " No compiled VHDL data exists." );
   }
   vcCmd.Enable( set_map_defaults_cmd, vlOnOff.On );
   vcCmd.Enable( cleanup_cmd,          vlOnOff.On );

   /* display menu */
   vcCmd.Enable( full_view_cmd,        vlOnOff.On );
   vcCmd.Enable( show_toggle_edge_cmd, vlOnOff.On );
   vcCmd.Enable( find_cmd,             vlOnOff.On );
   vcCmd.Enable( show_level_cmd,       vlOnOff.On );
   vcCmd.Enable( view_preopt_cmd,      vlOnOff.On );
   vcCmd.Enable( view_premap_cmd,      vlOnOff.On );
   vcCmd.Enable( setroot_cmd,          vlOnOff.On );
   filename := string_append( work_dir, "/synth.err" );
   if (fexists( filename ))
       vcCmd.Enable( view_synth_err_cmd, vlOnOff.On );
   else {
       vcCmd.Enable( view_synth_err_cmd, vlOnOff.Off );
       vcCmd.SetDisabledMsg( view_synth_err_cmd, "synth.err file does not exist." );
   }

   vcWin.UpdateMenus (vdes2_win);
}


/*---------------------------------------------------------------------------*/
/*                                                                           */
/*   POPUP_FUNC  function is .........................................       */
/*                                                                           */
/*                                                                           */
/*                                                                           */

function popup_func (v) 
   {
   menu := vcWv.MakeMenu ("menu",
               list(list ("Edit VHDL",                   editvhdl_cmd       )),
               list(list ("Re-Compile VHDL",             compilevhdl_cmd    )),
               list(list ("Clone",                       clone_cmd          )),
               list(list ("Set Optimization Constraints",optconstraint_cmd  )),
               list(list ("Set Timing Constraints",      mapconstraint_menu )),
               list(list ("Dissolve",                    dissolve_menu      )),
               list(list ("Flatten",                     flatten_menu       )),
               list(list ("Synthesize",                  synth_cmd          )),
               list(list ("View Report",                 show_report_cmd    )),
               list(list ("View Schematic",              show_schematic_cmd )));
    
   func (ev, v)
      {
      if (blocking_popup == 0)
         {
         vcTree.SelectVrtx( tree_region, v); 

         vertex := vcTree.VrtxGetItem( v );
         current_entity = string_copy( vertex );
         text2 := sprintf( "Entity '%s' selected.\n", current_entity );
         vcWin.ClearStatus (vdes2_win);
         vcWin.AddStatus (vdes2_win, text2);

         current_vertex = v;
         status := getStatus( vertex );

         vcCmd.Enable( dispreopt_cmd,     vlOnOff.On );
         vcCmd.Enable( dispremap_cmd,     vlOnOff.On );
         vcCmd.Enable( flapreopt_cmd,     vlOnOff.On );
         vcCmd.Enable( flapremap_cmd,     vlOnOff.On );
         vcCmd.Enable( clone_cmd,         vlOnOff.On );
         vcCmd.Enable( optconstraint_cmd, vlOnOff.On );
         vcCmd.Enable( editinput_cmd,     vlOnOff.On );
         vcCmd.Enable( editoutput_cmd,    vlOnOff.On );
         vcCmd.Enable( synth_cmd,         vlOnOff.On );
         vcCmd.Enable( show_report_cmd,   vlOnOff.On );
         vcCmd.Enable( show_schematic_cmd,vlOnOff.On );
         vcCmd.Enable( disundo_cmd,       vlOnOff.On );
         vcCmd.Enable( flaundo_cmd,       vlOnOff.On );
        
         wirfile := string_append( work_dir, "/wir/", vertex, ".1" );
         if (fexists( wirfile ) == FALSE)
            {
            vcCmd.Enable( show_schematic_cmd,vlOnOff.Off );
            vcCmd.SetDisabledMsg( show_schematic_cmd,
                                  "WIR file for entity does not exist.");
            }
        
         rptfile := string_append( work_dir, "/", vertex, ".rpt" );
         if (fexists( rptfile ) == FALSE)
            {
            vcCmd.Enable( show_report_cmd,vlOnOff.Off );
            vcCmd.SetDisabledMsg( show_report_cmd,
                           "Synthesis report file for entity does not exist.");
            }

         /* fade constraint menus if needed */
         if (not_in_opt( vertex, status ) == TRUE)
            {
            vcCmd.Enable(         clone_cmd,          vlOnOff.Off );
            vcCmd.Enable( optconstraint_cmd,          vlOnOff.Off );
            vcCmd.SetDisabledMsg( optconstraint_cmd, 
                               "Entity does not exist in optimization phase.");

            vcCmd.Enable(         editinput_cmd,      vlOnOff.Off );
            vcCmd.SetDisabledMsg( editinput_cmd, 
                               "Entity does not exist in optimization phase.");

            vcCmd.Enable(         editoutput_cmd,     vlOnOff.Off );
            vcCmd.SetDisabledMsg( editoutput_cmd, 
                               "Entity does not exist in optimization phase.");

            vcCmd.Enable(         synth_cmd,          vlOnOff.Off );
            vcCmd.SetDisabledMsg( synth_cmd, 
                               "Entity does not exist in optimization phase.");

            vcCmd.Enable(         show_report_cmd,    vlOnOff.Off );
            vcCmd.SetDisabledMsg( show_report_cmd, 
                               "Entity does not exist in optimization phase.");

            vcCmd.Enable(         show_schematic_cmd, vlOnOff.Off );
            vcCmd.SetDisabledMsg( show_schematic_cmd, 
                               "Entity does not exist in optimization phase.");
            }

         if (not_in_map( vertex, status ) == TRUE)
            {
            vcCmd.Enable(         editinput_cmd,      vlOnOff.Off );
            vcCmd.SetDisabledMsg( editinput_cmd, 
                                    "Entity does not exist in mapping phase.");

            vcCmd.Enable(         editoutput_cmd,     vlOnOff.Off );
            vcCmd.SetDisabledMsg( editoutput_cmd, 
                                    "Entity does not exist in mapping phase.");

            vcCmd.Enable(         synth_cmd,          vlOnOff.Off );
            vcCmd.SetDisabledMsg( synth_cmd, 
                                    "Entity does not exist in mapping phase.");

            vcCmd.Enable(         show_report_cmd,    vlOnOff.Off );
            vcCmd.SetDisabledMsg( show_report_cmd, 
                                    "Entity does not exist in mapping phase.");

           vcCmd.Enable(         show_schematic_cmd,  vlOnOff.Off );
           vcCmd.SetDisabledMsg( show_schematic_cmd, 
                                    "Entity does not exist in mapping phase.");
           }    

        hier_status := show_hierctl( get_statusflag( vertex ) );

        if (amgdebug == 1) printf( "hier_status = %d\n", hier_status );


        if (hier_status == 8)                            /* flattened premap */
           {
           vcCmd.Enable(         flapremap_cmd, vlOnOff.Off );
           vcCmd.SetDisabledMsg( flapremap_cmd, "Entity is flattened pre-map.");

           vcCmd.Enable(         disundo_cmd,   vlOnOff.Off );
           }

        if (hier_status == 4)                            /* flattened preopt */
           {
           vcCmd.Enable(         dispremap_cmd, vlOnOff.Off );
           vcCmd.SetDisabledMsg( dispremap_cmd, "Entity is flattened pre-opt.");

           vcCmd.Enable(         flapremap_cmd, vlOnOff.Off );
           vcCmd.SetDisabledMsg( flapremap_cmd, "Entity is flattened pre-opt.");

           vcCmd.Enable(         flapreopt_cmd, vlOnOff.Off );
           vcCmd.SetDisabledMsg( flapreopt_cmd, "Entity is flattened pre-opt.");

           vcCmd.Enable(         disundo_cmd,   vlOnOff.Off );
           vcCmd.SetDisabledMsg( disundo_cmd,   "Entity is flattened pre-opt.");
           }
            
        else if (hier_status == 2)                       /* dissolved premap */
           {
           vcCmd.Enable(         dispremap_cmd, vlOnOff.Off );
           vcCmd.SetDisabledMsg( dispremap_cmd, "Entity is dissolved pre-map.");

           vcCmd.Enable(         flapreopt_cmd, vlOnOff.Off );
           vcCmd.SetDisabledMsg( flapreopt_cmd, "Entity is dissolved pre-map.");

           vcCmd.Enable(         flapremap_cmd, vlOnOff.Off );
           vcCmd.SetDisabledMsg( flapremap_cmd, "Entity is dissolved pre-map.");

           vcCmd.Enable(         flaundo_cmd,   vlOnOff.Off );
           vcCmd.SetDisabledMsg( flaundo_cmd,   "Entity is dissolved pre-map.");
           }
            
        else if (hier_status == 1)                       /* dissolved preopt */
           {
           vcCmd.Enable(         dispremap_cmd, vlOnOff.Off );
           vcCmd.SetDisabledMsg( dispremap_cmd, "Entity is dissolved pre-opt.");

           vcCmd.Enable(         dispreopt_cmd, vlOnOff.Off );
           vcCmd.SetDisabledMsg( dispreopt_cmd, "Entity is dissolved pre-opt.");

           vcCmd.Enable(         flapreopt_cmd, vlOnOff.Off );
           vcCmd.SetDisabledMsg( flapreopt_cmd, "Entity is dissolved pre-opt.");

           vcCmd.Enable(         flapremap_cmd, vlOnOff.Off );
           vcCmd.SetDisabledMsg( flapremap_cmd, "Entity is dissolved pre-opt.");

           vcCmd.Enable(         flaundo_cmd,   vlOnOff.Off );
           vcCmd.SetDisabledMsg( flaundo_cmd,   "Entity is dissolved pre-opt.");
           }

        }       /* if not blocking popup */

     else                                               /* if blocking popup */
        {
        vcCmd.Enable( editvhdl_cmd,       vlOnOff.Off );
        vcCmd.Enable( compilevhdl_cmd,    vlOnOff.Off );
        vcCmd.Enable( clone_cmd,          vlOnOff.Off );
        vcCmd.Enable( optconstraint_cmd,  vlOnOff.Off );
        vcCmd.Enable( dispreopt_cmd,      vlOnOff.Off );
        vcCmd.Enable( dispremap_cmd,      vlOnOff.Off );
        vcCmd.Enable( flapreopt_cmd,      vlOnOff.Off );
        vcCmd.Enable( flapremap_cmd,      vlOnOff.Off );
        vcCmd.Enable( editinput_cmd,      vlOnOff.Off );
        vcCmd.Enable( editoutput_cmd,     vlOnOff.Off );
        vcCmd.Enable( synth_cmd,          vlOnOff.Off );
        vcCmd.Enable( show_report_cmd,    vlOnOff.Off );
        vcCmd.Enable( show_schematic_cmd, vlOnOff.Off );
        }

     vcMenuPop.Create (menu, ev); 
     vcRegion.Refresh( tree_region, vcRegion.Area( tree_region ));

       };  /* end of reurned function */
   }                                              /* end function POPUP_FUNC */
                                
    
function activate_cmd(ev, v)
   vcCmd.Run( sample_cmd, vcRegion.GetData(tree), ev, nil, TRUE );
    
    
function update_color(v, col )
   {
   vcTree.VrtxModify(v, border_color <- col );
   vcRegion.Refresh (tree_region, vcRegion.Area(tree_region));
   }


/*---------------------------------------------------------------------------*/
/*                                                                           */
/*   VDES_EXIT  function is ........................................         */
/*                                                                           */
/*                                                                           */
/*                                                                           */

function vdes_exit( mode, code )
   {
   /* clear up cross-reference files */
   if( fexists( vdestmp_file)) vscript.vsDelete( vdestmp_file, vscript.vsFILE);
   if( fexists( pins_file   )) vscript.vsDelete( pins_file,    vscript.vsFILE);
   if( fexists( spins_file  )) vscript.vsDelete( spins_file,   vscript.vsFILE);
   if( fexists( pack_file   )) vscript.vsDelete( pack_file,    vscript.vsFILE);
   if( fexists( spack_file  )) vscript.vsDelete( spack_file,   vscript.vsFILE);
   if( fexists( cons_file   )) vscript.vsDelete( cons_file,    vscript.vsFILE);
   if( fexists( scons_file  )) vscript.vsDelete( scons_file,   vscript.vsFILE);
 
   /* print exciting message */

   if ( code == 0 && mode == vcSysMode.Exited )  
      if ( (mode == vcSysMode.Exited ) )
         {
         print( "Program completed!!");
         vcWin.Destroy (vdes2_win);
         }

   if( code !=0 && mode == vcSysMode.Exited )
       close_all_commands(); 
   }                                                     /* end of VDES_EXIT */


/*---------------------------------------------------------------------------*/
/*                                                                           */
/*   HAC_SYNTH  function will .......................................        */
/*                                                                           */
/*                                                                           */
/*                                                                           */

function hac_synth( entity, force, show, iterate )
   {
   declare command;

   command = "";
   
   /* check for Xilinx processing */
   if ( char_eq( 'x', string_ref( current_tech, 0)) == TRUE)
      {
       if (run_iopad == TRUE)
          command = string_append( command, " -iopad " );
 
       /** if (run_xcons == TRUE) command =string_append( command," -xcons ");*/
      
      if (run_xtech == TRUE) 
          command = string_append( command, " -xtech " );
      }

   command = string_append(command," -iterate ", convert(string,iterate)," " );
   
   if (force == vlYesNo.Yes)
      command = string_append( command, " -f -synth ", entity );
   else 
      {
      if (show == vlYesNo.Yes)
          command = string_append( command, " -n ", entity );
      else
          command = string_append( command, " -synth ", entity );
      }
 
   printf( "command = '%s'\n", command );

   vcWv.CommandSequence(
       list ("cd " + work_dir + "; vsyn -itc " + command ),    /* functions  */
       nil,
       func(str) vcTxShell.PrintString(nusyn_sh,str);,        /* output      */
       nil,
       func(mode,code)                                       /* exit handler */
          {         
          synth_cleanup(); 
          if ( (code == 0) && (mode == vcSysMode.Exited))
             {
             vcWin.Busy( vdes2_win, TRUE );
             readStatus();
             vcWin.Busy( vdes2_win, FALSE );
             unblock_commands();
             blocking_popup = 0;
             }
          else
              vlEx.Throw2 (vlEx.FAILURE, "ViewSyn", vlErrSev.Error, 
                                         "The synthesis operation has errors. "
                                        +"Please check the synth.err file.");
          },
       nil  );
   }                                               /* end function HAC_SYNTH */




function _Initial( data, event )
   {
   read_synth_ini( data, event );
   }


function _Create( arg, region )
   {
   data := struct
        {
        ovly;
        ovly1;
        table
        };

   table := vcTable.Create("vdesII", 3, 1); 

   if (!isbound (`vcTree, nil))   /* verify that the tree library is linked */
      {
      msg := "The vctree library is missing.\n"
            +"\tYou must link the library in order to run the tree demo.";
      vlEx.Throw2 (vlEx.FAILURE, "runtree", vlErrSev.Error, msg);
      }
    
   tree_canvas := vcRegion.Create ("NewSynthesis GUI", vcCanvas.fac, nil,
                             size <- vgSize.Create (700,450,600,250,1000,850));
   vcRegion.Background( tree_canvas, vgColor.Black, TRUE ); 
       
   overlay := vcRegion.Create("Overlay", vcOverlay.fac,vgAlign.UpperLeft); 
   vcRegion.Background(  overlay, vgColor.Black, TRUE ); 
   vcRegion.AddChild(    overlay, tree_canvas );
   vcOverlay.SetCurrent( overlay,tree_canvas);
    
   text1 := vcRegion.Create ("", vcStaticText.fac,"Target Technology: <none>");
   vcRegion.Background( text1, vgColor.Black, TRUE ); 
   vcRegion.Font (text1, vgFont.small);

   overlay1 := vcRegion.Create("Overlay2", vcOverlay.fac,vgAlign.UpperLeft); 
   vcRegion.Background(  overlay1, vgColor.Black, TRUE ); 
   vcRegion.AddChild(    overlay1, text1);
   vcOverlay.SetCurrent( overlay1,text1);

   nusyn_sh = vcRegion.Create( "Hierarchy Control", vcTxShell.fac,"",
                             size <- vgSize.Create(700,150,600,150,1000,150));

   /** scroll := vcRegion.Create("scr", vcScroll.fac, nusyn_sh,              */
   /**                       align <- vgAlign.UpperLeft,                     */
   /**                       show_border <- TRUE,                            */
   /**                       inner_border <- TRUE,                           */
   /** vcSize.Set(size,700,600,600,400,1000,1000);                           */
   /** vcScroll.SetChildSize(scroll,vgSize.Create (300,200,50,50,2000,2000));*/
   
   vcTable.Add(table, overlay1);
   vcTable.Add(table, overlay);
   vcTable.Add(table, nusyn_sh);
   vcTable.Row(table, 2, vcTable.Border.Adjustable,10,10,10,vgAlign.UpperLeft);
   vcRegion.AddChild (region, table);

   vcRegion.Background( region, vgColor.Black, TRUE ); 
   
   vcRegion.Background( nusyn_sh, vgAllColor.Background, TRUE );  
   /* defaults or powerview.ini specified color.  bug 18303: 12/28/94 plabee */

   data.ovly  = overlay;
   data.ovly1  = overlay1;
   vcTxShell.InhibitInput(nusyn_sh, FALSE );
   vcTxShell.PrintString(nusyn_sh,"ViewSyn 5.0.1 (5/12/95)\n");
   
   data;  /* return 'data' */ 
   }                                                   /* end _CREATE method */



/*---------------------------------------------------------------------------*/
/*                                                                           */
/* This last section creates the actual menu bar. The call to vcWv.make_menu */
/* is the same, but it is followed by a call to vcFac.set_menus.  This       */
/* function takes two arguments, the mysterious "fac" and the name of a      */
/* menu you have already created.  This menu is the one that appears across  */
/* the top in your facility window.  Notice that the first entry is the red  */
/* square.                                                                   */
/*                                                                           */

vcFac.SetMenus (fac, main_menu);

init_sfile();
init_menu();
