
/*---------------------------------------------------------------------------*/
/*                                                                           */
/*   vsyn_2.vs         viewsynthesis 5.0           19 January 1995           */
/*                     Copyrite January 1995, Viewlogic Systems, Inc.        */
/*   version 1.22      Phil Labee                                            */
/*                                                                           */
/*   This module does these things and contains these functions:             */
/*                                                                           */
/*                                                                           */
/*   revison history:                                                        */
/*                                                                           */
/*   1/6/95          plabee  changed executable calls from "hac" to "vsyn"   */


declare fixlist;
declare multparents;
declare gfp;
declare declared_vertices;
declare hlevel;
declare levellist;
declare mult_levels;
declare vhdlfilelist;

function get_current_entity( data )
   {
   Vrtx := vcTree.SelectedVrtx( tree_region );
   if (!null(Vrtx))
      {
      current_entity = string_copy( vcTree.VrtxGetItem( Vrtx ) );
      if (!null( current_entity )) 
         return( current_entity );
      else
         error( "Data item for vertex is null", Vrtx );
      }
   else  return "Vrtx is null";
   }



function get_vhdl_src( data )   return( "" );



synth_cmd := vcWv.Cmd (fac, call_synth, "Synthesize", "Perform Logic Synthesis",
     vcWv.Param ("Entity", string, vcWv.Dynamic, get_current_entity, vcStaticText.fac),
     vcWv.Param ("Target Technology", string, vcWv.Dynamic, get_current_tech,
                 vcStaticText.fac ),
     vcWv.Param ("Package", string, vcWv.Dynamic, get_current_package, vcStaticText.fac ),
     vcWv.Param ("Process Type", string, vcWv.Dynamic, 
                 get_current_process_type, vcStaticText.fac ),
     vcWv.Param ("Voltage", float, vcWv.Dynamic, get_current_voltage, vcStaticText.fac ),
     vcWv.Param ("Temperature (C)", float, vcWv.Dynamic,get_current_temperature, vcStaticText.fac ),
     vcWv.Param ("Show out-of-date only (don't execute)", vlYesNoVT, vcWv.Sticky,vlYesNo.No ),
     vcWv.Param ("Force synthesis", vlYesNoVT, vcWv.Sticky,vlYesNo.No ),
     vcWv.Param ("Iterate # of times", vcPixelSpacingVT, vcWv.Sticky,1));

vcCmd.SetHelp (synth_cmd, "Perform synthesis");


function init_menu() {
        vcCmd.Enable (compile_vhdl_cmd1,    vlOnOff.Off);
        vcCmd.SetDisabledMsg( compile_vhdl_cmd1, "Technology must be set first." );
        vcCmd.Enable (seldesign2_cmd,       vlOnOff.Off);
        vcCmd.SetDisabledMsg( seldesign2_cmd, "Technology must be set first." );
        vcCmd.Enable (set_tech_cmd,         vlOnOff.On);
        vcCmd.Enable (setroot_cmd,          vlOnOff.Off);
        vcCmd.SetDisabledMsg( setroot_cmd, "No graphical data is displayed." );
        vcCmd.Enable (set_points_cmd,       vlOnOff.Off);
        vcCmd.SetDisabledMsg( set_points_cmd, "Technology must be set first." );
        vcCmd.Enable (full_view_cmd,        vlOnOff.Off);
        vcCmd.SetDisabledMsg( full_view_cmd, "No graphical data is displayed." );
        vcCmd.Enable (show_toggle_edge_cmd, vlOnOff.Off);
        vcCmd.SetDisabledMsg( show_toggle_edge_cmd, "No graphical data is displayed." );
        vcCmd.Enable (find_cmd,             vlOnOff.Off);
        vcCmd.SetDisabledMsg( find_cmd, "No graphical data is displayed." );
        vcCmd.Enable (show_level_cmd,       vlOnOff.Off);
        vcCmd.SetDisabledMsg( show_level_cmd, "No graphical data is displayed." );
        vcCmd.Enable (view_preopt_cmd,      vlOnOff.Off);
        vcCmd.SetDisabledMsg( view_preopt_cmd, "No graphical data is displayed." );
        vcCmd.Enable (view_premap_cmd,      vlOnOff.Off);
        vcCmd.SetDisabledMsg( view_premap_cmd, "No graphical data is displayed." );
        filename := string_append( work_dir, "/synth.err" );
        if (fexists( filename ) == FALSE) {
            vcCmd.Enable (view_synth_err_cmd,   vlOnOff.Off);
            vcCmd.SetDisabledMsg( view_synth_err_cmd, "synth.err file does not exist." );
        }
        else
            vcCmd.Enable (view_synth_err_cmd,   vlOnOff.On);
} /* end of init_menu */

function close_all_commands() {
    vcCmd.Enable (compile_vhdl_cmd1,   vlOnOff.Off);
    vcCmd.Enable (seldesign2_cmd,      vlOnOff.Off);
    vcCmd.Enable (set_tech_cmd,       vlOnOff.Off);
    vcCmd.Enable (output_cmd,         vlOnOff.Off);
    vcCmd.Enable (synth_cmd,          vlOnOff.Off);
    vcCmd.Enable (wire_cmd,           vlOnOff.Off);
    vcCmd.Enable (show_report_cmd,    vlOnOff.Off);
    vcCmd.Enable (mapconstraint_cmd,  vlOnOff.Off);
    vcCmd.Enable (optconstraint_cmd,  vlOnOff.Off);
    vcCmd.Enable (set_points_cmd,     vlOnOff.Off);
    vcCmd.Enable (viewgen_cmd,        vlOnOff.Off);
    vcCmd.Enable (start_macro_cmd,    vlOnOff.Off);
    vcCmd.Enable (close_macro_cmd,    vlOnOff.Off);
    vcCmd.Enable (run_macro_cmd,      vlOnOff.Off);
    vcCmd.Enable (show_aliases_cmd,   vlOnOff.Off);
    vcCmd.Enable (set_alias_cmd,      vlOnOff.Off);
    vcCmd.Enable (remove_alias_cmd,   vlOnOff.Off);
    vcCmd.Enable (run_system_cmd,     vlOnOff.Off);
    vcCmd.Enable (clear_lib_cmd,      vlOnOff.Off);
    vcCmd.Enable (list_lib_cmd,       vlOnOff.Off);
    vcCmd.Enable (show_setup_cmd,     vlOnOff.Off);
    vcCmd.Enable (show_history_cmd,   vlOnOff.Off);
    vcCmd.Enable (version_cmd,        vlOnOff.Off);
    vcCmd.Enable (view_synth_err_cmd, vlOnOff.Off);
    vcWin.UpdateMenus (vdes2_win);
}


/* a generic vertex creator */
function new_vrtx (labelstr, parent, name )
    vcTree.VrtxCreate( name, vcTree.VrtxType.Metafile, "vhdl.mf",
                          parent, nil,
                          label             <- labelstr,
                          label_color       <- vgColor.Red,
                          label_location    <- vgCompass.South,
                          label_stroke_font <- vgStk.SansSerifBold,
                          label_size        <- 18);


/*---------------------------------------------------------------------------*/
/*                                                                           */
/*   CALL_COMPILE_VHDL1  function is the object of the COMPILE_VHDL_CMD1.    */
/*   It calls HAC_COMPILE after checking the validity of the parameter.      */
/*                                                                           */

function call_compile_vhdl1( d, e, vhdfiles)
   {
   declare tmpstr;

   if (string_eq( vhdfiles, "") != TRUE)
      {
      block_commands( "VHDL Compilation" );
      blocking_popup = 1;
      hac_compile( d, e, vhdfiles );          /* see vsyn2.vs */
      }
   else
      {
      vcWin.ClearStatus( vdes2_win );
      vcWin.AddStatus(vdes2_win, "** Please select a VHDL file **\n");
      vlEx.Throw2 (vlEx.FAILURE, "ViewSyn", vlErrSev.Error,
          sprintf ("Select one or more VHDL files to compile."));
      }
   }                                      /* end function CALL_COMPILE_VHDL1 */


    
compile_vhdl_cmd1:= vcWv.Cmd (fac, call_compile_vhdl1, "Compile VHDL Source",
                                                 "Compile VHDL Source Files",
     vcWv.Param ("", string, vcWv.Dynamic, get_vhdl_src, vsynVlst.fac));

vcCmd.SetHelp (compile_vhdl_cmd1, "Compile VHDL source files");

vcCmd.EnableApply( compile_vhdl_cmd1, vlOnOff.On );



/*---------------------------------------------------------------------------*/
/*                                                                           */

function get_work_dir(dummy)
   {
   if (null (work_dir))  primary_path;
   else                  work_dir;
   }

function call_set_dir( d,e,path )
   {
   work_dir = string_copy( path );
   filename := string_append( work_dir, "/viewdraw.ini" );
   if (fexists( filename ) == FALSE)
      {
      vlEx.Throw2 (vlEx.FAILURE, "ViewSyn", vlErrSev.Error,
          sprintf ("Directory '%s' does not contain a viewdraw.ini file.",
                    work_dir ));
      }
   }

set_dir_cmd:= vcWv.Cmd (fac, call_set_dir, "Change Directory","
                                            Change Working Directory",
      vcWv.Param ("", string, vcWv.Dynamic, get_work_dir, vsynDir.fac));

vcCmd.SetHelp (set_dir_cmd, "Change working directory");




/*---------------------------------------------------------------------------*/
/*                                                                           */
/*   FINDMULT  function is will, using list of all edges seen in graph, for  */
/*   each edge, see it if occurs in the edge list more than once.............*/
/*                                                                           */
/*   It is called with two parameters .................                      */
/*                                                                           */

function findmult() 
   {
   declare multpar, tmp_edge;
   multpar = nil;

   tmp  := copy_list( tree_list );
   while (!null(tmp))  {
     tmp_edge = cdr( car( tmp ) );
     tmp = cdr( tmp );
   }
   edgelist := copy_list( tmp_edge );


   while (!null(tmp_edge)) 
      {
      for( i:= 0,cnt := 0; i<length(edgelist); ++i ) 
         {
         tmp := list(edgelist[i]);
         if ( member( car( tmp_edge), (tmp)) != FALSE )    cnt := cnt + 1; 
         }
      if (cnt > 1) 
         {
         if (null(multpar))
            multpar := list( car( tmp_edge ));
         else 
            if (member( car( tmp_edge), (multpar)) == FALSE)
                multpar := cons( car( tmp_edge ), multpar );
         }
      tmp_edge := cdr( tmp_edge );
      }
   return multpar;
   }                                                /* end function FINDMULT */


/*--------------------------------------------------------------------*/
/* Find  out-of-scope entities */
/*--------------------------------------------------------------------*/
function get_outscope( edgelist ) {
tmp_edge   := copy_list( edgelist );

while (!null( tmp_edge )) {
    entname := car( tmp_edge );
    if (member( entname, ( inscope_ent )) == FALSE) {
        if (null(outscope_ent))
            outscope_ent = list(entname);
        if (member( entname, ( outscope_ent )) == FALSE)
            outscope_ent = cons(entname, outscope_ent);
    }
    
    /* go to next edge */
    tmp_edge := cdr( tmp_edge );
}
}

new_number := 1;
function get_new_number() {
    new_number = new_number + 1;
    return( new_number );
}

function unique_file ( path ) {
 
    declare str, filename, temp_file;

    str = convert( string,  get_new_number());
    filename = "nsynth" + str;
    temp_file = vscript.vsMerge( "", path, filename, "tmp");
    while( fexists( temp_file)) {
         str =convert( string,  get_new_number());
         filename = "nsynth" + str;
         temp_file = vscript.vsMerge( "", path, filename, "tmp");
    }
    return temp_file;
}



function make_multp_data( mp_list, treelist  ) {
declare tmp_tree, mlt, multpdata;
/* 
------------------------------------------------------------
   'mp_list' is the list of nodes with multiple parents
   'treelist' is the global tree list

   This routine constructs a list like:

       ((Vmp1, P1, P2, ...Pn) (Vmp2, P1, P2, ... Pn) ...)

   which consists of a vertex with multiple parents followed
   by a list of its parents.

   Algorithm:
     For each vertex (v) that has multiple parents:
        Find vertices in global tree list that are a parent of "v".
        Make a list of these vertices, with "v" at the head.
        After global list has been searched for "v", get next
        vertex with multiple parents.
------------------------------------------------------------
*/
   multpdata := list();
   while (!null( mp_list )) {
       this_multp := car( mp_list );
       tmp_tree := copy_list( treelist );
       mlt       := list();
       while (!null( tmp_tree )) {
        
          /* get next vertex/edge chunk */
          datachunk := car( tmp_tree );
          vrtx := car( datachunk );
            
          /* edges are what is left in datachunk */
          datachunk := cdr( datachunk ); 
          while (!null( datachunk )) {
             edge := car( datachunk );
             if ( string_eq( edge, this_multp ) == TRUE) {
                 /* add to list, this vertex is a parent of this_multp */
                 if (null(mlt)) {
                     mlt = list( this_multp );
                     mlt = cons( vrtx, mlt );
                 }
                 else
                     mlt = cons( vrtx, mlt );
             }
             datachunk := cdr( datachunk );
          }
          tmp_tree := cdr( tmp_tree );
       }
 
       /* make the 'child' the head of the list (Vmp) */ 
       if (!null(mlt)) {
          mlt := reverse_destructive(mlt);
          if (null(multpdata)) {
              multpdata = list(mlt);
          }
          else
              multpdata = cons( mlt, multpdata );
       }
   
       mp_list := cdr( mp_list );
    
    }  /* !null( mlist ) */

    return multpdata;
}

function get_parents( child, treelist ) {
   /* return a list of parents for a given vertex 
      or nil, if a root node 
   */
declare parents;

   tmp_tree := copy_list( treelist );
   while (!null( tmp_tree )) {
        
      /* get next vertex/edge chunk */
      datachunk := car( tmp_tree );
      vrtx := car( datachunk );
            
      /* edges are what is left in datachunk */
      datachunk := cdr( datachunk ); 
      while (!null( datachunk )) {
         edge := car( datachunk );
         /* Add to list of parents */
         if (iscons( child ) == TRUE)
             child = car( child );
         if (string_eq( edge, child ) == TRUE ) {
            if (null(parents))
               parents = cons( vrtx, nil);
            else
               parents = cons( vrtx, parents );
          }
          datachunk := cdr( datachunk );
       }
       tmp_tree := cdr( tmp_tree );
   }

   if (!null(parents))
      parents := reverse_destructive(parents);
   return parents;
}


function find_level( child_list, parent, treelist ) {
   
   while (!null( child_list )) {

      /* find all references to each child, either as a vertex or edge */
      /* find this vertex in treelist */
      tmp := cons( car( child_list ), parent );
      tmp := cons( tmp, hlevel );
      if (member( tmp, levellist ) == FALSE)
         levellist = cons( tmp, levellist);

      /* check to see if the child is itself a parent */
      tmplist := copy_list( treelist );
      while( !null(tmplist) && string_eq( car( child_list ), car(car(tmplist))) == FALSE )
          tmplist = cdr( tmplist );
      
      if (!null( tmplist )) {

         /* bump level if the child is itself a parent */
         if (string_eq( car( child_list ), car(car(tmplist))) == TRUE) {
             ++hlevel;
         }

         /* process all children of this vertex */
         find_level( cdr( car( tmplist )), car( car( tmplist )), treelist);
      }
     
      /* popped back from 'find_level' - get next child from list */
      child_list = cdr( child_list );
   }
}
function sort_level() {
/*----------------------------------------------------
 Takes a list like:
    ( (Vmp1, parent1) . level1) (Vmp1, parent2) . level2) ... ) 
 Return a list like
    ( (Vmp1, parent) (Vmp2, parent) ...)
    where 'parent' is the parent of Vmp that should be declared
    in the graph file (deepest in the tree hierarchy).

Algorithm:
    For each element in list:
        Get name of vertex with multiple parents
        Make tmp entry for output list for this item    
        Traverse rest of list and find other occurences of this vertex
        For each other occurrence of this vertex:
             If level > this level, update tmp entry for output list
        When list has been traversed, add tmp entry to output list
------------------------------------------------------
*/
declare slist, tmplist;
   
  
   for( i:=0; i<length( tmplist); ++i)
       for( j:=0; j<length( tmplist); ++j) {
          if ((j == i) && (j+1 < length(tmplist)) )
             ++j;
          if ((j == i) && (j = length(tmplist)-1)) ;
          else {
              master := car( car( tmplist[i] ));
              slave := car( car( tmplist[j] ));
              if  (string_eq( master, slave ) == TRUE) {
                  if (null( slist ))
                      slist = cons( tmplist[i], nil );
                  else
                      slist = cons( tmplist[i], slist);
              }
          }
       }   
}


function find_deepest() {

declare outlist;

    tmplist := nil;
    for( i:=0; i<length( levellist); ++i)
       if ((member( car( car ( levellist[i] )), multparents ) != FALSE)
          && (member( levellist[i], tmplist ) == FALSE))
              tmplist = cons( levellist[i], tmplist );
    
    
    for (i:=0; i<length(tmplist); ++i) {
        tmpentry := tmplist[i];
        for (j:=0; j<length(tmplist); ++j) {
            if (string_eq( car(car(tmplist[i] )), car(car(tmplist[j])) ) == TRUE)
        
                if ( ( cdr( tmplist[j] ) >  cdr( tmpentry )) == TRUE)
                   tmpentry = tmplist[j];
        }
        if (member( tmpentry, outlist ) == FALSE) 
            outlist = cons( tmpentry, outlist );
    
    }
    return(outlist);
}



function set_levels( treelist, root ) 
   {
   /*----------------------------------------------------
      for children with multiple parents, 
      make a list like:
        ((Vmp1 <deepest parent>) (Vmp2, <deepest parent>))
   
      for example:
        ( ("logic4" "fsmtrytrywork") )

   ------------------------------------------------------ */

   declare multp_hierlist;
     
   tmplist := copy_list( treelist );
   while( !null( treelist ) && (string_eq( car(car( tmplist )), root) == FALSE))
       tmplist = cdr( tmplist );

   if (string_eq( car( car( tmplist )), root ) == TRUE)
      {
      find_level( cdr( car( tmplist )), root, treelist );
      sort_level();
      }
   else
      error( "Root not found in 'set_levels'", root );
   }                                              /* end function SET_LEVELS */



function write_multiple( mp_list,fp, treelist, popup ) {
/*--------------------------------------------------------------------------
 This routine writes the section of the graph file in /tmp that creates the
 edges to all children that have multiple parents.

 For all parents of a given child, print a line like:
    vcTree.EdgeModify (vcTree.GetEdge (parent1, child), descriptor <- desc);
                      .
                      . 
                      . 
    vcTree.EdgeModify (vcTree.GetEdge (parentN, child), descriptor <- desc);
----------------------------------------------------------------------------
*/
declare multp_data, tmpstr;


   /* process multiple parents */
   tmpstr = sprintf( "\n\n" );
   fputline( fp, tmpstr);
   multp_data := make_multp_data( mp_list, treelist ); 

   /* multp_data looks like ((Vmp1, p1, ..., pn) (Vmp2, p1, ... pn) ...) */
   while (!null( multp_data )) {
      child       := car(car( multp_data ));
      parent_list := cdr(car( multp_data ));
      parent      := car( parent_list );

      /* make sure parent is declared before referencing it */
      if (member( parent, declared_vertices) == FALSE) {
         grandparents := get_parents( parent, treelist );
         write_decl( parent, grandparents, popup );
      }
            
      while (!null( parent_list )) {
         tmpstr = sprintf( "vcTree.EdgeModify( vcTree.GetEdge( v_%s, v_%s ), 
                            descriptor <- desc );\n", 
                            car( parent_list ), child );
         fputline( fp, tmpstr);
         parent_list := cdr( parent_list );
      }
      multp_data := cdr( multp_data );
   }
}

function check_decl( vertex, treelist,popup ) {

    /* make sure parent is declared before referencing it */
    if (iscons( vertex ) == TRUE)
        vertex = car( vertex );
    if (member( vertex, declared_vertices) == FALSE) {
        grandparent := get_parents( vertex, treelist );
        check_decl( grandparent, treelist,popup );
        write_decl( vertex, grandparent, popup );
    }
}

function do_kids( child_list, parent, treelist, popup ) {


    while (!null( child_list )) {
        if (member( car( child_list ), multparents ) != FALSE) { 
            tmplevel:= copy_list( mult_levels );
            while (!null( tmplevel )) {
                if (string_eq( car( child_list ), car(car( car( tmplevel ) ) )) == TRUE)
                   parent := cdr( car( car( tmplevel ))); 
                tmplevel := cdr( tmplevel );
            }

            check_decl( parent, treelist,popup );            
            
            write_decl( car( child_list ), list( parent ), popup );
         }
 
         /* if not already declared, declare this vertex */
         else if (member( car(child_list), declared_vertices) == FALSE)
             write_decl( car( child_list ), list( parent ), popup );

         /* find this vertex in treelist */
         tmplist := copy_list( treelist );
         while( !null(tmplist) && string_eq( car( child_list ), car(car(tmplist))) == FALSE )
             tmplist = cdr( tmplist );

         if (!null( tmplist )) {
             /* process all children of this vertex */
             do_kids( cdr( car( tmplist )), car( car( tmplist )) , treelist, popup);
         }

         /* popped back - get next child from list */
         child_list = cdr( child_list );
    }
}
function make_popup( v, gfp, enable ) {
declare tmpstr;

       /* only display popup menu for inscope entities */
       if (enable == TRUE) {
          if (member( v, inscope_ent) != FALSE) {
             tmpstr = sprintf("vcTree.VrtxCallOnAltActivate( v_%s, popup_func( v_%s ));\n",v, v);
             fputline( gfp, tmpstr );
          }
       }
       tmpstr=sprintf("vcTree.VrtxSetItem( v_%s, \"%s\" );\n\n",v,v);
       fputline( gfp,  tmpstr );
}

function write_decl( vertex, parents, popup ) {
declare tmpstr;


   if ((parents == nil) && (string_eq( rootNode, vertex ) == TRUE)) {
       if (member( vertex, declared_vertices) == FALSE) {
          tmpstr = sprintf( "\/\*Root node \*\/\n" );
          fputline( gfp,  tmpstr );
          tmpstr = sprintf("v_%s := new_vrtx( \"%s\", nil, \"\");\n",vertex,vertex);
          fputline( gfp,  tmpstr );
          if (null(declared_vertices))
             declared_vertices = list( vertex, nil);
          else
             declared_vertices = cons( vertex, declared_vertices );
       }
       make_popup( vertex, gfp, popup );
   }
   else {
       tmplist := copy_list( parents );
       while (!null( tmplist )) {
           if (null(multparents) || 
               (member( vertex, multparents) == FALSE) || 
               (member( vertex, declared_vertices) == FALSE)) {
               tmpstr = sprintf("v_%s := new_vrtx( \"%s\", v_%s, \"\");\n",vertex,vertex,car( tmplist ));
               fputline( gfp,  tmpstr );
               if (member( vertex, declared_vertices) == FALSE) {
                   if (null(declared_vertices))
                       declared_vertices = list( vertex, nil);
                   else {
                       declared_vertices = cons( vertex, declared_vertices );
                       make_popup( vertex, gfp, popup );
                   }
               }
           }
   
           tmplist = cdr( tmplist );
        }
    }
}


function find_graph_roots() {

declare rList; /* list of roots in 'tree_list' */
declare vertices;
declare edges;

    tmplist := copy_list( tree_list );
    while( !null( tmplist )) {
        
        if (null( vertices ))
            vertices = cons( car( car( tmplist )), nil );
        else
            vertices = cons( car( car( tmplist )), vertices );
      
        kids := cdr( car( tmplist ));
        while( !null( kids )) {
            if (null( edges ))
                edges = cons( car( kids ), nil );
            else 
                if (member( car( kids ), edges ) == FALSE)
                    edges = cons( car( kids ), edges );
            kids = cdr( kids );
        } 
        tmplist = cdr( tmplist );
    }

    while (!null( vertices )) {
        if (member( car( vertices ), edges ) == FALSE)
            if( null( rList))
                rList = cons( car( vertices ), nil );
            else
                rList = cons( car( vertices ), rList );
        vertices = cdr( vertices );
    } 
    return rList;
}

function write_region_decl( root, popup ) {
declare tmpstr;

   tmpstr = sprintf( "\nnewtree = vcRegion.Create( \"NewSynthesis GUI DEMO\",\n" );
   fputline( gfp, tmpstr);
   tmpstr = sprintf( "                       vcTree.fac, nil,\n" );
   fputline( gfp,tmpstr);
   tmpstr = sprintf( "                       default_edge_descriptor <- desc,\n" );
   fputline( gfp,tmpstr);
   tmpstr = sprintf( "                       interactive <- TRUE,\n" );
   fputline( gfp,tmpstr);
   tmpstr = sprintf( "                       size <- vgSize.Create (700, 450, 600, 250, 1000, 850),\n" );
   fputline( gfp,tmpstr);
   tmpstr = sprintf( "                       inhibit_select_box <- FALSE );\n" );
   fputline( gfp,tmpstr);
   tmpstr = sprintf( "\n/* root nodes of the tree */\n" );
   fputline( gfp,tmpstr);
  
   tmplist := copy_list( rootList );
   while (!null( tmplist )) {
       rootname := car( tmplist );
       if (member( rootname, declared_vertices) == FALSE)
         write_decl( rootname, nil, popup );
      tmplist = cdr( tmplist );
   }
   tmpstr = sprintf( "treeRoots := list( \n" );
   fputline( gfp,tmpstr);
   
   tmplist := copy_list( rootList );
   while (!null( tmplist )) {
      if (null(cdr( tmplist )))
          tmpstr = sprintf( " v_%s", string2symbol( car( tmplist ) ));
      else
          tmpstr = sprintf( " v_%s,\n", string2symbol( car( tmplist ) ));
      fputline( gfp,tmpstr);
      tmplist = cdr( tmplist );
   }


   tmpstr = sprintf( ");\n" );
   fputline( gfp,tmpstr);
   tmpstr = sprintf( "vcTree.SetRoot( newtree, treeRoots );\n" );
   fputline( gfp,tmpstr);
}
       

function write_tree (root, treelist, popup )
   {
/*
   ------------------------------------------------
   Write out the ViewScript vcTree code
   to construct a tree, with root node 'root'.
   The global 'tree_list' is the list of all data
   read from 'top.ref', in the format:

   (v1, (e1, ..., en)), (v2, (e2,..., en), ...

   TODO!!
     Figure out hierarchical level, and base
     declarations on that. This will hopefully
     take care of problems seen with 'multiple root'
     VHDL files.

   Algorithm:
     1) Write declaration for root node
     2) For each child of root (until no children):
         a) Write declaration for child vertex
         b) For each child of child vertex: call 2)
        
   Arguments:
       root = root of tree
       treelist = tree data list
       popup = TRUE/FALSE to create popups for entities
               (FALSE for preopt/premap views which are
                read-only views) 
   ------------------------------------------------
*/
declare tmpstr;

   declared_vertices = nil;
   graph_file = unique_file( "/tmp" );
   gfp = fopen( graph_file, "w");
   if (null(gfp)) 
       vlEx.Throw2(vlEx.FAILURE, "ViewSyn", vlErrSev.Warning,
           sprintf( "Cannot open graph file for writing",graph_file) );


   multparents = findmult();
       
   for (i:=0; i<length( rootList ); ++i)
      {
      hlevel = 1;
      set_levels( treelist, rootList[i] );
      }

   mult_levels = find_deepest();

   tmpstr = sprintf( "/* treelist = \n" );
   fputline( gfp, tmpstr ); 

   for( i:= 0; i<length(treelist); ++i )
      {
      tmpstr = sprintf( "    %s\n", treelist[i] );
      fputline( gfp, tmpstr ); 
      }
   tmpstr = sprintf( "*/\n" );
   fputline( gfp, tmpstr ); 
   tmpstr = sprintf( "\n/* rootList = %s */\n", rootList );
   fputline( gfp, tmpstr ); 
   declared_vertices = nil;

   /* write declaration for root node */
   write_decl( root, nil, popup );
    
   /* find root vertex in tree_list */
   tmplist := copy_list( treelist );

   while( !null(tmplist) && string_eq( root, car(car(tmplist))) == FALSE )
      tmplist = cdr( tmplist );

   /* recursively process all children of root node */ 
   children := cdr(car( tmplist ));
   do_kids( children, root, treelist, popup );
        
   /* write region creation section */
   write_region_decl( root, popup );

   /* write multiple parent info */ 
   if (!null(multparents))
      write_multiple(multparents, gfp, treelist, popup );

   /* modify out-of-scope entities to use appropriate icon (blackbox) */
   tmpstr = sprintf( "\n\n" );  
   fputline( gfp,tmpstr);
   vlist := copy_list(initial_view);

   for(; (!null(vlist)); vlist=cdr(vlist))
      {
      if ( (member( car(vlist), declared_vertices) != FALSE) &&
           (member( car(vlist), inscope_ent)       == FALSE))
         {
         tmpstr = sprintf("vcTree.VrtxChangeDisplayInfo( v_%s,"
                           +" \"blackbox.mf\" );\n",  car(vlist) );  
         fputline( gfp,tmpstr);
         }
      }

   fclose(gfp);
   }                                              /* end function WRITE_TREE */


function find_kids( child_list, parent, treelist ) {

   while (!null( child_list )) {

      /* find all references to each child, as a vertex */
      /* find this vertex in treelist */
      
      /* check to see if the child is itself a parent */
      tmplist := copy_list( treelist );
      while( !null(tmplist) && string_eq( car( child_list ), car(car(tmplist))) == FALSE )
      tmplist = cdr( tmplist );

      if (!null( tmplist )) {

         /* printf( "Checking to see if %s is in %s...\n", car( tmplist ), fixlist);*/
         /* add this chunk to fixed_list */
         /*printf("member( %s, %s ) = %s\n", car( tmplist ), fixlist, member( car( tmplist),fixlist));*/
         if (member( car( tmplist ), fixlist ) == FALSE)
             fixlist = cons( car( tmplist ), fixlist );

         /* process all children of this vertex */
         find_kids( cdr( car( tmplist )), car( car( tmplist )), treelist);
      }
     
      /* check to see if the child is referenced somewhere else */ 
      /*tmplist := copy_list( treelist );
      while( !null(tmplist) ) {
          list_element := car( tmplist );
          tmpchunk := cdr( car( tmplist ) );
          while( !null( tmpchunk ) ) {
              if( string_eq( car( tmpchunk ), car( child_list )) == TRUE)*/
                  /* add this chunk to fixed_list */
                  /*if (member( list_element, fixlist ) == FALSE)
                      fixlist = cons( list_element, fixlist );
              tmpchunk = cdr( tmpchunk );
          }
          tmplist = cdr( tmplist );
      }*/
   
      /* popped back from 'find_kids' - get next child from list */
      child_list = cdr( child_list );
      /*printf( "2. child_list ='%s'\n", child_list );*/
   }
}

function fixtree( treelist, root ) {

    /* get chunk for root */
    tmplist:=copy_list( treelist );
    while ((!null( tmplist )) && (string_eq( root, car(car(tmplist))) == FALSE))
       tmplist=cdr( tmplist );
 
    /* see if 'root' has no children - i.e., a leaf cell */ 
    if ( (null( tmplist )) || (string_eq( root, car(car(tmplist))) == FALSE)) {
        fixlist = cons( cons( root, nil ), nil );
        tmplist = copy_list( fixlist );
    }
    else
        fixlist = cons( car( tmplist ), nil );

    children := cdr( car( tmplist ));
    find_kids( children, root, treelist );

    return( fixlist );
 
}



/*---------------------------------------------------------------------------*/
/*                                                                           */
/*   CALL_SELECT_DESIGN  function is the object of the SELDESIGN2_CMD  which */
/*   is called from the "View Design" pick in the "Setup" menu.              */
/*                                                                           */
/*   This function will
/*   the design hierarchy before the optimization phase.  It is called only  */
/*   with the data and event objects supplied by core (i.e. no Parameters).  */
/*                                                                           */
/*                                                                           */
/*                                                                           */


function call_select_design( d, e, root )
    {
    function callfixtree()
        tree_list = fixtree( tree_list, root );
        

    function callfindroots()
        rootList = find_graph_roots();  

    function callwritetree()
        write_tree( root, tree_list, TRUE );

    function loadfile()
        load( graph_file );

   if (!null( root ) && (string_eq( root, "") != TRUE) ) {
       blocking_popup = 1;
       block_commands( "'View Design'");
       vcWin.Busy( vdes2_win, TRUE );
       
       rootNode = string_copy( root ); 
       vcRegion.Refresh( region, vcRegion.Area( region ));

       /* Make the following 3 calls use WithBusy ...*/
       /* process tree_list to include only vertices referenced from 'root' */
       text2 := sprintf( "Creating graph data...\n");
       vcWin.ClearStatus( vdes2_win );
       vcWin.AddStatus(vdes2_win, text2 );
       vcWin.WithBusy( vdes2_win, callfixtree );
    
       /* find the roots in the 'fixed' tree_list */
       vcWin.WithBusy( vdes2_win, callfindroots );
       
       vcWin.WithBusy( vdes2_win, callwritetree );

       /* remove the last child of the overlay
          this is because the gesture will be applied to the
          first child of the overlay (needed for ZOOM) */
       if (isbound( `newtree, nil ) == TRUE) 
           if (!null(newtree)) 
              vcRegion.RemoveChild( newtree );
 
       vcWin.Busy( vdes2_win, FALSE );
       if (string_eq( rootNode , "" ) != TRUE) {
           text2 := sprintf( "Verifying synthesis data is up-to-date...\n");
           vcWin.ClearStatus( vdes2_win );
           vcWin.AddStatus(vdes2_win, text2 );
           vcWin.Busy( vdes2_win, TRUE );
           vcWv.CommandSequence(
           list ("cd " + work_dir + "; vsyn -n " + rootNode ),
              nil,
              func(str) {
                vcTxShell.PrintString(nusyn_sh,str);},
                nil,
                func(mode,code) { 
                    vcWin.WithBusy( vdes2_win, loadfile );
                    tree_region = newtree;
                    vcRegion.AddChild(d.ovly,newtree);
                    vcOverlay.SetCurrent(d.ovly,newtree);
                    vcWin.WithBusy( vdes2_win, func() {update_icons( tree_region, TRUE );}); 
                    vcWin.WithBusy( vdes2_win, func() {readStatus();});
                    text2 := sprintf( "Select an entity with the right mouse button.\n");
                    vcWin.ClearStatus( vdes2_win );
                    vcWin.AddStatus(vdes2_win, text2 );
                     
                    text3 := vcRegion.Create ("", vcStaticText.fac, "Target Technology: "+current_tech+"              Design: "+root);
                    vcRegion.Font (text3, vgFont.small);
                    vcRegion.AddChild(d.ovly1, text3);
                    vcOverlay.SetCurrent(d.ovly1, text3);
                    blocking_popup = 0;
                    unblock_commands();
                    vcWin.Busy( vdes2_win, FALSE );
                    if ( fexists( graph_file )) 
                       vscript.vsDelete( graph_file, vscript.vsFILE );
               }
               ,nil );
       }
       else
         vlEx.Throw2 (vlEx.FAILURE, "ViewSyn",
                      vlErrSev.Error,
                      sprintf ("Root node for design in null."));
    }
    else
       vlEx.Throw2 (vlEx.FAILURE, "ViewSyn", vlErrSev.Error,
                sprintf ("Select a design to display before clicking 'OK'."));

   }                                      /* end function CALL_SELECT_DESIGN */


function get_root_src( data)
   { 
   function doread()   read_reffile();
 
   vcRegion.Refresh( region, vcRegion.Area( region ));
   vcWin.ClearStatus( vdes2_win );
   vcWin.AddStatus(vdes2_win, "Reading compiled VHDL designs...");
   vcWin.WithBusy( vdes2_win, doread );
   return( " " );
   }



seldesign2_cmd := vcWv.Cmd (fac, call_select_design, "View Design",
                                                     "Select VHDL Design",
         vcWv.Param ("", string, vcWv.Dynamic, get_root_src, vsynroot.fac));

vcCmd.SetHelp (seldesign2_cmd, "View graph of design hierarchy");




function confirm_cleanup(d,e)
"This command deletes all data from the 'synth'
directory, including all ViewSynthesis-generated
synthesis data. If you have created user files
in the synth directory (Do NOT Do This!), move
them before using this command.";

cleanup_cmd := vcWv.CmdWithConfirm( fac, hac_cleanup, confirm_cleanup, TRUE, 
                                    "Clean Work Area", "Clear Work Area");

vcCmd.SetHelp (cleanup_cmd, "Clean synthesis work area");

/*
compile_menu := vcWv.MakeMenu( "Compile",
                      list ("All Local VHDL",compile_vhdl_cmd2),
                      list ("Select Files  ",compile_vhdl_cmd1));
 */                       
chip_setup_menu := vcWv.MakeMenu( "Setup",
                        list( "Change Directory",    set_dir_cmd ),
                        list( "Target Technology",set_tech_cmd ),
                        list( "Operating Points", set_points_cmd ),
                        list ("Compile VHDL",     compile_vhdl_cmd1 ),
                        list( "View Design",      seldesign2_cmd ),
                        list( "Set Defaults",     set_map_defaults_cmd),
                        list( "Clear Work Area",  cleanup_cmd ));

function call_toggle_edge_cmd(data,event) {

    if (edges_on == 1) {
        vcTree.EdgeDescriptorModify(desc, color <- vgColor.Black );
        edges_on = 0;
    }
    else {
        vcTree.EdgeDescriptorModify(desc, color <- vgColor.LightBlue );
        edges_on = 1;
    }
    vcTree.UpdateEdges(tree_region, desc );
    vcRegion.Refresh( tree_region, vcRegion.Area( tree_region ));
}

show_toggle_edge_cmd := vcWv.Cmd( fac, call_toggle_edge_cmd, "Toggle Edges", "Toggle Edge");

vcCmd.SetHelp (show_toggle_edge_cmd, "Show/hide graph edges");

function call_find_cmd(data,event,name) {
   
    foreach( v; vcTree.Vertices( tree_region ))
       if (!null( vcTree.VrtxGetItem(v))) {
           if (string_eq( vcTree.VrtxGetItem(v),  name )) {
               vcTree.Zoom( tree_region, v );
               vcTree.SelectVrtx( tree_region, v );
           }
       }
}

find_cmd := vcWv.Cmd( fac, call_find_cmd, "Find Entity", "Find Entity",
     vcWv.Param ("Entity Name", vlStringVT, vcWv.Sticky, ""));
vcCmd.SetHelp (find_cmd, "Find an entity in the graph");

function call_full_view_cmd(data,event)
    vcTree.ZoomToFull( tree_region );

full_view_cmd := vcWv.Cmd( fac, call_full_view_cmd, "Full View", "Full View");
vcCmd.SetHelp (full_view_cmd, "Display full view of graph");

function call_show_level(data,event,entity) {
   ; 
}

show_level_cmd := vcWv.Cmd( fac, call_show_level, "Graph Options", "Graph Options",
     vcWv.Param ("", vlStringVT, vcWv.Sticky, "", vsynlevl.fac ));
vcCmd.SetHelp (show_level_cmd, "Set options for graph display");

function remove_node( v, treelist ) {
/*-----------------------------------------------------------
Remove a node from tree list, which has the structure:
   ("v1" "e1" "e2" "e3") ("v2" "e1" "e2" "e3" ) ...
-------------------------------------------------------------
*/
declare newlist, tmplist;

    tmplist = copy_list( treelist );

    while (!null( tmplist )) {
        if (string_eq ( car( car( tmplist )), v) == FALSE) {
            /* add this element to new list */
            if (null( newlist ))
                newlist = cons( car( tmplist ), nil );
            else
                newlist = cons( car( tmplist ), newlist );
        }
        tmplist = cdr( tmplist );
    }
    newlist = reverse_destructive( newlist );
}


display_menu := vcWv.MakeMenu( "Display",
                        list( "Full View", full_view_cmd ),
                        list( "Show/Hide Dependencies", show_toggle_edge_cmd ),
                        list( "Find Entity",  find_cmd ),
                        list( "Graph Options",  show_level_cmd ),
                        list( "View Pre-Optimization",  view_preopt_cmd ),
                        list( "View Pre-Mapping",  view_premap_cmd ),
                        list( "Set Root",  setroot_cmd ),
                        list( "View Error Log",  view_synth_err_cmd));

main_menu := vcWv.make_menu  ("main_menu",
  vcWin.RedSquareEntry,
  list ("Setup", chip_setup_menu),
  list ("Display", display_menu ));
