
function set_display_level (data, flag) {
    vcRegion.PrefSet (tree_region, list (display_level <- data));
    vcRegion.Refresh (tree_region, vcRegion.Area (tree_region));
}

function change_style (event, style) {
   foreach (v1, v2, event; vcTree.VisibleEdges( tree_region ))
       vcTree.EdgeModify (event, style <- style);
   vcRegion.Refresh( tree_region, vcRegion.Area( tree_region ));
}


function change_curved(event, val) {
   foreach (v1, v2, event; vcTree.VisibleEdges( tree_region ))
      vcTree.EdgeModify(event, curved <- val);
   vcRegion.Refresh( tree_region , vcRegion.Area( tree_region ));
}
   

function _Create(name,region) {
declare maxlevel,lev;
    
    maxlevel = 1;
    foreach( v; vcTree.Vertices( tree_region ))
       if ( vcTree.VrtxLevel( v ) > maxlevel )
           maxlevel = vcTree.VrtxLevel( v );

    /* now the display level picklist */
    pick := vcRegion.Create ("pick", vcPicklist.fac, nil );
    vcPicklist.Add( pick, "1", 1);
    for( i:=2; i<= maxlevel; ++i) {
        lev = convert( string, i);
        vcPicklist.Add( pick, lev, i);
    }
    vcPicklist.Add( pick, "All", maxlevel);

    
    vcPicklist.Notify (pick, set_display_level);
    
    msg := vcRegion.Create ("msg", vcStaticText.fac, "Display Level:");
    vcRegion.Font (msg, vgFont.medium);
    tab := vcTable.Make ("tab", 1, 2, msg, pick);

    b2 := vcRegion.Create ("brdr", vcBorder.fac, tab,
                           border_style <- vcBorderStyle.ShadowIn);
    m2 := vcRegion.Create ("mrg", vcMargin.fac, b2);
    



/* now create the controls */
compass_data := list (list ("North", vgCompass.North),
                      list ("South", vgCompass.South),
                      list ("East",  vgCompass.East),
                      list ("West",  vgCompass.West));
compass_box := vcRegion.Create ("compass", vcRadioBox.fac, nil,
                       data <- compass_data);

function change_compass (ev, direction) {
   vcRegion.PrefSet (tree_region, list (compass <- direction));
   vcRegion.Refresh (tree_region, vcRegion.Area (tree_region));
}

vcRadioBox.NotifyOnChange (compass_box, change_compass);


layout_data := list (list ("Narrow",   vcTree.Layout.Wide),
                     list ("Wide", vcTree.Layout.Narrow));
                     
layout_box := vcRegion.Create ("compass", vcRadioBox.fac, nil,
                       data <- layout_data);

function change_layout (ev, l) {
   vcRegion.PrefSet (tree_region, list (layout <- l));
   vcRegion.Refresh (tree_region, vcRegion.Area (tree_region));
}

vcRadioBox.NotifyOnChange (layout_box, change_layout);

function change_squish (ev, val) {
   if (val)
      val = vlYesNo.Yes;
   else
      val = vlYesNo.No;
   vcRegion.PrefSet (tree_region, list (squish <- val));
   vcRegion.Refresh (tree_region, vcRegion.Area (tree_region));
}
squish_btn := vcRegion.Create ("squishbtn", vcToggleButton.fac, FALSE,
                    label <- "Compress", action <- change_squish);
                     
style_data := list (list ("Direct", vcTree.EdgeStyle.Direct),
                    list ("Bent",   vcTree.EdgeStyle.Bent),
                    list ("Either", vcTree.EdgeStyle.Either));
style_box := vcRegion.Create ("stylebox", vcRadioBox.fac, 
                        vcTree.EdgeStyle.Either, data <- style_data);
vcRadioBox.NotifyOnChange (style_box, change_style);

curve_btn := vcRegion.Create ("curvebtn", vcToggleButton.fac, FALSE,
                  label <- "Curved", action <- change_curved);

/* now out everything together */
control_table := vcTable.Create ("control_table", 2, 5);
vcTable.Add (control_table,
         vcRegion.Create ("compasslabel", vcStaticText.fac, "Compass"));
vcTable.Add (control_table,
         vcRegion.Create ("layout_label", vcStaticText.fac, "Layout"));
vcTable.Add (control_table, 
         vcRegion.Create ("squish_label", vcStaticText.fac,
              "Compress (Wide only)"));
vcTable.Add (control_table, 
         vcRegion.Create ("edge_label", vcStaticText.fac,
              "Connection Style"));
vcTable.Add (control_table, 
         vcRegion.Create ("curve_label", vcStaticText.fac,
              "Curved Edges?"));
vcTable.Add (control_table, compass_box);
vcTable.Add (control_table, layout_box);
vcTable.Add (control_table, squish_btn);
vcTable.Add (control_table, style_box );
vcTable.Add (control_table, curve_btn);
vcTable.Row (control_table, 1, vcTable.Border.Invisible, 
              1, 1, 1, vgAlign.UpperLeft);
vcTable.Col (control_table, vcTable.All, vcTable.Border.Visible,
              1, 1, 1, vgAlign.UpperLeft);
    

bigtable:= vcTable.Create ("control_table", 2, 1);
vcTable.Add( bigtable, m2 );
vcTable.Add( bigtable, control_table );

vcRegion.AddChild( region, bigtable);
bigtable;

}

function _Get(tab, region, ts) 
;
/*    vcRegion.Get(vcTable.Get(tab, 1, 1),ts);*/
