
/*---------------------------------------------------------------------------*/
/*                                                                           */
/*   vsynmain.vs       viewsynthesis 5.0           24 January 1995           */
/*                     Copyrite January 1995, Viewlogic Systems, Inc.        */
/*   version 1.27      Phil Labee                                            */
/*                                                                           */
/*   This is the primary module which is loaded from the "viewsyn" command.  */
/*   It will load these modules:                                             */
/*                                                                           */
/*       vsyn_itc.vs   set up Inter-Tool Communication with viewFSM, vsyn    */
/*       vsyntest.vs                                                         */
/*       vsynvhdL.vs                                                         */
/*       vsynVlst.vs                                                         */
/*       vsynDir.vs                                                          */
/*       vsynp2.vs                                                           */
/*       vsyn_3.vs                                                           */
/*       vsynvhdP.vs                                                         */
/*       vsynroot.vs                                                         */
/*       vsynhier.vs                                                         */
/*       vsynlevl.vs                                                         */
/*       vsyn_4.vs                                                           */
/*       vsyn2.vs                                                            */
/*                                                                           */
/*   This module contains these functions:                                   */


declare   vdes2_win;
declare   fac;
declare   region;
declare rootNode;
sec_code := "vhdldes";
declare  nusyn_sh;
declare vhdFiles, tech_string, tech_list_table,blocking_popup;

declare optVal, cpuVal, flatVal, redunVal;
declare run_iopad, run_xcons, run_xtech, runAluCons, aluSpeed;
vcWv.MakeEnum( "aluEnumVT", list( "Yes", "No"));
runAluCons = aluEnum.No;
aluSpeed = 1;
run_iopad = TRUE;
run_xcons = FALSE;
run_xtech = TRUE;

declare work_dir;
declare newtree;
declare vdestmp_file;
declare sec_file;
declare ssec_file;
declare pins_file;
declare spins_file;
declare pack_file;
declare spack_file;
declare cons_file;
declare scons_file;
declare primary_path;
declare vdraw_path;
declare vdraw_alias;
declare writable_alias;
declare amgdebug;
amgdebug = 1;
declare initial_view;      /* list of all vertices */
declare preopt_view;
declare premap_view;
declare edge_list;        /* list of all edges                     */
declare has_edge_list;
declare inscope_ent;
declare tree_list;        /* (v1, e1.1, e1.2, ...), (v2, e2.1, e2.2, ...) */
declare treedata;
declare vhdsrc_list;

declare rootList;
declare graph_file;
declare tree_region;
declare current_entity;
declare edges_on;
edges_on = 1;

new_number := 1;
function get_new_number() {

    new_number = new_number + 1;
    return( new_number );
}

function unique_filename ( path ) {
 
    declare str, filename, temp_file, fp; 

    str =convert( string,  get_new_number());
    filename = "vdes" + str;
    temp_file = vscript.vsMerge( "", path, filename, "tmp");
    while( fexists( temp_file)) {
         str =convert( string,  get_new_number());
         filename = "vdes" + str;
         temp_file = vscript.vsMerge( "", path, filename, "tmp");
    }
    fp = fopen( temp_file, "w");
    fclose( fp );
   
    vdestmp_file = temp_file;
    pins_file = vscript.vsMerge( "", path, filename, "pi" );
    pack_file = vscript.vsMerge( "", path, filename, "pa" );
    cons_file = vscript.vsMerge( "", path, filename, "co" );
}
 
function read_vdrawini() {

    function append1(list1, item) {
         return (reverse(cons(item,reverse(list1)))); }
    /* end jrs */


    primary_path = nil;
    vdraw_path = nil;
    vdraw_alias = nil;
    writable_alias = nil;
    vdrawini := fopen (vscript.vsGetini ("viewdraw.ini"), "r");
    if( vdrawini == nil ) return( 1 );
    for (s := fgetline (vdrawini); s != nil; s = fgetline (vdrawini)) {

        /*
         * If it's a directory line, "DIR [r] /pathname/...."
         * parse it and add it to the path list.
         */
        if (((s = string_token (s, &cmd, " \t")) != nil) &&
            (string_eqi (cmd, "dir")) &&
            ((s = string_token (s, &ignore, " \t")) != nil) &&
            ((s = string_token (s, &path, " \t\n")) != nil)) {
            if( (primary_path == nil) &&
                ( lindex( ignore, 'p') ||
                 lindex( ignore, 'P' )))
                primary_path = string_copy( path );
            string_token(s, &alias, " ()\t\n");
            vdraw_path =  append1( vdraw_path, vscript.vsAbsPath (path) );
            vdraw_alias = append1( vdraw_alias, alias );
            if( (alias != nil ) && 
                (lindex( ignore, 'p' ) ||
                 lindex( ignore, 'P' ) ||
                 lindex( ignore, 'w' ) ||
                 lindex( ignore, 'W' ))) 
                 writable_alias = append1( writable_alias, alias );
         } 

    } /* for */
    fclose (vdrawini);
    if( primary_path == nil ) {
        set_stdout( TRUE );
        printf("ERROR: must specify primary directory in viewdraw.ini\n");
        return(1);
    }
    else if (string_eq( primary_path, "." ) == TRUE)
        primary_path = vscript.vsAbsPath( primary_path );

    if (string_eq( substring(primary_path,0,8), "/tmp_mnt") == TRUE)
        primary_path = substring(primary_path,8,length(primary_path));

    work_dir = string_copy( primary_path );
    return( 0 );
} /* end of read_vdrawini */



/*---------------------------------------------------------------------------*/
/*                                                                           */
/*   READ_REFFILE  function is called with no arguments by the following:    */
/*                                                                           */
/*        hac_compile    vsyn2.vs                                            */
/*        hac_uniq       vsyn2.vs                                            */
/*        get_root_src   vsyn_2.vs                                           */
/*                                                                           */
/*                                                                           */
/*                                                                           */
/*                                                                           */
function read_reffile() 
   {
   declare linein;

   initial_view   = nil;
   preopt_view    = nil;
   premap_view    = nil;
   edge_list      = nil;
   has_edge_list  = nil;
   inscope_ent    = nil;
   tree_list      = nil;
   treedata       = nil;
   vhdsrc_list    = nil;

   filename := string_append( work_dir, "/top.ref" );
   if (fexists( filename )) 
      {
      fp := fopen( filename, "r");
      if (!null(fp)) 
         {
         while( !string_eq( linein=fgetline(fp), "$initial\n"));
         initial_view = process_section(fp, "initial");
         preopt_view  = process_section(fp, "preopt");
         premap_view  = process_section(fp, "premap");
         }
      else  
         vlEx.Throw2( vlEx.FAILURE, "Viewsyn", vlErrSev.Warning,
             sprintf("Cannot open design reference file %s", file) );

      fclose(fp);
      rootList = findroots( edge_list );
      }
   }                                            /* end function READ_REFFILE */




/*---------------------------------------------------------------------------*/
/*                                                                           */
/*   PROCESS_SECTION  function is called from READ_REFFILE with an open file */
/*   pointer <fp> and a string representing the appropriate <section>.  It   */
/*   will construct and return a <viewlist> and modify global variables:     */
/*   <treedata>, <treelist>, <has_edge_list>, and <vhdsrc_list>.             */
/*                                                                           */

function process_section(fp, section) 
   {
   declare linein,      /* single line read from file pointed to by <fp>     */
           token,       /* single word from a <linein>                       */
           edge,        /* part of token that represents valid entity name   */
           vertex_name, /* name of entity to go in <viewlist>, <these_edges> */
           these_edges, /* local list of edges, vertex to go into <treedata> */
           viewlist;    /* returned list of edges (with trailing nil)        */
   

   if (!member(section, list("initial", "preopt", "premap") ))
      vlEx.Throw2(vlEx.FAILURE, "Viewsyn", vlErrSev.Internal,
          sprintf("Illegal call to funtion 'process_section' in vsynmain.vs. "
                 +"Unknown section keyword '%s'", section)                  );


   while ( !null(linein = fgetline(fp)) && 
           !string_eq( linein, "\n")    &&
           !string_eq(substring(linein,0,1),"$")) 
      {
      if ((commapos := lindex(linein,',')) != FALSE) 
         {
         /* get the name of this entity */
         vertex_name = substring(linein,  0, commapos);

         /* mark entity as being present in appropriate view */

         if (null(viewlist))
            viewlist = list(vertex_name);
         if (! member(vertex_name, viewlist))
            viewlist = cons(vertex_name, viewlist);

         if (string_eq(section, "initial"))
            {
            /* see if it is in-scope */
            fname := string_append( work_dir, "/synth/", vertex_name );
            printf( "fname = '%s'\n", fname );
            printf( "vertex_name = '%s'\n", vertex_name );

            if (!null(vscript.vsInfo( fname )))
               {
               if (null(inscope_ent))
                  inscope_ent = list(vertex_name);
               if (member(vertex_name, inscope_ent) == FALSE)  
                  inscope_ent = cons(vertex_name, inscope_ent);
               }

            linein = substring( linein, commapos+2, 0);
            commapos = lindex(linein,',');

            /* get name of entity's VHDL source file */
            linein= substring( linein, commapos+2, 0);
            commapos = lindex(linein,',');
            srcname := substring(linein, 0, commapos );
            src_chunk := cons( vertex_name, srcname );

            vhdsrc_list = cons(src_chunk, vhdsrc_list);
            }                                        /* end $initial section */
           
         /* now get the dependencies of this entity */ 

         rcomma := rindex(linein,',');
         linein = substring(linein, rcomma+2,0 );
         token = " ";
         these_edges = list();

         while (!null(token))
            {
            linein = string_token( linein, &token, " ");
            if (! null(token) && (string_eq(token, "\n") == FALSE))
               {
               edge = string_copy(token);
               if (!rindex(edge,'\n') == FALSE)
                  edge = substring( edge, 0, rindex(edge,'\n'));
               }
            else  edge = nil;

            if (!null(edge))
               {
               if (rindex( edge, ':' ) != FALSE)      /* out-of-scope entity */
                  edge = substring( edge, rindex( edge, ':' ) + 1,
                                            string_length( edge )); 

               /* mark entity as being present in appropriate view */

               if (null(viewlist))            viewlist = list(edge);
               if (! member(edge, viewlist) ) viewlist = cons(edge, viewlist);
                  
               /* Add edge to edge list */
               if (string_eq(section, "initial"))
                  {
                  if (null(edge_list))       /* must edge_list end with nil? */
                        edge_list = list(edge);
                  else  edge_list = cons(edge, edge_list);
                  }
                         
               /* make edge list for this vertex */
               if (null(these_edges))
                  {
                  these_edges = list(vertex_name);
                  these_edges = cons(edge, these_edges);
                  }
               else
                  these_edges = cons(edge, these_edges);

               }  /* if !null(edge) */

            /* Add vertex to list of vertices with edges */
            if (null(has_edge_list))
               has_edge_list = list(vertex_name);
            else
               if (!member(vertex_name, has_edge_list) )  
                  has_edge_list = cons(vertex_name, has_edge_list);

            } /* end while !null(token) */
         
   
         /* put vertex at front of list, edges follow */
         these_edges = reverse_destructive(these_edges);

         if (!null(these_edges))
            {
            if (null(treedata))
               treedata = list(these_edges);
            else
               treedata = cons(these_edges, treedata);
            }

         } /* end if line has commas*/
   
      else 
         vlEx.Throw2( vlEx.FAILURE, "Viewsyn", vlErrSev.Warning,
             sprintf("Syntax error in '\$%s' section of design reference file "
                    +"'top.ref'.\n (missing comma)  : %s", section, linein) );

      } /* while */
   
   /* reverse order to match order .ref files were read */
   if (string_eq(section, "initial"))
       tree_list = reverse_destructive(treedata);

   copy_list(viewlist);
   }                                         /* end function PROCESS_SECTION */

/*---------------------------------------------------------------------------*/
/*                                                                           */
/*   FINDROOTS  function will find the root of a tree.  It is called with a  */
/*   single parameter, which is an edge list described above. It is called   */
/*   from  READ_REFFILE.                                                     */
/*                                                                           */
/*   The algorithm is this:  For each vertex that has an edge, see whether   */
/*   the vertex itself is in the edge list.  If not, it must be a root.      */
/*                                                                           */
/*   Note that the current root is placed by "vsyn" as the last root in each */
/*   section of the top.ref file, and is the LAST root in <rootList>.        */
/*                                                                           */

function findroots( edgelist )
   {
   declare local_rootList;

   tmp_vertex := copy_list( has_edge_list );

   while ( !null( tmp_vertex ))
      {
      if (! member( car(tmp_vertex ),( edgelist) ))
         {
         local_rootList = cons( car(tmp_vertex), local_rootList );
         }
      tmp_vertex := cdr( tmp_vertex );                  /* go to next vertex */
      }

    if (null(local_rootList)) 
       {
       if (null( initial_view ))
          vlEx.Throw2( vlEx.FAILURE, "Viewsyn", vlErrSev.Warning,
              sprintf("No entities found in design reference file 'top.ref' "
                     +"under:\n\n%s\n\n"
                     +"See 'synth.log' file for compilation errors.",
                      work_dir)  );

       return( cons( car( initial_view ), nil ) );
       }
    else
       return local_rootList;
    }                                              /* end function FINDROOTS */



function  updateLabelColor( v, icon_name ) {
declare labcol;

         if (string_eq( icon_name, "syn"))
            labcol = vgColor.LightBlue;
         else if (string_eq( icon_name, "opt"))
            labcol = vgColor.LightGreen;
         else if (string_eq( icon_name, "optwork"))
            labcol = vgColor.LightGreen;
         else if (string_eq( icon_name, "vhdlsrc"))
            labcol = vgColor.Red;
         else if (string_eq( icon_name, "vhdlcomp"))
            labcol = vgColor.Yellow;
         else if (string_eq( icon_name, "compwork"))
            labcol = vgColor.Yellow;
         else if (string_eq( icon_name, "compdis"))
            labcol = vgColor.Yellow;
         else if (string_eq( icon_name, "optdis"))
            labcol = vgColor.LightGreen;
         else
            error( "Unknown icon type in 'updateLabelColor':", icon_name );
         vcTree.VrtxModify(v, label_color <- labcol );
}

function update_1_icon( entity, icon, flag ) {
  
   /* convert integer status flag to string icon name */ 
   if ( ((flag & 1) > 0) || ((flag & 2) > 0) ) {
      if (string_eq( icon, "opt" ))
          icon_name := string_copy( "optdis" );
      else if (string_eq( icon, "map" ))
          icon_name := string_copy( "optdis" );
      else
          icon_name := string_copy( icon );
   }
   else
      icon_name := string_copy( icon );

   /* this is needed because there is no VRTX -> string conversion */
   foreach( v; vcTree.Vertices( tree_region )) {
      vertex_name := vcTree.VrtxGetItem(v);
      if (!null( vertex_name ))
          if (string_eq( vertex_name, entity ) == TRUE) {
              vcTree.VrtxChangeDisplayInfo( v, icon_name );
              updateLabelColor( v, icon_name );
              vcRegion.Refresh( tree_region, vcRegion.Area( tree_region ));
          }
   }
}

function show_hierctl( status_flag ) {

      if (( status_flag & 8 ) > 0) {
         if (amgdebug == 1) printf( "%d is flattened premap.\n", status_flag );
         return( 8 );
      }
      else if (( status_flag & 4 ) > 0) {
        if (amgdebug == 1) printf( "%d is flattened preopt.\n", status_flag );
         return( 4 );
      }
      else if (( status_flag & 2 ) > 0) {
         if (amgdebug == 1) printf( "%d is dissolved premap.\n", status_flag );
         return( 2 );
      }
      else if (( status_flag & 1 ) > 0) {
         if (amgdebug == 1) printf( "%d is dissolved preopt.\n", status_flag );
         return( 1 );
      }
      else return( 0 );
}

function show_icon_type( status_flag ) { 
     
   if (( status_flag & 128 ) > 0) {
      if (amgdebug == 1) printf( "%d is VHDL SRC.\n", status_flag );
      return( 128 );
   }
   else if (( status_flag & 64) > 0) {
      if (amgdebug == 1) printf( "%d is COMPILED.\n", status_flag );
      return( 64 );
   }
   else if (( status_flag & 32) > 0) {
      if (amgdebug == 1) printf( "%d is OPTIMIZED.\n", status_flag );
      return( 32 );
   }
   else {
      if (amgdebug == 1) printf( "%d is MAPPED.\n", status_flag );
      return( 0 );
   }
}




/*------------------- GUI Setup ---------------------------------------------*/


function start_gui()
     {
     load_m := list( "vsyn_itc.vs");                /* ITC-related functions */

     for (next := car(load_m) ; next != nil ; next=car(load_m) )
         {
         if (!null(path := vscript.vsGetini(next)) )                load(path);
         else
            vlEx.Throw2(vlEx.FAILURE, "Viewsyn", vlErrSev.Internal,
                sprintf("File >> %s << missing. (installation error)", next) );
         load_m = cdr(load_m);
         }

     vcFac.Create ("vsyntest", vscmVT);
     vcFac.Create ("vsynvhdL", vscmVT);
     vcFac.Create ("vsynVlst", vscmVT);
     vcFac.Create ("vsynDir", vscmVT);
     vcFac.Create ("vsynp2", vscmVT);
     vcFac.Create ("vsyn_3", vscmVT);
     vcFac.Create ("vsynvhdP", vscmVT);
     vcFac.Create ("vsynroot", vscmVT);
     vcFac.Create ("vsynhier", vscmVT);
     vcFac.Create ("vsynlevl", vscmVT);
     vcFac.Create ("vsyn_4", vscmVT);
     fac = vcFac.Create ("vsyn2", vscmVT);
     if (args == nil)
         path := "/import/viewtools/workview/v50/demo/";
     else {
         path := car (args);
         if (!string_eq (substring (path, 0, 1), "/"))
         path = path + "/";
     } /* else */


      /* Vhdldes is the string that will appear in the icon */
     region = vcRegion.Create1 ("ViewSyn 5.0.1 (5/12/95)", fac, path, nil);
     /* Create a main window with no "bindings" area */
     vcWin.SetProgramName ("ViewSyn");
     vdes2_win = vcWin.Create(region,vcWin.NoBindings);

     setup_itc();        /* see vsyn_itc.vs */
     }                                             /* end function START_GUI */

unique_filename( "/tmp" );

if( read_vdrawini() == 0 )
    start_gui();
