
/*---------------------------------------------------------------------------*/
/*                                                                           */
/*   vsynroot.vs       viewsynthesis 5.0           24 January 1995           */
/*                     Copyrite January 1995, Viewlogic Systems, Inc.        */
/*   version 1.7       Phil Labee                                            */
/*                                                                           */
/*   This module will build a dialog box which will display the working      */
/*   directory and present an exclusive picklist of root module names from   */
/*   the "top.ref" file contained in the global variable <rootList>.         */
/*                                                                           */
/*   This module is loaded as a package by vcFac.Create.                     */
/*                                                                           */

declare table,          /* table of widgets returned by the _Create method   */
        root_plist,     /* picklist of design root modules from <rootList>   */
        root_scroll,    /* scrolling picklist containing <root_plist>        */
        pick_string;    /* command line to get value from picklist for _Get  */


function make_root_list() 
   {
   if (null(rootList))
      vlEx.Throw2( vlEx.FAILURE, "Viewsyn", vlErrSev.Warning,
          "No root entities found in design reference file 'top.ref'" );


   local_roots := list();

   foreach (item; vscript.list_iter(rootList) )
       {
       local_roots  = cons( cons(item, item), local_roots  );
       } 

   reverse_destructive( local_roots );
   }                                          /* end function MAKE_ROOT_LIST */



function rootpickdata( data, on_off )  vcCmdline.Set( pick_string, data );


function _Create(name,region)
   {
   function Label(text) vcRegion.Create(text, vcStaticText.fac, text);

   root_plist = vcRegion.Create( "rootplist", vcPicklist.fac, make_root_list(),
                                 will_scroll <- TRUE  );

   root_scroll = vcPicklist.Scroll( "rootscroll", root_plist, 1,5,0);
   vcPicklist.Notify ( root_scroll, rootpickdata );

   pick_string = vcRegion.Create ("root", vcCmdline.fac,"", max_width <- 10);

   table = vcTable.Create("", 5, 2);
   vcTable.Row( table, 0, vcTable.Border.Invisible, 12,20,30,
                          vgAlign.UpperRight                );
   vcTable.Row( table, 1, vcTable.Border.Invisible, 12,20,30,
                          vgAlign.UpperLeft                 );

   vcTable.Set(table, 0,0, Label("Working Directory: ") );
   vcTable.Set(table, 0,1, Label(work_dir)              );
 
   vcTable.Set(table, 1,0, Label("Compiled Designs: ")  );
   vcTable.Set(table, 1,1, root_scroll);

   vcTable.Set(table, 2,1, pick_string);

   vcRegion.AddChild( region, table);
   vcWin.ClearStatus( vdes2_win );
   vcWin.AddStatus(vdes2_win, "Select a design to view." );
   table;
   }                                                   /* end _CREATE method */


function _Get(table, region, ts)  vcRegion.Get(pick_string, ts);
