/* ---------------------------------------------------------------------- *\
 * Module -- 
 *
 *      Facility:      Vtime/VTM dialog facility
 *
 *      Environment:   All, Powerview 5.2
 *
 *      Author:        Mani Alagappan,  Nov 1994
 *                     Jeff Hare
 *
 *      Description:   Facility to collect VTM netlister specific data
 *       
 *
 *      Copyright (c) 1993 by Viewlogic Systems, Inc.
 */
/* ---------------------------------------------------------------------- */

function label(str) vcRegion.Create1(str,vcLabel.fac,str,nil);

/*===========================================================================*/
/*==                      _ G e t                                          ==*/
/*===========================================================================*/
/*\Function _Get  -- The _Get data method for this facility
  
  DESCRIPTION
       
  RETURNS
       
  EXAMPLE
       
  CAUTION
       
  SEE ALSO
       
*/
function _Get(d,r,type)
	foo := Data2Str(d,r);   



/* -------------------------------------------------- *\
 * The following options are used for various types of
 * trace reports and modes.
\* -------------------------------------------------- */

SRC := "src";
PIN := "pin";
CTL := "ctl";
MOD := "mod";
IDD := "idd";

SRC_OFF := " -ns";
PIN_OFF := " -np";
CTL_OFF := " -nc";
MOD_OFF := " -nm";
IDD_OFF := " -ni";

SRCstr := ".src";
PINstr := ".pin";
CTLstr := ".ctl";
MODstr := ".mod";
IDDstr := ".idd";
/*===========================================================================*/
/*==                      _ C r e a t e                                    ==*/
/*===========================================================================*/
/*\Function _Get  -- The _Create method of the facility vtimevtm
  
  DESCRIPTION
       
  RETURNS
       
  EXAMPLE
       
  CAUTION
       
  SEE ALSO
*/       

function _Create(Defaults, TopRegion)
{
   declare LevelRgn;                    
   declare DtbRgn;                      
   declare CompidRgn;
   declare PinidRgn;
   declare ModidRgn;
   declare PrimFileRgn;
   declare ModMapRgn;
   declare ArgsRgn;
   declare OptionsRgn;


   /*====================================================*/
   /*==       U p d a t e V t m G u i                  ==*/
   /*====================================================*/
   /*\Function UpdateVtmGui  -- Refresh using settings provided with
     
     DESCRIPTION
     
   */
   function UpdateVtmGui(s){
      if (isstring (settings.Level))      vcCmdline.Set (LevelRgn,settings.Level);
      if (isstring (settings.Dtbfile))    vcCmdline.Set (DtbRgn,settings.Dtbfile);
      if (isstring (settings.Compid))     vcCmdline.Set (CompidRgn,settings.Compid);
      if (isstring (settings.Pinid))      vcCmdline.Set (PinidRgn,settings.Pinid);
      if (isstring (settings.Modid))      vcCmdline.Set (ModidRgn,settings.Modid);
      if (isstring (settings.Primfile))   vcCmdline.Set (PrimFileRgn,settings.Primfile);
      if (isstring (settings.Modmapfile)) vcCmdline.Set (ModMapRgn,settings.Modmapfile);
      if (isstring (settings.Args))       vcCmdline.Set (ArgsRgn,settings.Args);
      if (string_eqi (settings.Src, "") == TRUE)
         vcPicklist.SetByString (OptionsRgn, SRCstr);
      if (string_eqi (settings.Pin, "") == TRUE)
         vcPicklist.SetByString (OptionsRgn, PINstr);
      if (string_eqi (settings.Mod, "") == TRUE)
         vcPicklist.SetByString (OptionsRgn, MODstr);
      if (string_eqi (settings.Ctl, "") == TRUE)
         vcPicklist.SetByString (OptionsRgn, CTLstr);
      if (string_eqi (settings.Idd, "") == TRUE)
         vcPicklist.SetByString (OptionsRgn, IDDstr);         
   }

   /*====================================================*/
   /*==       U p d a t e M e t h o d s ...            ==*/
   /*====================================================*/
   /*\Function UpdateMethods... - Update functions for various editor fields.
     
     DESCRIPTION
     
   */   
   function UpdateLevel(str)
      settings.Level = str;
   function UpdateDtb(str)
      settings.Dtbfile = str;
   function UpdateCompid(str)
      settings.Compid = str;
   function UpdatePinid(str)
      settings.Pinid = str;
   function UpdateModid(str)
      settings.Modid = str;
   function UpdatePrimfile(str)
      settings.Primfile = str;
   function UpdateModmapfile(str)
      settings.Modmapfile = str;
   function UpdateArgs(str)
      settings.Args = str;

   /*====================================================*/
   /*==       B u i l d V t m G u i                ==*/
   /*====================================================*/
   /*\Function BuildVtmGui  -- Establish the Dialog box
     
     DESCRIPTION
     
     RETURNS
     
   */
   function BuildVtmGui()
   {  
      LevelRgn    =  vcRegion.Create("level",vcCmdline.fac, "", 
                                  case <- vlPref.Val (prefs, "case"));
      LevelTitle := label ("Level Attribute(s): ");
      LevelTable := vcRegion.Create("",vcBorder.fac,
                                    vcTable.Make ("",1,2,
                                                  LevelTitle, LevelRgn));
      vcCmdline.CallOnChange (LevelRgn,UpdateLevel);

      DtbRgn    = vcRegion.Create("dtb", vcCmdline.fac, "", 
                                case <- vlPref.Val (prefs, "case"));
      DtbRgn     = vcRegion.Create ("dtb",vcFilePop.fac, "", filter <- "*.dtb");
      DtbTitle  := label ("ASIC DTB File(s): ");
      DtbTable  := vcRegion.Create("",vcBorder.fac,
                                   vcTable.Make ("",1,3,
                                                 DtbTitle, DtbRgn));
      /*vcRegion.Create("",vcFilePop.fac,"")));*/
      vcCmdline.CallOnChange (DtbRgn,UpdateDtb);

      CompidRgn    = vcRegion.Create("compid", vcCmdline.fac, "", 
                                  case <- vlPref.Val (prefs, "case"));
      CompTitle := label ("Comp ID Attribute:   ");
      CompTable := vcRegion.Create("",vcBorder.fac,
                                   vcTable.Make ("",1,2,
                                                 CompTitle, CompidRgn));
      vcCmdline.CallOnChange (CompidRgn,UpdateCompid);

      PinidRgn    = vcRegion.Create("pinid", vcCmdline.fac, "", 
                                  case <- vlPref.Val (prefs, "case"));
      PinTitle  := label ("Pin ID Attribute:    ");
      PinTable  := vcRegion.Create("",vcBorder.fac,
                                   vcTable.Make ("",1,2,
                                                 PinTitle, PinidRgn));
      vcCmdline.CallOnChange (PinidRgn,UpdatePinid);

      ModidRgn    = vcRegion.Create("modid", vcCmdline.fac, "", 
                                  case <- vlPref.Val (prefs, "case"));
      ModTitle     := label ("Model ID Attribute:  ");
      ModTable     := vcRegion.Create("",vcBorder.fac,
                                      vcTable.Make ("",1,2,
                                                    ModTitle, ModidRgn));
      vcCmdline.CallOnChange (ModidRgn,UpdateModid);

      PrimFileRgn    = vcRegion.Create("prim", vcFilePop.fac, "");
      PrimTitle  := label ("Primitives File:      ");
      PrimTable  := vcRegion.Create("",vcBorder.fac,
                                    vcTable.Make ("",1,2,
                                                  PrimTitle, PrimFileRgn));
      vcCmdline.CallOnChange (PrimFileRgn,UpdatePrimfile);

      ModMapRgn    = vcRegion.Create("modmap", vcFilePop.fac, "");
      ModTitle  := label ("Model Mapping File: ");
      ModmapTable := vcRegion.Create("",vcBorder.fac,
                                     vcTable.Make ("",1,2,
                                                   ModTitle, ModMapRgn));
      vcCmdline.CallOnChange (ModMapRgn,UpdateModmapfile);

      ArgsRgn    = vcRegion.Create("args", vcCmdline.fac, "");
      ArgsTitle     := label ("Other VTM/MMP args: ");
      ArgsTable     := vcRegion.Create("",vcBorder.fac,
                                       vcTable.Make ("",1,2,
                                                     ArgsTitle, ArgsRgn));
      vcCmdline.CallOnChange (ArgsRgn,UpdateArgs);

      /* Build the non-exclusive picklist allowing the user */
      /* the choice to not create certain output files      */
      
      SRC_OPT := cons (SRCstr, cons(SRC, set_option));
      PIN_OPT := cons (PINstr, cons(PIN, set_option));
      CTL_OPT := cons (CTLstr, cons(CTL, set_option));
      MOD_OPT := cons (MODstr, cons(MOD, set_option));
      IDD_OPT := cons (IDDstr, cons(IDD, set_option));

      option_types := list (list (SRC_OPT, PIN_OPT, CTL_OPT, 
                                  MOD_OPT, IDD_OPT));

      OptionTypeTitleRgn  := vcRegion.Create("title", vcLabel.fac, 
                                             "Generate These Output");
      OptionsRgn           = vcRegion.Create("Option", 
                                             vcPicklist.fac,
                                             option_types,
                                             exclusive <- FALSE);
      vcPicklist.Notify( OptionsRgn, CallOnPick);
      OptionsTable :=  vcRegion.Create("", vcBorder.fac,
                                       vcTable.Make("Options", 1, 2, 
                                                    OptionTypeTitleRgn, OptionsRgn));

      /*----------------------------------------*\
            Layout the Trace Analysis Window
      \*----------------------------------------*/
      LayoutRgn :=  vcRegion.Create("OkQuit", vcMargin.fac,
                                    tt := vcTable.Make("TraceArgEditor", 9, 1,
                                                       LevelTable,
                                                       DtbTable,
                                                       CompTable,
                                                       PinTable,
                                                       ModTable,
                                                       PrimTable,
                                                       ModmapTable,
                                                       ArgsTable,
                                                       OptionsTable));
      
      LayoutRgn;
   } /* BuildTraceGui */

   /*=====================================================*/
   /*==          C a l l O n P i c k 1                  ==*/
   /*=====================================================*/
   /*\Function CallOnPick  -- Control dialog presentation with args
     
     DESCRIPTION
          This is similar to the CallOnPick() except the notify
          function iscalled with arguments.
     RETURNS
     
   */
   function CallOnPick(data, on_or_off) {
      if (isprocedure(cdr(data))) {
         (cdr(data))(car (data),on_or_off);
      }
      else 
         vlEx.Throw2(vlEx.FAILURE,"vtime",vlErrSev.Error,
                     "No action specified for this pick in tracedlg.BuildTraceGui()");
   } /* CallOnPick */


   /*=====================================================*/
   /*==               s e t _ o p t i o n s             ==*/
   /*=====================================================*/
   function set_option(data,onoff){
      if (onoff == vlOnOff.Off){
         if (string_eqi (data,SRC))
            settings.Src = SRC_OFF;
         else if (string_eqi (data,PIN))
            settings.Pin = PIN_OFF;
         else if (string_eqi (data,MOD))
            settings.Mod = MOD_OFF;
         else if (string_eqi (data,CTL))
            settings.Ctl = CTL_OFF;
         else if (string_eqi (data,IDD))
            settings.Idd = IDD_OFF;
      }
      else{
         if (string_eqi (data,SRC))
            settings.Src = "";
         else if (string_eqi (data,PIN))
            settings.Pin = "";
         else if (string_eqi (data,MOD))
            settings.Mod = "";
         else if (string_eqi (data,CTL))
            settings.Ctl = "";
         else if (string_eqi (data,IDD))
            settings.Idd = "";
      }
   }


   if (Defaults == nil) 
      settings := GetDefaultSettings();

   else 
      settings := Str2Data(Defaults);
   
   VtmRgn := BuildVtmGui ();
   UpdateVtmGui (settings);

   vcRegion.AddChild (TopRegion, VtmRgn);

   settings;
}
 
/*===========================================================================*/
/*==                      D a t a 2 S t r                                  ==*/
/*===========================================================================*/
/*\Function Data2Str  -- Convert a settings structure to a string
  
  DESCRIPTION
       
  RETURNS
       
  EXAMPLE
       
  CAUTION
       
  SEE ALSO
       
*/
function Data2Str(s,r)
{
   declare cmd;

   cmd = " " + s.Block + " -ca " + s.Case + " -li " + s.Liblst;
   
   if (string_eqi (s.Level, "") != TRUE)
      cmd = cmd + " -le " + s.Level;
   if (string_eqi (s.Dtbfile, "") != TRUE)
      cmd = cmd + " -dt " + s.Dtbfile;
   if (string_eqi (s.Compid, "") != TRUE)
      cmd = cmd + " -ia " + s.Compid;
   if (string_eqi (s.Pinid, "") != TRUE)
      cmd = cmd + " -pa " + s.Pinid;
   if (string_eqi (s.Modid, "") != TRUE)
      cmd = cmd + " -ma " + s.Modid;
   if (string_eqi (s.Primfile, "") != TRUE)
      cmd = cmd + " -pr " + s.Primfile;
   if (string_eqi (s.Modmapfile, "") != TRUE)
      cmd = cmd + " -mm " + s.Modmapfile;
   if (string_eqi (s.Args, "") != TRUE)
      cmd = cmd + " " + s.Args;
   if (string_eqi (s.Src, "") == FALSE)
      cmd = cmd + SRC_OFF;
   if (string_eqi (s.Pin, "") == FALSE)
      cmd = cmd + PIN_OFF;
   if (string_eqi (s.Mod, "") == FALSE)
      cmd = cmd + MOD_OFF;
   if (string_eqi (s.Ctl, "") == FALSE)
      cmd = cmd + CTL_OFF;
   if (string_eqi (s.Idd, "") == FALSE)
      cmd = cmd + IDD_OFF;

   cmd;
}

/*===========================================================================*/
/*==                       S t r 2 D a t a                                ==*/
/*===========================================================================*/
/*\Function Str2Data  -- Convert a string to a settings structure
  
  DESCRIPTION
       
  RETURNS
       
  EXAMPLE
       
  CAUTION
       
  SEE ALSO
       
*/
function Str2Data(str)
{
   cmdline := nil;
   i       := 0;

   foreach(token; string_loop(str," ")) {
      cmdline = cons(token,cmdline);
      ++i;
   }

   cmdline = reverse (cmdline);
   s := GetDefaultSettings();

   if (i != 0){
      for (j := 0; j < i; ++j){
         if (string_eqi (cmdline[j], "-le") == TRUE)
            s.Level = cmdline[++j];
         else if (string_eqi (cmdline[j], "-dt") == TRUE)
            s.Dtbfile = cmdline[++j];
         else if (string_eqi (cmdline[j], "-ia") == TRUE)
            s.Compid = cmdline[++j];         
         else if (string_eqi (cmdline[j], "-pa") == TRUE)
            s.Pinid = cmdline[++j];
         else if (string_eqi (cmdline[j], "-ma") == TRUE)
            s.Modid= cmdline[++j];
         else if (string_eqi (cmdline[j], "-pr") == TRUE)
            s.Primfile = cmdline[++j];
         else if (string_eqi (cmdline[j], "-mm") == TRUE)
            s.Modmapfile = cmdline[++j];
         else if (string_eqi (cmdline[j], "-ns") == TRUE)
            s.Src = SRC_OFF;
         else if (string_eqi (cmdline[j], "-np") == TRUE)
            s.Pin = PIN_OFF;
         else if (string_eqi (cmdline[j], "-nm") == TRUE)
            s.Mod = MOD_OFF;
         else if (string_eqi (cmdline[j], "-nc") == TRUE)
            s.Ctl = CTL_OFF;
         else if (string_eqi (cmdline[j], "-ni") == TRUE)
            s.Idd = IDD_OFF;
         else if (string_eqi (cmdline[j], "-ca") == TRUE)
            s.Case = cmdline[++j];
         else if (string_eqi (cmdline[j], "-li") == TRUE)
            s.Liblst = cmdline[++j];
         else{
            if (string_eqi (s.Block, "") == TRUE)
               s.Block = cmdline[j];
            else
               s.Args = s.Args +  " " + cmdline[j];
         }
      }
      s;      
   }
}
  
/*===========================================================================*/
/*==           G e t D e f a u l t S e t t i n g s                         ==*/
/*===========================================================================*/
/*\Function GetDefaultSettings  -- 
  
  DESCRIPTION
       
  RETURNS
       
  EXAMPLE
       
  CAUTION
       
  SEE ALSO
       
*/
function GetDefaultSettings() {
   struct {
      Level     = "STD";
      Dtbfile   = "";
      Compid    = "";
      Pinid     = "";
      Modid     = "";
      Primfile  = "";
      Modmapfile="";
      Args      ="";
      Options   = "";
      Src       = "";
      Pin       = "";
      Ctl       = "";
      Mod       = "";
      Idd       = "";
      Liblst    = "";
      Case      = "";      
      Block     = ""
   } settings;
} /* GetDefaultSettings */


vlPref.Replace (prefs, "case", vcCmdlineCaseVT,
            "Fold character case to Upper, Lower or Either (mixed)",
            vcCmdlineCase.Upper);
