/* ---------------------------------------------------------------------- *\
 * Module -- vtvutils.vs
 *
 *      Facility:      Viewtime
 *
 *      Environment:   sun4, pv 5.2
 *
 *      Author:        Mani Alagappan,  Nov 1993
 *
 *      Description:   Viewscript macros, utilities for facility
 *
 *      Copyright (c) 1993 by Viewlogic Systems, Inc.
 */
/* ---------------------------------------------------------------------- *\
Modification History
$Log:	vtvutils.vs,v $
Revision 1.1  93/11/05  11:16:44  mania
Viewtime facility written

\* ---------------------------------------------------------------------- */

STICKY   := vcWv.Sticky;
CONSTANT := vcWv.Constant;
DYNAMIC  := vcWv.Dynamic;

YES      := vlYesNo.Yes;
NO       := vlYesNo.No;

/* key bindings */

/*  Commented out the following command since it created a warning
    indicating that the command already existed...
 run_cmd := vcWv.Cmd (vcWin.fac, vcWin.show_cmdline, "cmdline");
*/
function bindcmd(key, command) vcBind.set(bindings, key, command);
bindcmd ('\_\^C', vcWin.wclose);
/*bindcmd (' ',   run_cmd);*/

/* viewscript macros */

function FacilityTitle() "ViewTime 1.9.0(proto) ";
function label(str) vcRegion.Create1(str,vcLabel.fac,str,nil);
function cmdline1(title, default, w) 
    vcRegion.Create1(title, vcCmdline.fac, default,
                     list(cons(`max_width, w),
                          cons(`width, 8),
                          cons(`macro_on, TRUE),
                          cons(`max_size, 64)));

function entrybox(prompt, cmdline)
{
    text_entry := vcTable.Create ("entrybox", 1, 2);
    vcTable.Add (text_entry, label (prompt));
    vcTable.Add (text_entry, cmdline);
    text_entry;
} /* function entrybox */

function cmdline2(prompt,defval,width)
{
    t := vcTable.Create("", 1, 2);
    vcTable.Add (t, label (prompt));
    vcTable.Add (t,cmdline1 (prompt, defval, width));
    t;
} /* function cmdline2 */
 
function cmdline(default, onreturn)
{
    cmd_line := vcRegion.Create1 ("", vcCmdline.fac, default, 
                                  list (cons (`width, 30)));
    vcCmdline.CallOnReturn (cmd_line, onreturn);
    cmd_line;
} /* function cmdline */

/* status msg display */
function display_msg(w,m)
{
    vcWin.ClearStatus (w);
    vcWin.AddStatus (w, m);
}

function status_msg(event, msg)
{
    win := vcEvent.Window (event);
    display_msg (win, msg);
} /* function status_msg */

function add_status(w, e, msg)
{
    if (e != nil)
        status_msg (e, msg);
    else if (w != nil)
        display_msg (w,msg);
        
} /* function add_status */

function win2event(w)
{
    r := vcWin.Region (w);
    print (r);
    e := vcEvent.Create (0, 0, ' ', "", w, r, nil);
}

function region2event(r)
{
    w := vcRegion.Window (r);
    e := vcEvent.Create (0, 0, ' ', "", w, r, nil);
}

function data2event(d)
{
    r := vtmGetSession (d);
    region2event (r);
}

