/*
 * $Revision: 1.3.5.1 $
 *
 * Example of a command which requires confirmation.
 */

define_enum ("SafeOrDangerousVT", list ("Safe", "Dangerous"));

function doit(data, event, arg)
{
    rgn := vcRegion.Create ("blah", vcLabel.fac, "Did it!");
    vcRegion.Font (rgn, vgFont.largeb);
    margin := vcRegion.Create ("margin", vcMargin.fac, rgn);
    vcWin.Create (margin, vcWin.NoCmdline + vcWin.NoBindings + vcWin.NoStatus);

} /* doit */

function confirm_doit(data, event, arg)
    if (arg == SafeOrDangerous.Safe)
        FALSE;
    else
"You have selected a DANGEROUS command,
so you better be damn sure you want to do it.
By the way, mouse coords == " + sprintf ("(%d,%d)", vcEvent.X (event),
                                         vcEvent.Y (event)) + "

OK to do it?";

cmd := vcWv.CmdWithConfirm (vcWin.fac, doit, confirm_doit, TRUE,
                            "doit", "Do It",
                            vcWv.Param ("", SafeOrDangerousVT, vcWv.Sticky,
                                        SafeOrDangerous.Safe));

rgnButnRow := vcRegion.Create ("Example", vcButnRow.fac,
                               list (list ("OK", "Press here to do it",
                                           cmd, nil)));
vcWin.Create (rgnButnRow, vcWin.NoCmdline + vcWin.NoBindings + vcWin.NoStatus);
