/*
 * $Id: dragger.vs,v 1.1.2.1 1995/01/24 21:54:37 cway Stab $
 * 
 * drag&drop demo: drag origin facility
 */

/* facility initialization data is the name of a metafile */
function _Create (i, rgn) {
   icon := vcRegion.Create ("", vcIcon.fac, i + ".mf",
                      size <- vgSize.Create (100, 100, 100, 100, 100, 100));
   vcRegion.AddChild (rgn, icon);
   i;
}

/* to specify a call-on-done action, we can use nothing, a function,
 * or a command. Here,
 * a command is used to make the call-on-done action recordable.
 * note that things like prompt & default values are never used */
function dragdone (d, ev, dat, flg)
    printf ("did drop of %s? %s\n", dat, flg);
DoneCmd := vcWv.Cmd (fac, dragdone, "Done", "Done",
      vcWv.Param ("Yamit", dragdemoVT, vcWv.Sticky, vcWv.NoDefault),
      vcWv.Param ("Yamooz", vscmVT, vcWv.Sticky, TRUE));

/* we start the drag here */
function do_drag (i, ev) {
    /* the icon name, and the call-on-done action are optional. */
    /* the region is required iff the call-on-done is a command */
    dragdata := convert (dragdemoVT, i);
    dg := vcWv.StartDrag 
          (wv, dragdata,  i, vcEvent.Region (ev), DoneCmd);
    vcWv.ModifyDrag (dg, erase_color <- vgColor.Yellow);
}

DragCmd := vcWv.Cmd (fac, do_drag, "Drag");
vcBind.Set (bindings, '\leftdown', DragCmd);
vcBind.Set (bindings, '\middledown', DragCmd);




