/*
 * $Revision: 1.1.1.1 $
 *
 * vcNotebook demo - deom of the vcNotebook facility
 */

/* the notebook region */
note := vcRegion.Create ("notebook", vcNotebook.fac, vgAlign.UpperCenter,
                       macro_on <- TRUE);

/* now we stick all of the regions, with labels, into the notebook */
r1 := vcRegion.Create ("", vcIcon.fac, "escher");
vcNotebook.AddEntry (note, "Escher", r1);

color_box := vcRegion.Create ("", vcRadioBox.fac, vgColor.Red,
        data <- list (list ("Red", vgColor.Red), 
                      list ("Blue", vgColor.Blue),
                      list ("Yellow", vgColor.Yellow),
                      list ("Green", vgColor.Green)));

fill_box := vcRegion.Create ("", vcRadioBox.fac, vgFill.Solid,
                  data <- list (list ("Solid", vgFill.Solid),
                                list ("Grey",  vgFill.Grey50),
                                list ("Diagonal", vgFill.Diagup2),
                                list ("X", vgFill.X1),
                                list ("Grid", vgFill.Grid2)));
r2 := vcTable.Make ("", 1, 2, color_box, fill_box);
vcNotebook.AddEntry (note, "Selection", r2);

r3 := vcRegion.Create ("", vcCanvas.fac, nil);

color := vgColor.Red;
fill := vgFill.Solid;

vcCanvas.RefreshProc (r3, func (ev) {
    r := vcEvent.Region (ev);
    vp := vcRegion.Viewport (r, vgRect.Create (0, 0, 100, 100),
                                   vgU.OneToOne);

    vgU.Color (vp, color);
    vgU.Fillstyle (vp, fill);
    vgU.Box (vp, vgRect.Create (0, 0, 100, 100));
});

vcNotebook.AddEntry (note, "Color", r3);

vcRadioBox.NotifyOnChange (color_box, 
      func (ev, val) {
          color = val;
          vcRegion.QueueForRefresh (r3);
      });
vcRadioBox.NotifyOnChange (fill_box, 
      func (ev, val) {
          fill = val;
          vcRegion.QueueForRefresh (r3);
      });

/* note that we can use vcNoteTab functions with vcNotebook regions */
function enable(ev, flag)
    vcNoteTab.EnableByString (note, "Selection", flag);
tog := vcRegion.Create ("toggle", vcToggleButton.fac, TRUE, 
                                  action <- enable,
                                  label <- "Enabled",
                                  macro_on <- TRUE);

b := vcRegion.Create ("", vcBorder.fac, tog, 
                         width <- 6,
                         bottom_space <- 10, top_space <- 10,
                         left_space <- 10, right_space <- 10,
                         border_style <- vcBorderStyle.ShadowIn);
b  = vcRegion.Create ("", vcBorder.fac, b, 
                         width <- 4,
                         bottom_space <- 10, top_space <- 10,
                         left_space <- 10, right_space <- 10,
                         border_style <- vcBorderStyle.EtchedOut);
b  = vcRegion.Create ("", vcBorder.fac, b, 
                         width <- 8,
                         bottom_space <- 10, top_space <- 10,
                         left_space <- 10, right_space <- 10,
                         border_style <- vcBorderStyle.ShadowOut);
b  = vcRegion.Create ("", vcBorder.fac, b, 
                         width <- 2,
                         bottom_space <- 15, top_space <- 15,
                         left_space <- 15, right_space <- 15,
                         border_style <- vcBorderStyle.EtchedIn);

/* note the use of text formatting: \011 produces italics */
vcNotebook.AddEntry (note, "\011Enable", b);
vcWin.Create (note);

