/* $Id: rundnd.vs,v 1.1.2.1 1995/01/24 21:54:40 cway Stab $
 *
 * driver for the drag&drop demo
 *
 */ 

/* we could just use vlStringVT for the drags.
 * However, this allows the dropsite to select only the drags it wants
 */
define_string ("dragdemoVT");

vcFac.Create ("dragger", vscmVT);
vcFac.Create ("dropper", vscmVT);

/* create a window of drag origins */
a := vcRegion.Create ("m", dragger.fac, "a", macro_on <- TRUE);
b := vcRegion.Create ("n", dragger.fac, "b", macro_on <- TRUE);
c := vcRegion.Create ("o", dragger.fac, "c", macro_on <- TRUE);

t := vcTable.Make ("draggers", 3, 1, a, b, c);

w1 := vcWin.Create (t,vcWin.NoBindings + vcWin.NoStatus);

/* create a window of dropsites */
r := vcRegion.Create ("red", dropper.fac, vgColor.Red, macro_on <- TRUE);
y := vcRegion.Create ("yellow", dropper.fac, vgColor.Yellow, macro_on <- TRUE);
g := vcRegion.Create ("green", dropper.fac, vgColor.Green, macro_on <- TRUE);

t2 := vcTable.Make ("droppers", 3, 1, r, y, g);

w2 := vcWin.Create (t2, vcWin.NoBindings + vcWin.NoStatus);

/* these functions allow inter-process drag&drop */

/* this allows us to drag onto foreign dropsites */ 
/* this should be called once when the executable initializes */
vcWv.InquireForeignDropsites (wv);

/* this allows foriegn drags to drop onto dropsites within this window */
/* this should be called once for each window containing dropsites
 * that should accept foreign drops. In can be undone via
 * vcWv.UnregisterDropWindow */
vcWv.RegisterDropWindow (wv, w2);

