/*
 *  $Revision: 1.5.6.1 $
 *
 *  Temperature demo -- uses two scalebars, hooked together by notification
 *  routines to make sure the same temperature is visible in both scales.
 *
 *  Copyright (c) 1992 by Viewlogic Systems, Inc.
 */

fahrenheit := vcRegion.Create ("Fahrenheit", vcScalebar.fac, 68,
                               min <- 32, max <- 212,
                               increment <- .5,
                               macro_on  <- TRUE,
                               width     <- 100);
celsius := vcRegion.Create ("Celsius", vcScalebar.fac, 20,
                            min <- 0, max <- 100,
                            increment <- .5,
                            macro_on  <- TRUE,
                            width     <- 100);

function change_fahrenheit(f)
    vcScalebar.Set (celsius, (f - 32) * 5/9);

function change_celsius(c)
    vcScalebar.Set (fahrenheit, c * 9/5 + 32);

vcScale.NotifyOnChange (fahrenheit, change_fahrenheit);
vcScale.NotifyOnChange (celsius, change_celsius);

t := vcTable.Create ("Temperature", 2, 2);
vcTable.Add (t, vcRegion.Create ("f", vcLabel.fac, "Fahrenheit"));
vcTable.Add (t, fahrenheit);

vcTable.Add (t, vcRegion.Create ("c", vcLabel.fac, "Celsius"));
vcTable.Add (t, celsius);

vcWin.Create (t);
