entity add_32 is 
  port (op1, op2  : in vlbit_1d(0 to 31);
        carry_in  : in vlbit;
        sum       : out vlbit_1d(0 to 31);
        carry_out : out vlbit);
end add_32;



architecture structural of add_32 is

signal  sa31, sa27, sa23, sa19, sa15, sa11, sa7, sa3 : vlbit_1d(0 to 3);
signal  sb31, sb27, sb23, sb19, sb15, sb11, sb7, sb3 : vlbit_1d(0 to 3);
signal  ss31, ss27, ss23, ss19, ss15, ss11, ss7, ss3 : vlbit_1d(0 to 3);
signal  sc31, sc27, sc23, sc19, sc15, sc11, sc7      : vlbit;
signal  sumI : vlbit_1d(0 to 31);
component foadder
    port (av ,bv : in vlbit_1d(0 to 3);
          fci   : in vlbit;
          sv    : out vlbit_1d(0 to 3);
          fco   : out vlbit);
end component;




begin

    sumI <= (ss3 & ss7 & ss11 & ss15 & ss19 & ss23 & ss27 & ss31);
    sum  <= sumI;

    sa31 <= op1(28 to 31);
    sa27 <= op1(24 to 27);
    sa23 <= op1(20 to 23);
    sa19 <= op1(16 to 19);
    sa15 <= op1(12 to 15);
    sa11 <= op1(8 to 11);
    sa7  <= op1(4 to 7);
    sa3  <= op1(0 to 3);

    sb31 <= op2(28 to 31);
    sb27 <= op2(24 to 27);
    sb23 <= op2(20 to 23);
    sb19 <= op2(16 to 19);
    sb15 <= op2(12 to 15);
    sb11 <= op2(8 to 11);
    sb7  <= op2(4 to 7);
    sb3  <= op2(0 to 3);

    add_31_28 : foadder 
        port map (sa31, sb31, carry_in, ss31, sc31);

    add_27_24 : foadder
        port map (sa27, sb27, sc31, ss27, sc27);

    add_23_20 : foadder
        port map (sa23, sb23, sc27, ss23, sc23);

    add_19_16 : foadder
        port map (sa19, sb19, sc23, ss19, sc19);

    add_15_12 : foadder
        port map (sa15, sb15, sc19, ss15, sc15);

    add_11_8  : foadder
        port map (sa11, sb11, sc15, ss11, sc11);

    add_7_4   : foadder
        port map (sa7, sb7, sc11, ss7, sc7);

    add_3_0   : foadder
        port map (sa3, sb3, sc7, ss3, carry_out);


end;
